using System;
using NetRuntimeSystem = System;
using System.ComponentModel;
using NetOffice.Attributes;

namespace NetOffice.MSProjectApi
{
	/// <summary>
	/// DispatchInterface _MSProject 
	/// SupportByVersion MSProject, 11,12,14
	/// </summary>
	[SupportByVersion("MSProject", 11,12,14)]
	[EntityType(EntityType.IsDispatchInterface), BaseType]
 	public class _MSProject : COMObject
	{
		#pragma warning disable

		#region Type Information

		/// <summary>
		/// Instance Type
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Advanced), Browsable(false), Category("NetOffice"), CoreOverridden]
		public override Type InstanceType
		{
			get
			{
				return LateBindingApiWrapperType;
			}
		}

        private static Type _type;

		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
        public static Type LateBindingApiWrapperType
        {
            get
            {
                if (null == _type)
                    _type = typeof(_MSProject);
                return _type;
            }
        }
        
        #endregion
        
		#region Ctor

		/// <param name="factory">current used factory core</param>
		/// <param name="parentObject">object there has created the proxy</param>
		/// <param name="proxyShare">proxy share instead if com proxy</param>
		public _MSProject(Core factory, ICOMObject parentObject, COMProxyShare proxyShare) : base(factory, parentObject, proxyShare)
		{
		}

		///<param name="factory">current used factory core</param>
		///<param name="parentObject">object there has created the proxy</param>
        ///<param name="comProxy">inner wrapped COM proxy</param>
		public _MSProject(Core factory, ICOMObject parentObject, object comProxy) : base(factory, parentObject, comProxy)
		{
			
		}

        ///<param name="parentObject">object there has created the proxy</param>
        ///<param name="comProxy">inner wrapped COM proxy</param>
        [EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public _MSProject(ICOMObject parentObject, object comProxy) : base(parentObject, comProxy)
		{
		}
		
		///<param name="factory">current used factory core</param>
		///<param name="parentObject">object there has created the proxy</param>
        ///<param name="comProxy">inner wrapped COM proxy</param>
        ///<param name="comProxyType">Type of inner wrapped COM proxy"</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public _MSProject(Core factory, ICOMObject parentObject, object comProxy, NetRuntimeSystem.Type comProxyType) : base(factory, parentObject, comProxy, comProxyType)
		{

		}

		///<param name="parentObject">object there has created the proxy</param>
        ///<param name="comProxy">inner wrapped COM proxy</param>
        ///<param name="comProxyType">Type of inner wrapped COM proxy"</param>
        [EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public _MSProject(ICOMObject parentObject, object comProxy, NetRuntimeSystem.Type comProxyType) : base(parentObject, comProxy, comProxyType)
		{
		}
		
		///<param name="replacedObject">object to replaced. replacedObject are not usable after this action</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public _MSProject(ICOMObject replacedObject) : base(replacedObject)
		{
		}
		
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public _MSProject() : base()
		{
		}
		
		/// <param name="progId">registered progID</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public _MSProject(string progId) : base(progId)
		{
		}
		
		#endregion
		
		#region Properties

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Application Application
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Application>(this, "Application", NetOffice.MSProjectApi.Application.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "Application", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Application Parent
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Application>(this, "Parent", NetOffice.MSProjectApi.Application.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "Parent", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Projects Projects
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Projects>(this, "Projects", NetOffice.MSProjectApi.Projects.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "Projects", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Selection ActiveSelection
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Selection>(this, "ActiveSelection", NetOffice.MSProjectApi.Selection.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "ActiveSelection", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Cell ActiveCell
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Cell>(this, "ActiveCell", NetOffice.MSProjectApi.Cell.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "ActiveCell", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Project ActiveProject
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Project>(this, "ActiveProject", NetOffice.MSProjectApi.Project.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "ActiveProject", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Window ActiveWindow
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Window>(this, "ActiveWindow", NetOffice.MSProjectApi.Window.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "ActiveWindow", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SupportsMultipleDocuments
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "SupportsMultipleDocuments");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "SupportsMultipleDocuments", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SupportsMultipleWindows
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "SupportsMultipleWindows");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "SupportsMultipleWindows", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Visible
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "Visible");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Visible", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string PathSeparator
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "PathSeparator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "PathSeparator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string Caption
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "Caption");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Caption", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string Name
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "Name");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Name", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string Path
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "Path");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Path", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string Version
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "Version");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Version", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjWindowState WindowState
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjWindowState>(this, "WindowState");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "WindowState", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 Left
		{
			get
			{
				return Factory.ExecuteInt32PropertyGet(this, "Left");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Left", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 Top
		{
			get
			{
				return Factory.ExecuteInt32PropertyGet(this, "Top");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Top", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 Width
		{
			get
			{
				return Factory.ExecuteInt32PropertyGet(this, "Width");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Width", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 Height
		{
			get
			{
				return Factory.ExecuteInt32PropertyGet(this, "Height");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Height", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjDateOrder DateOrder
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjDateOrder>(this, "DateOrder");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "DateOrder", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string DateSeparator
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "DateSeparator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DateSeparator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string ThousandSeparator
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "ThousandSeparator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "ThousandSeparator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string DecimalSeparator
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "DecimalSeparator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DecimalSeparator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string ListSeparator
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "ListSeparator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "ListSeparator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string TimeSeparator
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "TimeSeparator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "TimeSeparator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TwelveHourTimeFormat
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "TwelveHourTimeFormat");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "TwelveHourTimeFormat", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string AMText
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "AMText");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "AMText", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string PMText
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "PMText");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "PMText", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string DefaultView
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "DefaultView");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DefaultView", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayStatusBar
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayStatusBar");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayStatusBar", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayAlerts
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayAlerts");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayAlerts", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayEntryBar
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayEntryBar");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayEntryBar", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayScrollBars
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayScrollBars");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayScrollBars", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayWindowsInTaskbar
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayWindowsInTaskbar");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayWindowsInTaskbar", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjCalculation Calculation
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjCalculation>(this, "Calculation");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "Calculation", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AutoLevel
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "AutoLevel");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "AutoLevel", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AutoClearLeveling
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "AutoClearLeveling");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "AutoClearLeveling", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelWithinSlack
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "LevelWithinSlack");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "LevelWithinSlack", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjLevelOrder LevelOrder
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjLevelOrder>(this, "LevelOrder");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "LevelOrder", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjLevelPeriodBasis LevelPeriodBasis
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjLevelPeriodBasis>(this, "LevelPeriodBasis");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "LevelPeriodBasis", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelIndividualAssignments
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "LevelIndividualAssignments");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "LevelIndividualAssignments", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelProposedBookings
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "LevelProposedBookings");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "LevelProposedBookings", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingCanSplit
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "LevelingCanSplit");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "LevelingCanSplit", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MoveAfterReturn
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "MoveAfterReturn");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "MoveAfterReturn", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayScheduleMessages
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayScheduleMessages");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayScheduleMessages", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjWeekday StartWeekOn
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjWeekday>(this, "StartWeekOn");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "StartWeekOn", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjMonth StartYearIn
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjMonth>(this, "StartYearIn");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "StartYearIn", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CellDragAndDrop
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "CellDragAndDrop");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "CellDragAndDrop", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string UserName
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "UserName");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "UserName", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public bool DisplayNotesIndicator
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayNotesIndicator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayNotesIndicator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AskToUpdateLinks
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "AskToUpdateLinks");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "AskToUpdateLinks", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayPlanningWizard
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayPlanningWizard");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayPlanningWizard", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayWizardUsage
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayWizardUsage");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayWizardUsage", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayWizardErrors
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayWizardErrors");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayWizardErrors", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayWizardScheduling
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayWizardScheduling");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayWizardScheduling", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public bool ShowTipOfDay
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "ShowTipOfDay");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "ShowTipOfDay", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public bool ShowToolTips
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "ShowToolTips");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "ShowToolTips", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ShowWelcome
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "ShowWelcome");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "ShowWelcome", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadLastFile
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "LoadLastFile");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "LoadLastFile", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PromptForSummaryInfo
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "PromptForSummaryInfo");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "PromptForSummaryInfo", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayOLEIndicator
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayOLEIndicator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayOLEIndicator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjDateFormat DefaultDateFormat
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjDateFormat>(this, "DefaultDateFormat");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "DefaultDateFormat", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DayLeadingZero
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DayLeadingZero");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DayLeadingZero", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MonthLeadingZero
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "MonthLeadingZero");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "MonthLeadingZero", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimeLeadingZero
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "TimeLeadingZero");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "TimeLeadingZero", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public bool CopyResourceUsageHeader
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "CopyResourceUsageHeader");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "CopyResourceUsageHeader", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 RecentFilesMaximum
		{
			get
			{
				return Factory.ExecuteInt32PropertyGet(this, "RecentFilesMaximum");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "RecentFilesMaximum", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayRecentFiles
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayRecentFiles");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayRecentFiles", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public bool MacroVirusProtection
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "MacroVirusProtection");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "MacroVirusProtection", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjAssignmentUnits ShowAssignmentUnitsAs
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjAssignmentUnits>(this, "ShowAssignmentUnitsAs");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "ShowAssignmentUnitsAs", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AutomaticallyFillPhoneticFields
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "AutomaticallyFillPhoneticFields");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "AutomaticallyFillPhoneticFields", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DefaultAutoFilter
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DefaultAutoFilter");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DefaultAutoFilter", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ShowEstimatedDuration
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "ShowEstimatedDuration");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "ShowEstimatedDuration", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool NewTasksEstimated
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "NewTasksEstimated");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "NewTasksEstimated", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.OfficeApi.Assistant Assistant
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.OfficeApi.Assistant>(this, "Assistant", NetOffice.OfficeApi.Assistant.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "Assistant", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayViewBar
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayViewBar");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayViewBar", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.VBIDEApi.VBE VBE
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.VBIDEApi.VBE>(this, "VBE", NetOffice.VBIDEApi.VBE.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "VBE", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjEnableCancelKey EnableCancelKey
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjEnableCancelKey>(this, "EnableCancelKey");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "EnableCancelKey", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UserControl
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "UserControl");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "UserControl", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Double UsableWidth
		{
			get
			{
				return Factory.ExecuteDoublePropertyGet(this, "UsableWidth");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "UsableWidth", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Double UsableHeight
		{
			get
			{
				return Factory.ExecuteDoublePropertyGet(this, "UsableHeight");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "UsableHeight", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public object StatusBar
		{
			get
			{
				return Factory.ExecuteVariantPropertyGet(this, "StatusBar");
			}
			set
			{
				Factory.ExecuteVariantPropertySet(this, "StatusBar", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.OfficeApi.FileSearch FileSearch
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.OfficeApi.FileSearch>(this, "FileSearch", NetOffice.OfficeApi.FileSearch.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "FileSearch", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ScreenUpdating
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "ScreenUpdating");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "ScreenUpdating", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplayProjectGuide
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "DisplayProjectGuide");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "DisplayProjectGuide", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.OfficeApi.Enums.MsoAutomationSecurity AutomationSecurity
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.OfficeApi.Enums.MsoAutomationSecurity>(this, "AutomationSecurity");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "AutomationSecurity", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseAllowLocalBaseCalendars
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "EnterpriseAllowLocalBaseCalendars");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "EnterpriseAllowLocalBaseCalendars", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjEditionType Edition
		{
			get
			{
				return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjEditionType>(this, "Edition");
			}
			set
			{
				Factory.ExecuteEnumPropertySet(this, "Edition", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Profiles Profiles
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Profiles>(this, "Profiles", NetOffice.MSProjectApi.Profiles.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "Profiles", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Calendars GlobalBaseCalendars
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Calendars>(this, "GlobalBaseCalendars", NetOffice.MSProjectApi.Calendars.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalBaseCalendars", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		[BaseResult]
		public NetOffice.MSProjectApi.Views GlobalViews
		{
			get
			{
				return Factory.ExecuteBaseReferencePropertyGet<NetOffice.MSProjectApi.Views>(this, "GlobalViews");
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalViews", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.ViewsSingle GlobalViewsSingle
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.ViewsSingle>(this, "GlobalViewsSingle", NetOffice.MSProjectApi.ViewsSingle.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalViewsSingle", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.ViewsCombination GlobalViewsCombination
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.ViewsCombination>(this, "GlobalViewsCombination", NetOffice.MSProjectApi.ViewsCombination.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalViewsCombination", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Tables GlobalTaskTables
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Tables>(this, "GlobalTaskTables", NetOffice.MSProjectApi.Tables.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalTaskTables", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Tables GlobalResourceTables
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Tables>(this, "GlobalResourceTables", NetOffice.MSProjectApi.Tables.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalResourceTables", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Filters GlobalTaskFilters
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Filters>(this, "GlobalTaskFilters", NetOffice.MSProjectApi.Filters.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalTaskFilters", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Filters GlobalResourceFilters
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Filters>(this, "GlobalResourceFilters", NetOffice.MSProjectApi.Filters.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalResourceFilters", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.OutlineCodes GlobalOutlineCodes
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.OutlineCodes>(this, "GlobalOutlineCodes", NetOffice.MSProjectApi.OutlineCodes.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "GlobalOutlineCodes", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string EnterpriseListSeparator
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "EnterpriseListSeparator");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "EnterpriseListSeparator", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseProtectActuals
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "EnterpriseProtectActuals");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "EnterpriseProtectActuals", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Windows Windows
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Windows>(this, "Windows", NetOffice.MSProjectApi.Windows.LateBindingApiWrapperType);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.OfficeApi.CommandBars CommandBars
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.OfficeApi.CommandBars>(this, "CommandBars", NetOffice.OfficeApi.CommandBars.LateBindingApiWrapperType);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.OfficeApi.AnswerWizard AnswerWizard
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.OfficeApi.AnswerWizard>(this, "AnswerWizard", NetOffice.OfficeApi.AnswerWizard.LateBindingApiWrapperType);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string OperatingSystem
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "OperatingSystem");
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public string get_FileFormatID(string name, object userID, object databasePassWord)
		{
			return Factory.ExecuteStringPropertyGet(this, "FileFormatID", name, userID, databasePassWord);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Alias for get_FileFormatID
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		[SupportByVersion("MSProject", 11,12,14), Redirect("get_FileFormatID")]
		public string FileFormatID(string name, object userID, object databasePassWord)
		{
			return get_FileFormatID(name, userID, databasePassWord);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		/// <param name="name">string name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public string get_FileFormatID(string name)
		{
			return Factory.ExecuteStringPropertyGet(this, "FileFormatID", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Alias for get_FileFormatID
		/// </summary>
		/// <param name="name">string name</param>
		[SupportByVersion("MSProject", 11,12,14), Redirect("get_FileFormatID")]
		public string FileFormatID(string name)
		{
			return get_FileFormatID(name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public string get_FileFormatID(string name, object userID)
		{
			return Factory.ExecuteStringPropertyGet(this, "FileFormatID", name, userID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Alias for get_FileFormatID
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		[SupportByVersion("MSProject", 11,12,14), Redirect("get_FileFormatID")]
		public string FileFormatID(string name, object userID)
		{
			return get_FileFormatID(name, userID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public string get_FileBuildID(string name, object userID, object databasePassWord)
		{
			return Factory.ExecuteStringPropertyGet(this, "FileBuildID", name, userID, databasePassWord);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Alias for get_FileBuildID
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		[SupportByVersion("MSProject", 11,12,14), Redirect("get_FileBuildID")]
		public string FileBuildID(string name, object userID, object databasePassWord)
		{
			return get_FileBuildID(name, userID, databasePassWord);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		/// <param name="name">string name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public string get_FileBuildID(string name)
		{
			return Factory.ExecuteStringPropertyGet(this, "FileBuildID", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Alias for get_FileBuildID
		/// </summary>
		/// <param name="name">string name</param>
		[SupportByVersion("MSProject", 11,12,14), Redirect("get_FileBuildID")]
		public string FileBuildID(string name)
		{
			return get_FileBuildID(name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public string get_FileBuildID(string name, object userID)
		{
			return Factory.ExecuteStringPropertyGet(this, "FileBuildID", name, userID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Alias for get_FileBuildID
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="userID">optional object userID</param>
		[SupportByVersion("MSProject", 11,12,14), Redirect("get_FileBuildID")]
		public string FileBuildID(string name, object userID)
		{
			return get_FileBuildID(name, userID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.OfficeApi.COMAddIns COMAddIns
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.OfficeApi.COMAddIns>(this, "COMAddIns", NetOffice.OfficeApi.COMAddIns.LateBindingApiWrapperType);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Windows2 Windows2
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Windows2>(this, "Windows2", NetOffice.MSProjectApi.Windows2.LateBindingApiWrapperType);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.ReportTemplates VisualReportTemplateList
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.ReportTemplates>(this, "VisualReportTemplateList", NetOffice.MSProjectApi.ReportTemplates.LateBindingApiWrapperType);
			}
			set
			{
				Factory.ExecuteReferencePropertySet(this, "VisualReportTemplateList", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Use3DLook
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "Use3DLook");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Use3DLook", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UseOMIDs
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "UseOMIDs");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "UseOMIDs", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 UndoLevels
		{
			get
			{
				return Factory.ExecuteInt32PropertyGet(this, "UndoLevels");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "UndoLevels", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnableChangeHighlighting
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "EnableChangeHighlighting");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "EnableChangeHighlighting", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string VisualReportsAdditionalTemplatePath
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "VisualReportsAdditionalTemplatePath");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "VisualReportsAdditionalTemplatePath", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TrustProjectServerAndWSSPages
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "TrustProjectServerAndWSSPages");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "TrustProjectServerAndWSSPages", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.OfficeApi.IAssistance Assistance
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.OfficeApi.IAssistance>(this, "Assistance", NetOffice.OfficeApi.IAssistance.LateBindingApiWrapperType);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public object TimescaleStart
		{
			get
			{
				return Factory.ExecuteVariantPropertyGet(this, "TimescaleStart");
			}
			set
			{
				Factory.ExecuteVariantPropertySet(this, "TimescaleStart", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public object TimescaleFinish
		{
			get
			{
				return Factory.ExecuteVariantPropertyGet(this, "TimescaleFinish");
			}
			set
			{
				Factory.ExecuteVariantPropertySet(this, "TimescaleFinish", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public object PanZoomStart
		{
			get
			{
				return Factory.ExecuteVariantPropertyGet(this, "PanZoomStart");
			}
			set
			{
				Factory.ExecuteVariantPropertySet(this, "PanZoomStart", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public object PanZoomFinish
		{
			get
			{
				return Factory.ExecuteVariantPropertyGet(this, "PanZoomFinish");
			}
			set
			{
				Factory.ExecuteVariantPropertySet(this, "PanZoomFinish", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public string Build
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "Build");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "Build", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public string CompareProjectsCurrentVersionName
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "CompareProjectsCurrentVersionName");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "CompareProjectsCurrentVersionName", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public string CompareProjectsPreviousVersionName
		{
			get
			{
				return Factory.ExecuteStringPropertyGet(this, "CompareProjectsPreviousVersionName");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "CompareProjectsPreviousVersionName", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// Get/Set
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelFreeformTasks
		{
			get
			{
				return Factory.ExecuteBoolPropertyGet(this, "LevelFreeformTasks");
			}
			set
			{
				Factory.ExecuteValuePropertySet(this, "LevelFreeformTasks", value);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// Get
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public NetOffice.MSProjectApi.Reports GlobalReports
		{
			get
			{
				return Factory.ExecuteKnownReferencePropertyGet<NetOffice.MSProjectApi.Reports>(this, "GlobalReports", NetOffice.MSProjectApi.Reports.LateBindingApiWrapperType);
			}
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// Get
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="projectJobType">NetOffice.MSProjectApi.Enums.PjJobType projectJobType</param>
		[SupportByVersion("MSProject", 11)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public NetOffice.MSProjectApi.Enums.PjCacheJobState get_GetCacheStatusForProject(string projectName, NetOffice.MSProjectApi.Enums.PjJobType projectJobType)
		{
			return Factory.ExecuteEnumPropertyGet<NetOffice.MSProjectApi.Enums.PjCacheJobState>(this, "GetCacheStatusForProject", projectName, projectJobType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// Alias for get_GetCacheStatusForProject
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="projectJobType">NetOffice.MSProjectApi.Enums.PjJobType projectJobType</param>
		[SupportByVersion("MSProject", 11), Redirect("get_GetCacheStatusForProject")]
		public NetOffice.MSProjectApi.Enums.PjCacheJobState GetCacheStatusForProject(string projectName, NetOffice.MSProjectApi.Enums.PjJobType projectJobType)
		{
			return get_GetCacheStatusForProject(projectName, projectJobType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// Get
		/// </summary>
		/// <param name="projectName">string projectName</param>
		[SupportByVersion("MSProject", 11)]
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public bool get_IsCheckedOut(string projectName)
		{
			return Factory.ExecuteBoolPropertyGet(this, "IsCheckedOut", projectName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// Alias for get_IsCheckedOut
		/// </summary>
		/// <param name="projectName">string projectName</param>
		[SupportByVersion("MSProject", 11), Redirect("get_IsCheckedOut")]
		public bool IsCheckedOut(string projectName)
		{
			return get_IsCheckedOut(projectName);
		}

		#endregion

		#region Methods

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="saveChanges">optional NetOffice.MSProjectApi.Enums.PjSaveType SaveChanges = 2</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void Quit(object saveChanges)
		{
			 Factory.ExecuteMethod(this, "Quit", saveChanges);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Quit()
		{
			 Factory.ExecuteMethod(this, "Quit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startDate">object startDate</param>
		/// <param name="duration">object duration</param>
		/// <param name="calendar">optional object calendar</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateAdd(object startDate, object duration, object calendar)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateAdd", startDate, duration, calendar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startDate">object startDate</param>
		/// <param name="duration">object duration</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateAdd(object startDate, object duration)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateAdd", startDate, duration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="finishDate">object finishDate</param>
		/// <param name="duration">object duration</param>
		/// <param name="calendar">optional object calendar</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateSubtract(object finishDate, object duration, object calendar)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateSubtract", finishDate, duration, calendar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="finishDate">object finishDate</param>
		/// <param name="duration">object duration</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateSubtract(object finishDate, object duration)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateSubtract", finishDate, duration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startDate">object startDate</param>
		/// <param name="finishDate">object finishDate</param>
		/// <param name="calendar">optional object calendar</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateDifference(object startDate, object finishDate, object calendar)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateDifference", startDate, finishDate, calendar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startDate">object startDate</param>
		/// <param name="finishDate">object finishDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateDifference(object startDate, object finishDate)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateDifference", startDate, finishDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="duration">object duration</param>
		/// <param name="units">optional object units</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string DurationFormat(object duration, object units)
		{
			return Factory.ExecuteStringMethodGet(this, "DurationFormat", duration, units);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="duration">object duration</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public string DurationFormat(object duration)
		{
			return Factory.ExecuteStringMethodGet(this, "DurationFormat", duration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="duration">string duration</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public object DurationValue(string duration)
		{
			return Factory.ExecuteVariantMethodGet(this, "DurationValue", duration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="date">object date</param>
		/// <param name="format">optional object format</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateFormat(object date, object format)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateFormat", date, format);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="date">object date</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object DateFormat(object date)
		{
			return Factory.ExecuteVariantMethodGet(this, "DateFormat", date);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="password">optional object password</param>
		/// <param name="downloadNewMail">optional object downloadNewMail</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void MailLogon(object name, object password, object downloadNewMail)
		{
			 Factory.ExecuteMethod(this, "MailLogon", name, password, downloadNewMail);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void MailLogon()
		{
			 Factory.ExecuteMethod(this, "MailLogon");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void MailLogon(object name)
		{
			 Factory.ExecuteMethod(this, "MailLogon", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="password">optional object password</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void MailLogon(object name, object password)
		{
			 Factory.ExecuteMethod(this, "MailLogon", name, password);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public void MailLogoff()
		{
			 Factory.ExecuteMethod(this, "MailLogoff");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string MailSession()
		{
			return Factory.ExecuteStringMethodGet(this, "MailSession");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjMailSystem MailSystem()
		{
			return Factory.ExecuteEnumMethodGet<NetOffice.MSProjectApi.Enums.PjMailSystem>(this, "MailSystem");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		/// <param name="resourceID">Int32 resourceID</param>
		/// <param name="startDate">object startDate</param>
		/// <param name="endDate">object endDate</param>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjTimescaledData Type = 0</param>
		/// <param name="timeScaleUnit">optional NetOffice.MSProjectApi.Enums.PjTimescaleUnit TimeScaleUnit = 3</param>
		/// <param name="count">optional object count</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public object TimescaledData(Int32 taskID, Int32 resourceID, object startDate, object endDate, object type, object timeScaleUnit, object count)
		{
			return Factory.ExecuteVariantMethodGet(this, "TimescaledData", new object[]{ taskID, resourceID, startDate, endDate, type, timeScaleUnit, count });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		/// <param name="resourceID">Int32 resourceID</param>
		/// <param name="startDate">object startDate</param>
		/// <param name="endDate">object endDate</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object TimescaledData(Int32 taskID, Int32 resourceID, object startDate, object endDate)
		{
			return Factory.ExecuteVariantMethodGet(this, "TimescaledData", taskID, resourceID, startDate, endDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		/// <param name="resourceID">Int32 resourceID</param>
		/// <param name="startDate">object startDate</param>
		/// <param name="endDate">object endDate</param>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjTimescaledData Type = 0</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object TimescaledData(Int32 taskID, Int32 resourceID, object startDate, object endDate, object type)
		{
			return Factory.ExecuteVariantMethodGet(this, "TimescaledData", new object[]{ taskID, resourceID, startDate, endDate, type });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		/// <param name="resourceID">Int32 resourceID</param>
		/// <param name="startDate">object startDate</param>
		/// <param name="endDate">object endDate</param>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjTimescaledData Type = 0</param>
		/// <param name="timeScaleUnit">optional NetOffice.MSProjectApi.Enums.PjTimescaleUnit TimeScaleUnit = 3</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object TimescaledData(Int32 taskID, Int32 resourceID, object startDate, object endDate, object type, object timeScaleUnit)
		{
			return Factory.ExecuteVariantMethodGet(this, "TimescaledData", new object[]{ taskID, resourceID, startDate, endDate, type, timeScaleUnit });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string CustomFieldGetName(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteStringMethodGet(this, "CustomFieldGetName", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		/// <param name="arg24">optional object arg24</param>
		/// <param name="arg25">optional object arg25</param>
		/// <param name="arg26">optional object arg26</param>
		/// <param name="arg27">optional object arg27</param>
		/// <param name="arg28">optional object arg28</param>
		/// <param name="arg29">optional object arg29</param>
		/// <param name="arg30">optional object arg30</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23, object arg24, object arg25, object arg26, object arg27, object arg28, object arg29, object arg30)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24, arg25, arg26, arg27, arg28, arg29, arg30 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name)
		{
			 Factory.ExecuteMethod(this, "Run", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1)
		{
			 Factory.ExecuteMethod(this, "Run", name, arg1);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2)
		{
			 Factory.ExecuteMethod(this, "Run", name, arg1, arg2);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3)
		{
			 Factory.ExecuteMethod(this, "Run", name, arg1, arg2, arg3);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		/// <param name="arg24">optional object arg24</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23, object arg24)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		/// <param name="arg24">optional object arg24</param>
		/// <param name="arg25">optional object arg25</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23, object arg24, object arg25)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24, arg25 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		/// <param name="arg24">optional object arg24</param>
		/// <param name="arg25">optional object arg25</param>
		/// <param name="arg26">optional object arg26</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23, object arg24, object arg25, object arg26)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24, arg25, arg26 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		/// <param name="arg24">optional object arg24</param>
		/// <param name="arg25">optional object arg25</param>
		/// <param name="arg26">optional object arg26</param>
		/// <param name="arg27">optional object arg27</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23, object arg24, object arg25, object arg26, object arg27)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24, arg25, arg26, arg27 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		/// <param name="arg24">optional object arg24</param>
		/// <param name="arg25">optional object arg25</param>
		/// <param name="arg26">optional object arg26</param>
		/// <param name="arg27">optional object arg27</param>
		/// <param name="arg28">optional object arg28</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23, object arg24, object arg25, object arg26, object arg27, object arg28)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24, arg25, arg26, arg27, arg28 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="arg1">optional object arg1</param>
		/// <param name="arg2">optional object arg2</param>
		/// <param name="arg3">optional object arg3</param>
		/// <param name="arg4">optional object arg4</param>
		/// <param name="arg5">optional object arg5</param>
		/// <param name="arg6">optional object arg6</param>
		/// <param name="arg7">optional object arg7</param>
		/// <param name="arg8">optional object arg8</param>
		/// <param name="arg9">optional object arg9</param>
		/// <param name="arg10">optional object arg10</param>
		/// <param name="arg11">optional object arg11</param>
		/// <param name="arg12">optional object arg12</param>
		/// <param name="arg13">optional object arg13</param>
		/// <param name="arg14">optional object arg14</param>
		/// <param name="arg15">optional object arg15</param>
		/// <param name="arg16">optional object arg16</param>
		/// <param name="arg17">optional object arg17</param>
		/// <param name="arg18">optional object arg18</param>
		/// <param name="arg19">optional object arg19</param>
		/// <param name="arg20">optional object arg20</param>
		/// <param name="arg21">optional object arg21</param>
		/// <param name="arg22">optional object arg22</param>
		/// <param name="arg23">optional object arg23</param>
		/// <param name="arg24">optional object arg24</param>
		/// <param name="arg25">optional object arg25</param>
		/// <param name="arg26">optional object arg26</param>
		/// <param name="arg27">optional object arg27</param>
		/// <param name="arg28">optional object arg28</param>
		/// <param name="arg29">optional object arg29</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void Run(string name, object arg1, object arg2, object arg3, object arg4, object arg5, object arg6, object arg7, object arg8, object arg9, object arg10, object arg11, object arg12, object arg13, object arg14, object arg15, object arg16, object arg17, object arg18, object arg19, object arg20, object arg21, object arg22, object arg23, object arg24, object arg25, object arg26, object arg27, object arg28, object arg29)
		{
			 Factory.ExecuteMethod(this, "Run", new object[]{ name, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18, arg19, arg20, arg21, arg22, arg23, arg24, arg25, arg26, arg27, arg28, arg29 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="index">NetOffice.MSProjectApi.Enums.PjMSApplication index</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void ActivateMicrosoftApp(NetOffice.MSProjectApi.Enums.PjMSApplication index)
		{
			 Factory.ExecuteMethod(this, "ActivateMicrosoftApp", index);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 BoxGetXPosition(Int32 taskID, object projectName)
		{
			return Factory.ExecuteInt32MethodGet(this, "BoxGetXPosition", taskID, projectName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 BoxGetXPosition(Int32 taskID)
		{
			return Factory.ExecuteInt32MethodGet(this, "BoxGetXPosition", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 BoxGetYPosition(Int32 taskID, object projectName)
		{
			return Factory.ExecuteInt32MethodGet(this, "BoxGetYPosition", taskID, projectName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 BoxGetYPosition(Int32 taskID)
		{
			return Factory.ExecuteInt32MethodGet(this, "BoxGetYPosition", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string CustomFieldGetFormula(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteStringMethodGet(this, "CustomFieldGetFormula", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjValueListItem item</param>
		/// <param name="index">Int32 index</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string CustomFieldValueListGetItem(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, NetOffice.MSProjectApi.Enums.PjValueListItem item, Int32 index)
		{
			return Factory.ExecuteStringMethodGet(this, "CustomFieldValueListGetItem", fieldID, item, index);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="goalArea">Int32 goalArea</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void GoalAreaHighlight(Int32 goalArea)
		{
			 Factory.ExecuteMethod(this, "GoalAreaHighlight", goalArea);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="displayState">bool displayState</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void SetSidepaneStateButton(bool displayState)
		{
			 Factory.ExecuteMethod(this, "SetSidepaneStateButton", displayState);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void GoalAreaTaskHighlight(Int32 taskID)
		{
			 Factory.ExecuteMethod(this, "GoalAreaTaskHighlight", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldName">string fieldName</param>
		/// <param name="fieldType">optional NetOffice.MSProjectApi.Enums.PjFieldType FieldType = 0</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjField FieldNameToFieldConstant(string fieldName, object fieldType)
		{
			return Factory.ExecuteEnumMethodGet<NetOffice.MSProjectApi.Enums.PjField>(this, "FieldNameToFieldConstant", fieldName, fieldType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldName">string fieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjField FieldNameToFieldConstant(string fieldName)
		{
			return Factory.ExecuteEnumMethodGet<NetOffice.MSProjectApi.Enums.PjField>(this, "FieldNameToFieldConstant", fieldName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">NetOffice.MSProjectApi.Enums.PjField field</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string FieldConstantToFieldName(NetOffice.MSProjectApi.Enums.PjField field)
		{
			return Factory.ExecuteStringMethodGet(this, "FieldConstantToFieldName", field);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="requestXML">string requestXML</param>
		/// <param name="project">optional object project</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string GetProjectServerSettings(string requestXML, object project)
		{
			return Factory.ExecuteStringMethodGet(this, "GetProjectServerSettings", requestXML, project);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="requestXML">string requestXML</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public string GetProjectServerSettings(string requestXML)
		{
			return Factory.ExecuteStringMethodGet(this, "GetProjectServerSettings", requestXML);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="window">optional object window</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void UnloadWebBrowserControl(object window)
		{
			 Factory.ExecuteMethod(this, "UnloadWebBrowserControl", window);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void UnloadWebBrowserControl()
		{
			 Factory.ExecuteMethod(this, "UnloadWebBrowserControl");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="xML">string xML</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 OpenXML(string xML)
		{
			return Factory.ExecuteInt32MethodGet(this, "OpenXML", xML);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">string serverURL</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Enums.PjServerVersionInfo GetProjectServerVersion(string serverURL)
		{
			return Factory.ExecuteEnumMethodGet<NetOffice.MSProjectApi.Enums.PjServerVersionInfo>(this, "GetProjectServerVersion", serverURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="dataFile">string dataFile</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public object UpdateFromProjectServer(string dataFile)
		{
			return Factory.ExecuteVariantMethodGet(this, "UpdateFromProjectServer", dataFile);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 LocaleID()
		{
			return Factory.ExecuteInt32MethodGet(this, "LocaleID");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public void EnterpriseMakeServerURLTrusted()
		{
			 Factory.ExecuteMethod(this, "EnterpriseMakeServerURLTrusted");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="uRL">string uRL</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool IsURLTrusted(string uRL)
		{
			return Factory.ExecuteBoolMethodGet(this, "IsURLTrusted", uRL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyResources">optional bool NotifyResources = true</param>
		/// <param name="notificationText">optional object notificationText</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishNewAndChangedAssignments(object showDialog, object itemsScope, object notifyResources, object notificationText)
		{
			 Factory.ExecuteMethod(this, "PublishNewAndChangedAssignments", showDialog, itemsScope, notifyResources, notificationText);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishNewAndChangedAssignments()
		{
			 Factory.ExecuteMethod(this, "PublishNewAndChangedAssignments");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishNewAndChangedAssignments(object showDialog)
		{
			 Factory.ExecuteMethod(this, "PublishNewAndChangedAssignments", showDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishNewAndChangedAssignments(object showDialog, object itemsScope)
		{
			 Factory.ExecuteMethod(this, "PublishNewAndChangedAssignments", showDialog, itemsScope);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyResources">optional bool NotifyResources = true</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishNewAndChangedAssignments(object showDialog, object itemsScope, object notifyResources)
		{
			 Factory.ExecuteMethod(this, "PublishNewAndChangedAssignments", showDialog, itemsScope, notifyResources);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="publishFullPlan">optional bool PublishFullPlan = true</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishProjectPlan(object showDialog, object publishFullPlan)
		{
			 Factory.ExecuteMethod(this, "PublishProjectPlan", showDialog, publishFullPlan);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishProjectPlan()
		{
			 Factory.ExecuteMethod(this, "PublishProjectPlan");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishProjectPlan(object showDialog)
		{
			 Factory.ExecuteMethod(this, "PublishProjectPlan", showDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public void PublishAllInformation()
		{
			 Factory.ExecuteMethod(this, "PublishAllInformation");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyTaskLead">optional bool NotifyTaskLead = false</param>
		/// <param name="notificationText">optional object notificationText</param>
		/// <param name="reportingPeriodFrom">optional object reportingPeriodFrom</param>
		/// <param name="reportingPeriodTo">optional object reportingPeriodTo</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void RequestProgressInformation(object showDialog, object itemsScope, object notifyTaskLead, object notificationText, object reportingPeriodFrom, object reportingPeriodTo)
		{
			 Factory.ExecuteMethod(this, "RequestProgressInformation", new object[]{ showDialog, itemsScope, notifyTaskLead, notificationText, reportingPeriodFrom, reportingPeriodTo });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RequestProgressInformation()
		{
			 Factory.ExecuteMethod(this, "RequestProgressInformation");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RequestProgressInformation(object showDialog)
		{
			 Factory.ExecuteMethod(this, "RequestProgressInformation", showDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RequestProgressInformation(object showDialog, object itemsScope)
		{
			 Factory.ExecuteMethod(this, "RequestProgressInformation", showDialog, itemsScope);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyTaskLead">optional bool NotifyTaskLead = false</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RequestProgressInformation(object showDialog, object itemsScope, object notifyTaskLead)
		{
			 Factory.ExecuteMethod(this, "RequestProgressInformation", showDialog, itemsScope, notifyTaskLead);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyTaskLead">optional bool NotifyTaskLead = false</param>
		/// <param name="notificationText">optional object notificationText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RequestProgressInformation(object showDialog, object itemsScope, object notifyTaskLead, object notificationText)
		{
			 Factory.ExecuteMethod(this, "RequestProgressInformation", showDialog, itemsScope, notifyTaskLead, notificationText);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyTaskLead">optional bool NotifyTaskLead = false</param>
		/// <param name="notificationText">optional object notificationText</param>
		/// <param name="reportingPeriodFrom">optional object reportingPeriodFrom</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RequestProgressInformation(object showDialog, object itemsScope, object notifyTaskLead, object notificationText, object reportingPeriodFrom)
		{
			 Factory.ExecuteMethod(this, "RequestProgressInformation", new object[]{ showDialog, itemsScope, notifyTaskLead, notificationText, reportingPeriodFrom });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyResources">optional bool NotifyResources = true</param>
		/// <param name="overwriteActuals">optional bool OverwriteActuals = false</param>
		/// <param name="becomeManager">optional bool BecomeManager = false</param>
		/// <param name="notificationText">optional object notificationText</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void RepublishAssignments(object showDialog, object itemsScope, object notifyResources, object overwriteActuals, object becomeManager, object notificationText)
		{
			 Factory.ExecuteMethod(this, "RepublishAssignments", new object[]{ showDialog, itemsScope, notifyResources, overwriteActuals, becomeManager, notificationText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RepublishAssignments()
		{
			 Factory.ExecuteMethod(this, "RepublishAssignments");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RepublishAssignments(object showDialog)
		{
			 Factory.ExecuteMethod(this, "RepublishAssignments", showDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RepublishAssignments(object showDialog, object itemsScope)
		{
			 Factory.ExecuteMethod(this, "RepublishAssignments", showDialog, itemsScope);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyResources">optional bool NotifyResources = true</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RepublishAssignments(object showDialog, object itemsScope, object notifyResources)
		{
			 Factory.ExecuteMethod(this, "RepublishAssignments", showDialog, itemsScope, notifyResources);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyResources">optional bool NotifyResources = true</param>
		/// <param name="overwriteActuals">optional bool OverwriteActuals = false</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RepublishAssignments(object showDialog, object itemsScope, object notifyResources, object overwriteActuals)
		{
			 Factory.ExecuteMethod(this, "RepublishAssignments", showDialog, itemsScope, notifyResources, overwriteActuals);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showDialog">optional bool ShowDialog = false</param>
		/// <param name="itemsScope">optional NetOffice.MSProjectApi.Enums.PjPublishScope ItemsScope = 1</param>
		/// <param name="notifyResources">optional bool NotifyResources = true</param>
		/// <param name="overwriteActuals">optional bool OverwriteActuals = false</param>
		/// <param name="becomeManager">optional bool BecomeManager = false</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void RepublishAssignments(object showDialog, object itemsScope, object notifyResources, object overwriteActuals, object becomeManager)
		{
			 Factory.ExecuteMethod(this, "RepublishAssignments", new object[]{ showDialog, itemsScope, notifyResources, overwriteActuals, becomeManager });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="waitForCompletion">bool waitForCompletion</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 RegisterProject(bool waitForCompletion)
		{
			return Factory.ExecuteInt32MethodGet(this, "RegisterProject", waitForCompletion);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alertText">string alertText</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SaveProjectIfDirty(string alertText)
		{
			return Factory.ExecuteBoolMethodGet(this, "SaveProjectIfDirty", alertText);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool IsOfficeTaskPaneVisible()
		{
			return Factory.ExecuteBoolMethodGet(this, "IsOfficeTaskPaneVisible");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public void OfficeTaskPaneHide()
		{
			 Factory.ExecuteMethod(this, "OfficeTaskPaneHide");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 GetCurrentTheme()
		{
			return Factory.ExecuteInt32MethodGet(this, "GetCurrentTheme");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="message">string message</param>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjMessageType Type = 0</param>
		/// <param name="yesText">optional object yesText</param>
		/// <param name="noText">optional object noText</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Message(string message, object type, object yesText, object noText)
		{
			return Factory.ExecuteBoolMethodGet(this, "Message", message, type, yesText, noText);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="message">string message</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Message(string message)
		{
			return Factory.ExecuteBoolMethodGet(this, "Message", message);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="message">string message</param>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjMessageType Type = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Message(string message, object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "Message", message, type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="message">string message</param>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjMessageType Type = 0</param>
		/// <param name="yesText">optional object yesText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Message(string message, object type, object yesText)
		{
			return Factory.ExecuteBoolMethodGet(this, "Message", message, type, yesText);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Alerts(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "Alerts", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Alerts()
		{
			return Factory.ExecuteBoolMethodGet(this, "Alerts");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="template">optional object template</param>
		/// <param name="fileNewDialog">optional object fileNewDialog</param>
		/// <param name="fileNewWorkpane">optional object fileNewWorkpane</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileNew(object summaryInfo, object template, object fileNewDialog, object fileNewWorkpane)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileNew", summaryInfo, template, fileNewDialog, fileNewWorkpane);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileNew()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileNew");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileNew(object summaryInfo)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileNew", summaryInfo);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="template">optional object template</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileNew(object summaryInfo, object template)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileNew", summaryInfo, template);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="template">optional object template</param>
		/// <param name="fileNewDialog">optional object fileNewDialog</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileNew(object summaryInfo, object template, object fileNewDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileNew", summaryInfo, template, fileNewDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileProperties()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileProperties");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="ignoreReadOnlyRecommended">optional object ignoreReadOnlyRecommended</param>
		/// <param name="xMLName">optional object xMLName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpen(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password, object writeResPassword, object ignoreReadOnlyRecommended, object xMLName)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpen", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password, writeResPassword, ignoreReadOnlyRecommended, xMLName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpen(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpen", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpen(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpen", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpen(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpen", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpen(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password, object writeResPassword)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpen", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password, writeResPassword });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="ignoreReadOnlyRecommended">optional object ignoreReadOnlyRecommended</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpen(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password, object writeResPassword, object ignoreReadOnlyRecommended)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpen", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password, writeResPassword, ignoreReadOnlyRecommended });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Zoom()
		{
			return Factory.ExecuteBoolMethodGet(this, "Zoom");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="duration">optional object duration</param>
		/// <param name="entire">optional object entire</param>
		/// <param name="selection">optional object selection</param>
		/// <param name="reset">optional object reset</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomTimescale(object duration, object entire, object selection, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomTimescale", duration, entire, selection, reset);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomTimescale()
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomTimescale");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="duration">optional object duration</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomTimescale(object duration)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomTimescale", duration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="duration">optional object duration</param>
		/// <param name="entire">optional object entire</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomTimescale(object duration, object entire)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomTimescale", duration, entire);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="duration">optional object duration</param>
		/// <param name="entire">optional object entire</param>
		/// <param name="selection">optional object selection</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomTimescale(object duration, object entire, object selection)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomTimescale", duration, entire, selection);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percent">optional object percent</param>
		/// <param name="entire">optional object entire</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxZoom(object percent, object entire)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxZoom", percent, entire);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxZoom()
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxZoom");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percent">optional object percent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxZoom(object percent)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxZoom", percent);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		/// <param name="noAuto">optional object noAuto</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileClose(object save, object noAuto)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileClose", save, noAuto);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileClose()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileClose");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileClose(object save)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileClose", save);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseAll(object save)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseAll", save);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseAll()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseAll");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="share">optional object share</param>
		/// <param name="name">optional object name</param>
		/// <param name="pool">optional object pool</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharing(object share, object name, object pool)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharing", share, name, pool);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharing()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharing");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="share">optional object share</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharing(object share)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharing", share);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="share">optional object share</param>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharing(object share, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharing", share, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSave()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSave");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="clearBaseline">optional object clearBaseline</param>
		/// <param name="clearActuals">optional object clearActuals</param>
		/// <param name="clearResourceRates">optional object clearResourceRates</param>
		/// <param name="clearFixedCosts">optional object clearFixedCosts</param>
		/// <param name="xMLName">optional object xMLName</param>
		/// <param name="clearConfirmed">optional object clearConfirmed</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password, object writeResPassword, object clearBaseline, object clearActuals, object clearResourceRates, object clearFixedCosts, object xMLName, object clearConfirmed)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password, writeResPassword, clearBaseline, clearActuals, clearResourceRates, clearFixedCosts, xMLName, clearConfirmed });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", name, format);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", name, format, backup);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", name, format, backup, readOnly);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password, object writeResPassword)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password, writeResPassword });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="clearBaseline">optional object clearBaseline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password, object writeResPassword, object clearBaseline)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password, writeResPassword, clearBaseline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="clearBaseline">optional object clearBaseline</param>
		/// <param name="clearActuals">optional object clearActuals</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password, object writeResPassword, object clearBaseline, object clearActuals)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password, writeResPassword, clearBaseline, clearActuals });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="clearBaseline">optional object clearBaseline</param>
		/// <param name="clearActuals">optional object clearActuals</param>
		/// <param name="clearResourceRates">optional object clearResourceRates</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password, object writeResPassword, object clearBaseline, object clearActuals, object clearResourceRates)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password, writeResPassword, clearBaseline, clearActuals, clearResourceRates });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="clearBaseline">optional object clearBaseline</param>
		/// <param name="clearActuals">optional object clearActuals</param>
		/// <param name="clearResourceRates">optional object clearResourceRates</param>
		/// <param name="clearFixedCosts">optional object clearFixedCosts</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password, object writeResPassword, object clearBaseline, object clearActuals, object clearResourceRates, object clearFixedCosts)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password, writeResPassword, clearBaseline, clearActuals, clearResourceRates, clearFixedCosts });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjFileFormat Format = 0</param>
		/// <param name="backup">optional object backup</param>
		/// <param name="readOnly">optional object readOnly</param>
		/// <param name="taskInformation">optional object taskInformation</param>
		/// <param name="filtered">optional object filtered</param>
		/// <param name="table">optional object table</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		/// <param name="map">optional object map</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="clearBaseline">optional object clearBaseline</param>
		/// <param name="clearActuals">optional object clearActuals</param>
		/// <param name="clearResourceRates">optional object clearResourceRates</param>
		/// <param name="clearFixedCosts">optional object clearFixedCosts</param>
		/// <param name="xMLName">optional object xMLName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveAs(object name, object format, object backup, object readOnly, object taskInformation, object filtered, object table, object userID, object databasePassWord, object formatID, object map, object password, object writeResPassword, object clearBaseline, object clearActuals, object clearResourceRates, object clearFixedCosts, object xMLName)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveAs", new object[]{ name, format, backup, readOnly, taskInformation, filtered, table, userID, databasePassWord, formatID, map, password, writeResPassword, clearBaseline, clearActuals, clearResourceRates, clearFixedCosts, xMLName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveWorkspace(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveWorkspace", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveWorkspace()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveWorkspace");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="onePageWide">optional object onePageWide</param>
		/// <param name="preview">optional object preview</param>
		/// <param name="color">optional object color</param>
		/// <param name="showIEPrintDialog">optional object showIEPrintDialog</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate, object onePageWide, object preview, object color, object showIEPrintDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", new object[]{ fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate, onePageWide, preview, color, showIEPrintDialog });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", fromPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", fromPage, toPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", fromPage, toPage, pageBreaks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", fromPage, toPage, pageBreaks, draft);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft, object copies)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", new object[]{ fromPage, toPage, pageBreaks, draft, copies });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", new object[]{ fromPage, toPage, pageBreaks, draft, copies, fromDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", new object[]{ fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="onePageWide">optional object onePageWide</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate, object onePageWide)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", new object[]{ fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate, onePageWide });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="onePageWide">optional object onePageWide</param>
		/// <param name="preview">optional object preview</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate, object onePageWide, object preview)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", new object[]{ fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate, onePageWide, preview });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="onePageWide">optional object onePageWide</param>
		/// <param name="preview">optional object preview</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrint(object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate, object onePageWide, object preview, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrint", new object[]{ fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate, onePageWide, preview, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="preview">optional object preview</param>
		/// <param name="color">optional object color</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate, object preview, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", new object[]{ name, fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate, preview, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint()
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", name, fromPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", name, fromPage, toPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage, object pageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", name, fromPage, toPage, pageBreaks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage, object pageBreaks, object draft)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", new object[]{ name, fromPage, toPage, pageBreaks, draft });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage, object pageBreaks, object draft, object copies)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", new object[]{ name, fromPage, toPage, pageBreaks, draft, copies });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", new object[]{ name, fromPage, toPage, pageBreaks, draft, copies, fromDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", new object[]{ name, fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="fromPage">optional object fromPage</param>
		/// <param name="toPage">optional object toPage</param>
		/// <param name="pageBreaks">optional object pageBreaks</param>
		/// <param name="draft">optional object draft</param>
		/// <param name="copies">optional object copies</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="preview">optional object preview</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrint(object name, object fromPage, object toPage, object pageBreaks, object draft, object copies, object fromDate, object toDate, object preview)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrint", new object[]{ name, fromPage, toPage, pageBreaks, draft, copies, fromDate, toDate, preview });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrintPreview()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrintPreview");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrintPreview(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrintPreview", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReportPrintPreview()
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportPrintPreview");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="printer">optional object printer</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrintSetup(object printer)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrintSetup", printer);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePrintSetup()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePrintSetup");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetup(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetup", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetup()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetup");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="portrait">object portrait</param>
		/// <param name="percentScale">object percentScale</param>
		/// <param name="pagesTall">object pagesTall</param>
		/// <param name="pagesWide">object pagesWide</param>
		/// <param name="paperSize">optional NetOffice.MSProjectApi.Enums.PjPaperSize PaperSize = 0</param>
		/// <param name="firstPageNumber">optional object firstPageNumber</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupPage(object name, object portrait, object percentScale, object pagesTall, object pagesWide, object paperSize, object firstPageNumber)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupPage", new object[]{ name, portrait, percentScale, pagesTall, pagesWide, paperSize, firstPageNumber });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="portrait">object portrait</param>
		/// <param name="percentScale">object percentScale</param>
		/// <param name="pagesTall">object pagesTall</param>
		/// <param name="pagesWide">object pagesWide</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupPage(object name, object portrait, object percentScale, object pagesTall, object pagesWide)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupPage", new object[]{ name, portrait, percentScale, pagesTall, pagesWide });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="portrait">object portrait</param>
		/// <param name="percentScale">object percentScale</param>
		/// <param name="pagesTall">object pagesTall</param>
		/// <param name="pagesWide">object pagesWide</param>
		/// <param name="paperSize">optional NetOffice.MSProjectApi.Enums.PjPaperSize PaperSize = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupPage(object name, object portrait, object percentScale, object pagesTall, object pagesWide, object paperSize)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupPage", new object[]{ name, portrait, percentScale, pagesTall, pagesWide, paperSize });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="top">optional object top</param>
		/// <param name="bottom">optional object bottom</param>
		/// <param name="left">optional object left</param>
		/// <param name="right">optional object right</param>
		/// <param name="borders">optional object borders</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupMargins(object name, object top, object bottom, object left, object right, object borders)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupMargins", new object[]{ name, top, bottom, left, right, borders });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupMargins()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupMargins");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupMargins(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupMargins", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="top">optional object top</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupMargins(object name, object top)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupMargins", name, top);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="top">optional object top</param>
		/// <param name="bottom">optional object bottom</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupMargins(object name, object top, object bottom)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupMargins", name, top, bottom);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="top">optional object top</param>
		/// <param name="bottom">optional object bottom</param>
		/// <param name="left">optional object left</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupMargins(object name, object top, object bottom, object left)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupMargins", name, top, bottom, left);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="top">optional object top</param>
		/// <param name="bottom">optional object bottom</param>
		/// <param name="left">optional object left</param>
		/// <param name="right">optional object right</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupMargins(object name, object top, object bottom, object left, object right)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupMargins", new object[]{ name, top, bottom, left, right });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupHeader(object name, object alignment, object text)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupHeader", name, alignment, text);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupHeader(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupHeader", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupHeader(object name, object alignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupHeader", name, alignment);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupFooter(object name, object alignment, object text)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupFooter", name, alignment, text);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupFooter(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupFooter", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupFooter(object name, object alignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupFooter", name, alignment);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">object text</param>
		/// <param name="labelFontName">object labelFontName</param>
		/// <param name="labelFontSize">object labelFontSize</param>
		/// <param name="labelFontBold">object labelFontBold</param>
		/// <param name="labelFontItalic">object labelFontItalic</param>
		/// <param name="labelFontUnderline">object labelFontUnderline</param>
		/// <param name="labelFontColor">optional NetOffice.MSProjectApi.Enums.PjColor LabelFontColor = -1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupLegend(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize, object labelFontBold, object labelFontItalic, object labelFontUnderline, object labelFontColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegend", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize, labelFontBold, labelFontItalic, labelFontUnderline, labelFontColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">object text</param>
		/// <param name="labelFontName">object labelFontName</param>
		/// <param name="labelFontSize">object labelFontSize</param>
		/// <param name="labelFontBold">object labelFontBold</param>
		/// <param name="labelFontItalic">object labelFontItalic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupLegend(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize, object labelFontBold, object labelFontItalic)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegend", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize, labelFontBold, labelFontItalic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">object text</param>
		/// <param name="labelFontName">object labelFontName</param>
		/// <param name="labelFontSize">object labelFontSize</param>
		/// <param name="labelFontBold">object labelFontBold</param>
		/// <param name="labelFontItalic">object labelFontItalic</param>
		/// <param name="labelFontUnderline">object labelFontUnderline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupLegend(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize, object labelFontBold, object labelFontItalic, object labelFontUnderline)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegend", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize, labelFontBold, labelFontItalic, labelFontUnderline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="allSheetColumns">optional object allSheetColumns</param>
		/// <param name="repeatColumns">optional object repeatColumns</param>
		/// <param name="printNotes">optional object printNotes</param>
		/// <param name="printBlankPages">optional object printBlankPages</param>
		/// <param name="bestPageFitTimescale">optional object bestPageFitTimescale</param>
		/// <param name="printColumnTotals">optional object printColumnTotals</param>
		/// <param name="printRowTotals">optional object printRowTotals</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name, object allSheetColumns, object repeatColumns, object printNotes, object printBlankPages, object bestPageFitTimescale, object printColumnTotals, object printRowTotals)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", new object[]{ name, allSheetColumns, repeatColumns, printNotes, printBlankPages, bestPageFitTimescale, printColumnTotals, printRowTotals });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="allSheetColumns">optional object allSheetColumns</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name, object allSheetColumns)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", name, allSheetColumns);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="allSheetColumns">optional object allSheetColumns</param>
		/// <param name="repeatColumns">optional object repeatColumns</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name, object allSheetColumns, object repeatColumns)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", name, allSheetColumns, repeatColumns);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="allSheetColumns">optional object allSheetColumns</param>
		/// <param name="repeatColumns">optional object repeatColumns</param>
		/// <param name="printNotes">optional object printNotes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name, object allSheetColumns, object repeatColumns, object printNotes)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", name, allSheetColumns, repeatColumns, printNotes);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="allSheetColumns">optional object allSheetColumns</param>
		/// <param name="repeatColumns">optional object repeatColumns</param>
		/// <param name="printNotes">optional object printNotes</param>
		/// <param name="printBlankPages">optional object printBlankPages</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name, object allSheetColumns, object repeatColumns, object printNotes, object printBlankPages)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", new object[]{ name, allSheetColumns, repeatColumns, printNotes, printBlankPages });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="allSheetColumns">optional object allSheetColumns</param>
		/// <param name="repeatColumns">optional object repeatColumns</param>
		/// <param name="printNotes">optional object printNotes</param>
		/// <param name="printBlankPages">optional object printBlankPages</param>
		/// <param name="bestPageFitTimescale">optional object bestPageFitTimescale</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name, object allSheetColumns, object repeatColumns, object printNotes, object printBlankPages, object bestPageFitTimescale)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", new object[]{ name, allSheetColumns, repeatColumns, printNotes, printBlankPages, bestPageFitTimescale });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="allSheetColumns">optional object allSheetColumns</param>
		/// <param name="repeatColumns">optional object repeatColumns</param>
		/// <param name="printNotes">optional object printNotes</param>
		/// <param name="printBlankPages">optional object printBlankPages</param>
		/// <param name="bestPageFitTimescale">optional object bestPageFitTimescale</param>
		/// <param name="printColumnTotals">optional object printColumnTotals</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupView(object name, object allSheetColumns, object repeatColumns, object printNotes, object printBlankPages, object bestPageFitTimescale, object printColumnTotals)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupView", new object[]{ name, allSheetColumns, repeatColumns, printNotes, printBlankPages, bestPageFitTimescale, printColumnTotals });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		/// <param name="onlyDaysInMonth">optional object onlyDaysInMonth</param>
		/// <param name="onlyWeeksInMonth">optional object onlyWeeksInMonth</param>
		/// <param name="monthPreviews">optional object monthPreviews</param>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="additionalTasks">optional object additionalTasks</param>
		/// <param name="groupAdditionalTasks">optional object groupAdditionalTasks</param>
		/// <param name="printNotes">optional object printNotes</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight, object onlyDaysInMonth, object onlyWeeksInMonth, object monthPreviews, object monthTitle, object additionalTasks, object groupAdditionalTasks, object printNotes)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", new object[]{ name, monthsPerPage, weeksPerPage, screenWeekHeight, onlyDaysInMonth, onlyWeeksInMonth, monthPreviews, monthTitle, additionalTasks, groupAdditionalTasks, printNotes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", name, monthsPerPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", name, monthsPerPage, weeksPerPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", name, monthsPerPage, weeksPerPage, screenWeekHeight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		/// <param name="onlyDaysInMonth">optional object onlyDaysInMonth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight, object onlyDaysInMonth)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", new object[]{ name, monthsPerPage, weeksPerPage, screenWeekHeight, onlyDaysInMonth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		/// <param name="onlyDaysInMonth">optional object onlyDaysInMonth</param>
		/// <param name="onlyWeeksInMonth">optional object onlyWeeksInMonth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight, object onlyDaysInMonth, object onlyWeeksInMonth)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", new object[]{ name, monthsPerPage, weeksPerPage, screenWeekHeight, onlyDaysInMonth, onlyWeeksInMonth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		/// <param name="onlyDaysInMonth">optional object onlyDaysInMonth</param>
		/// <param name="onlyWeeksInMonth">optional object onlyWeeksInMonth</param>
		/// <param name="monthPreviews">optional object monthPreviews</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight, object onlyDaysInMonth, object onlyWeeksInMonth, object monthPreviews)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", new object[]{ name, monthsPerPage, weeksPerPage, screenWeekHeight, onlyDaysInMonth, onlyWeeksInMonth, monthPreviews });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		/// <param name="onlyDaysInMonth">optional object onlyDaysInMonth</param>
		/// <param name="onlyWeeksInMonth">optional object onlyWeeksInMonth</param>
		/// <param name="monthPreviews">optional object monthPreviews</param>
		/// <param name="monthTitle">optional object monthTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight, object onlyDaysInMonth, object onlyWeeksInMonth, object monthPreviews, object monthTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", new object[]{ name, monthsPerPage, weeksPerPage, screenWeekHeight, onlyDaysInMonth, onlyWeeksInMonth, monthPreviews, monthTitle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		/// <param name="onlyDaysInMonth">optional object onlyDaysInMonth</param>
		/// <param name="onlyWeeksInMonth">optional object onlyWeeksInMonth</param>
		/// <param name="monthPreviews">optional object monthPreviews</param>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="additionalTasks">optional object additionalTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight, object onlyDaysInMonth, object onlyWeeksInMonth, object monthPreviews, object monthTitle, object additionalTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", new object[]{ name, monthsPerPage, weeksPerPage, screenWeekHeight, onlyDaysInMonth, onlyWeeksInMonth, monthPreviews, monthTitle, additionalTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="monthsPerPage">optional object monthsPerPage</param>
		/// <param name="weeksPerPage">optional object weeksPerPage</param>
		/// <param name="screenWeekHeight">optional object screenWeekHeight</param>
		/// <param name="onlyDaysInMonth">optional object onlyDaysInMonth</param>
		/// <param name="onlyWeeksInMonth">optional object onlyWeeksInMonth</param>
		/// <param name="monthPreviews">optional object monthPreviews</param>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="additionalTasks">optional object additionalTasks</param>
		/// <param name="groupAdditionalTasks">optional object groupAdditionalTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendar(object name, object monthsPerPage, object weeksPerPage, object screenWeekHeight, object onlyDaysInMonth, object onlyWeeksInMonth, object monthPreviews, object monthTitle, object additionalTasks, object groupAdditionalTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendar", new object[]{ name, monthsPerPage, weeksPerPage, screenWeekHeight, onlyDaysInMonth, onlyWeeksInMonth, monthPreviews, monthTitle, additionalTasks, groupAdditionalTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name, object item, object font, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", new object[]{ name, item, font, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name, object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", name, item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name, object item, object font)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", name, item, font);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name, object item, object font, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", name, item, font, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name, object item, object font, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", new object[]{ name, item, font, size, bold });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name, object item, object font, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", new object[]{ name, item, font, size, bold, italic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilePageSetupCalendarText(object name, object item, object font, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarText", new object[]{ name, item, font, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="any">optional object any</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailOpen(object any)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailOpen", any);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailOpen()
		{
			return Factory.ExecuteBoolMethodGet(this, "MailOpen");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="enclosures">optional object enclosures</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="returnReceipt">optional object returnReceipt</param>
		/// <param name="bcc">optional object bcc</param>
		/// <param name="urgent">optional object urgent</param>
		/// <param name="saveCopy">optional object saveCopy</param>
		/// <param name="addRecipient">optional object addRecipient</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body, object enclosures, object includeDocument, object returnReceipt, object bcc, object urgent, object saveCopy, object addRecipient)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", new object[]{ to, cc, subject, body, enclosures, includeDocument, returnReceipt, bcc, urgent, saveCopy, addRecipient });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend()
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", to);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", to, cc);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", to, cc, subject);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", to, cc, subject, body);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="enclosures">optional object enclosures</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body, object enclosures)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", new object[]{ to, cc, subject, body, enclosures });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="enclosures">optional object enclosures</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body, object enclosures, object includeDocument)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", new object[]{ to, cc, subject, body, enclosures, includeDocument });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="enclosures">optional object enclosures</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="returnReceipt">optional object returnReceipt</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body, object enclosures, object includeDocument, object returnReceipt)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", new object[]{ to, cc, subject, body, enclosures, includeDocument, returnReceipt });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="enclosures">optional object enclosures</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="returnReceipt">optional object returnReceipt</param>
		/// <param name="bcc">optional object bcc</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body, object enclosures, object includeDocument, object returnReceipt, object bcc)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", new object[]{ to, cc, subject, body, enclosures, includeDocument, returnReceipt, bcc });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="enclosures">optional object enclosures</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="returnReceipt">optional object returnReceipt</param>
		/// <param name="bcc">optional object bcc</param>
		/// <param name="urgent">optional object urgent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body, object enclosures, object includeDocument, object returnReceipt, object bcc, object urgent)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", new object[]{ to, cc, subject, body, enclosures, includeDocument, returnReceipt, bcc, urgent });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="cc">optional object cc</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="enclosures">optional object enclosures</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="returnReceipt">optional object returnReceipt</param>
		/// <param name="bcc">optional object bcc</param>
		/// <param name="urgent">optional object urgent</param>
		/// <param name="saveCopy">optional object saveCopy</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSend(object to, object cc, object subject, object body, object enclosures, object includeDocument, object returnReceipt, object bcc, object urgent, object saveCopy)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSend", new object[]{ to, cc, subject, body, enclosures, includeDocument, returnReceipt, bcc, urgent, saveCopy });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		/// <param name="resources">optional object resources</param>
		/// <param name="taskContacts">optional object taskContacts</param>
		/// <param name="selection">optional object selection</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="includePicture">optional object includePicture</param>
		/// <param name="body">optional object body</param>
		/// <param name="subject">optional object subject</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager, object resources, object taskContacts, object selection, object includeDocument, object includePicture, object body, object subject)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", new object[]{ manager, resources, taskContacts, selection, includeDocument, includePicture, body, subject });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote()
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", manager);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		/// <param name="resources">optional object resources</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager, object resources)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", manager, resources);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		/// <param name="resources">optional object resources</param>
		/// <param name="taskContacts">optional object taskContacts</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager, object resources, object taskContacts)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", manager, resources, taskContacts);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		/// <param name="resources">optional object resources</param>
		/// <param name="taskContacts">optional object taskContacts</param>
		/// <param name="selection">optional object selection</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager, object resources, object taskContacts, object selection)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", manager, resources, taskContacts, selection);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		/// <param name="resources">optional object resources</param>
		/// <param name="taskContacts">optional object taskContacts</param>
		/// <param name="selection">optional object selection</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager, object resources, object taskContacts, object selection, object includeDocument)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", new object[]{ manager, resources, taskContacts, selection, includeDocument });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		/// <param name="resources">optional object resources</param>
		/// <param name="taskContacts">optional object taskContacts</param>
		/// <param name="selection">optional object selection</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="includePicture">optional object includePicture</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager, object resources, object taskContacts, object selection, object includeDocument, object includePicture)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", new object[]{ manager, resources, taskContacts, selection, includeDocument, includePicture });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="manager">optional object manager</param>
		/// <param name="resources">optional object resources</param>
		/// <param name="taskContacts">optional object taskContacts</param>
		/// <param name="selection">optional object selection</param>
		/// <param name="includeDocument">optional object includeDocument</param>
		/// <param name="includePicture">optional object includePicture</param>
		/// <param name="body">optional object body</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendScheduleNote(object manager, object resources, object taskContacts, object selection, object includeDocument, object includePicture, object body)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendScheduleNote", new object[]{ manager, resources, taskContacts, selection, includeDocument, includePicture, body });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailPostDocument()
		{
			return Factory.ExecuteBoolMethodGet(this, "MailPostDocument");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ODBCManageDataSources()
		{
			return Factory.ExecuteBoolMethodGet(this, "ODBCManageDataSources");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ODBCCreateDataSource()
		{
			return Factory.ExecuteBoolMethodGet(this, "ODBCCreateDataSource");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="allAtOnce">optional object allAtOnce</param>
		/// <param name="returnWhenDone">optional object returnWhenDone</param>
		/// <param name="trackStatus">optional object trackStatus</param>
		/// <param name="clear">optional object clear</param>
		/// <param name="sendNow">optional object sendNow</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to, object subject, object body, object allAtOnce, object returnWhenDone, object trackStatus, object clear, object sendNow)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", new object[]{ to, subject, body, allAtOnce, returnWhenDone, trackStatus, clear, sendNow });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip()
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", to);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="subject">optional object subject</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to, object subject)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", to, subject);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to, object subject, object body)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", to, subject, body);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="allAtOnce">optional object allAtOnce</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to, object subject, object body, object allAtOnce)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", to, subject, body, allAtOnce);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="allAtOnce">optional object allAtOnce</param>
		/// <param name="returnWhenDone">optional object returnWhenDone</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to, object subject, object body, object allAtOnce, object returnWhenDone)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", new object[]{ to, subject, body, allAtOnce, returnWhenDone });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="allAtOnce">optional object allAtOnce</param>
		/// <param name="returnWhenDone">optional object returnWhenDone</param>
		/// <param name="trackStatus">optional object trackStatus</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to, object subject, object body, object allAtOnce, object returnWhenDone, object trackStatus)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", new object[]{ to, subject, body, allAtOnce, returnWhenDone, trackStatus });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="to">optional object to</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="allAtOnce">optional object allAtOnce</param>
		/// <param name="returnWhenDone">optional object returnWhenDone</param>
		/// <param name="trackStatus">optional object trackStatus</param>
		/// <param name="clear">optional object clear</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailRoutingSlip(object to, object subject, object body, object allAtOnce, object returnWhenDone, object trackStatus, object clear)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailRoutingSlip", new object[]{ to, subject, body, allAtOnce, returnWhenDone, trackStatus, clear });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="number">optional object number</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileLoadLast(object number)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileLoadLast", number);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileLoadLast()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileLoadLast");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileExit(object save)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileExit", save);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileExit()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileExit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBars()
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBars");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="copy">optional object copy</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="newName">optional object newName</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarEdit(object copy, object create, object name, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarEdit", copy, create, name, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarEdit()
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarEdit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="copy">optional object copy</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarEdit(object copy)
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarEdit", copy);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="copy">optional object copy</param>
		/// <param name="create">optional object create</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarEdit(object copy, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarEdit", copy, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="copy">optional object copy</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarEdit(object copy, object create, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarEdit", copy, create, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="_default">optional object default</param>
		/// <param name="noFiles">optional object noFiles</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarApply(string name, object _default, object noFiles)
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarApply", name, _default, noFiles);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarApply(string name)
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarApply", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="_default">optional object default</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MenuBarApply(string name, object _default)
		{
			return Factory.ExecuteBoolMethodGet(this, "MenuBarApply", name, _default);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditUndo()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditUndo");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditCut()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditCut");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditCopy()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditCopy");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="_object">object object</param>
		/// <param name="forPrinter">object forPrinter</param>
		/// <param name="selectedRows">object selectedRows</param>
		/// <param name="fromDate">object fromDate</param>
		/// <param name="toDate">object toDate</param>
		/// <param name="fileName">object fileName</param>
		/// <param name="scaleOption">optional NetOffice.MSProjectApi.Enums.PjCopyPictureScaleOption ScaleOption = 1</param>
		/// <param name="maxImageHeight">optional object maxImageHeight</param>
		/// <param name="maxImageWidth">optional object maxImageWidth</param>
		/// <param name="measurementUnits">optional object measurementUnits</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditCopyPicture(object _object, object forPrinter, object selectedRows, object fromDate, object toDate, object fileName, object scaleOption, object maxImageHeight, object maxImageWidth, object measurementUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditCopyPicture", new object[]{ _object, forPrinter, selectedRows, fromDate, toDate, fileName, scaleOption, maxImageHeight, maxImageWidth, measurementUnits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="_object">object object</param>
		/// <param name="forPrinter">object forPrinter</param>
		/// <param name="selectedRows">object selectedRows</param>
		/// <param name="fromDate">object fromDate</param>
		/// <param name="toDate">object toDate</param>
		/// <param name="fileName">object fileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditCopyPicture(object _object, object forPrinter, object selectedRows, object fromDate, object toDate, object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditCopyPicture", new object[]{ _object, forPrinter, selectedRows, fromDate, toDate, fileName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="_object">object object</param>
		/// <param name="forPrinter">object forPrinter</param>
		/// <param name="selectedRows">object selectedRows</param>
		/// <param name="fromDate">object fromDate</param>
		/// <param name="toDate">object toDate</param>
		/// <param name="fileName">object fileName</param>
		/// <param name="scaleOption">optional NetOffice.MSProjectApi.Enums.PjCopyPictureScaleOption ScaleOption = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditCopyPicture(object _object, object forPrinter, object selectedRows, object fromDate, object toDate, object fileName, object scaleOption)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditCopyPicture", new object[]{ _object, forPrinter, selectedRows, fromDate, toDate, fileName, scaleOption });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="_object">object object</param>
		/// <param name="forPrinter">object forPrinter</param>
		/// <param name="selectedRows">object selectedRows</param>
		/// <param name="fromDate">object fromDate</param>
		/// <param name="toDate">object toDate</param>
		/// <param name="fileName">object fileName</param>
		/// <param name="scaleOption">optional NetOffice.MSProjectApi.Enums.PjCopyPictureScaleOption ScaleOption = 1</param>
		/// <param name="maxImageHeight">optional object maxImageHeight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditCopyPicture(object _object, object forPrinter, object selectedRows, object fromDate, object toDate, object fileName, object scaleOption, object maxImageHeight)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditCopyPicture", new object[]{ _object, forPrinter, selectedRows, fromDate, toDate, fileName, scaleOption, maxImageHeight });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="_object">object object</param>
		/// <param name="forPrinter">object forPrinter</param>
		/// <param name="selectedRows">object selectedRows</param>
		/// <param name="fromDate">object fromDate</param>
		/// <param name="toDate">object toDate</param>
		/// <param name="fileName">object fileName</param>
		/// <param name="scaleOption">optional NetOffice.MSProjectApi.Enums.PjCopyPictureScaleOption ScaleOption = 1</param>
		/// <param name="maxImageHeight">optional object maxImageHeight</param>
		/// <param name="maxImageWidth">optional object maxImageWidth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditCopyPicture(object _object, object forPrinter, object selectedRows, object fromDate, object toDate, object fileName, object scaleOption, object maxImageHeight, object maxImageWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditCopyPicture", new object[]{ _object, forPrinter, selectedRows, fromDate, toDate, fileName, scaleOption, maxImageHeight, maxImageWidth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditPaste()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditPaste");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="link">optional object link</param>
		/// <param name="type">optional object type</param>
		/// <param name="displayAsIcon">optional object displayAsIcon</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditPasteSpecial(object link, object type, object displayAsIcon)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditPasteSpecial", link, type, displayAsIcon);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditPasteSpecial()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditPasteSpecial");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="link">optional object link</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditPasteSpecial(object link)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditPasteSpecial", link);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="link">optional object link</param>
		/// <param name="type">optional object type</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditPasteSpecial(object link, object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditPasteSpecial", link, type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditClearFormats()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditClearFormats");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="contents">optional object contents</param>
		/// <param name="formats">optional object formats</param>
		/// <param name="notes">optional object notes</param>
		/// <param name="hyperlinks">optional object hyperlinks</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditClear(object contents, object formats, object notes, object hyperlinks)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditClear", contents, formats, notes, hyperlinks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditClear()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditClear");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="contents">optional object contents</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditClear(object contents)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditClear", contents);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="contents">optional object contents</param>
		/// <param name="formats">optional object formats</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditClear(object contents, object formats)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditClear", contents, formats);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="contents">optional object contents</param>
		/// <param name="formats">optional object formats</param>
		/// <param name="notes">optional object notes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditClear(object contents, object formats, object notes)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditClear", contents, formats, notes);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool RowClear()
		{
			return Factory.ExecuteBoolMethodGet(this, "RowClear");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DDEPasteLink()
		{
			return Factory.ExecuteBoolMethodGet(this, "DDEPasteLink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditDelete()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditDelete");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ColumnDelete()
		{
			return Factory.ExecuteBoolMethodGet(this, "ColumnDelete");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool RowDelete()
		{
			return Factory.ExecuteBoolMethodGet(this, "RowDelete");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="verb">optional object verb</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ObjectVerb(object verb)
		{
			return Factory.ExecuteBoolMethodGet(this, "ObjectVerb", verb);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ObjectVerb()
		{
			return Factory.ExecuteBoolMethodGet(this, "ObjectVerb");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ObjectLinks()
		{
			return Factory.ExecuteBoolMethodGet(this, "ObjectLinks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ObjectChangeIcon()
		{
			return Factory.ExecuteBoolMethodGet(this, "ObjectChangeIcon");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ObjectConvert()
		{
			return Factory.ExecuteBoolMethodGet(this, "ObjectConvert");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditInsert()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditInsert");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ColumnInsert()
		{
			return Factory.ExecuteBoolMethodGet(this, "ColumnInsert");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool RowInsert()
		{
			return Factory.ExecuteBoolMethodGet(this, "RowInsert");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinkTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="from">Int32 from</param>
		/// <param name="to">Int32 to</param>
		/// <param name="delete">optional object delete</param>
		/// <param name="type">optional object type</param>
		/// <param name="lag">optional object lag</param>
		/// <param name="predecessorProjectName">optional object predecessorProjectName</param>
		/// <param name="successorProjectName">optional object successorProjectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinkTasksEdit(Int32 from, Int32 to, object delete, object type, object lag, object predecessorProjectName, object successorProjectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkTasksEdit", new object[]{ from, to, delete, type, lag, predecessorProjectName, successorProjectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="from">Int32 from</param>
		/// <param name="to">Int32 to</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinkTasksEdit(Int32 from, Int32 to)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkTasksEdit", from, to);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="from">Int32 from</param>
		/// <param name="to">Int32 to</param>
		/// <param name="delete">optional object delete</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinkTasksEdit(Int32 from, Int32 to, object delete)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkTasksEdit", from, to, delete);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="from">Int32 from</param>
		/// <param name="to">Int32 to</param>
		/// <param name="delete">optional object delete</param>
		/// <param name="type">optional object type</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinkTasksEdit(Int32 from, Int32 to, object delete, object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkTasksEdit", from, to, delete, type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="from">Int32 from</param>
		/// <param name="to">Int32 to</param>
		/// <param name="delete">optional object delete</param>
		/// <param name="type">optional object type</param>
		/// <param name="lag">optional object lag</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinkTasksEdit(Int32 from, Int32 to, object delete, object type, object lag)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkTasksEdit", new object[]{ from, to, delete, type, lag });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="from">Int32 from</param>
		/// <param name="to">Int32 to</param>
		/// <param name="delete">optional object delete</param>
		/// <param name="type">optional object type</param>
		/// <param name="lag">optional object lag</param>
		/// <param name="predecessorProjectName">optional object predecessorProjectName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinkTasksEdit(Int32 from, Int32 to, object delete, object type, object lag, object predecessorProjectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkTasksEdit", new object[]{ from, to, delete, type, lag, predecessorProjectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UnlinkTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "UnlinkTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="resources">object resources</param>
		/// <param name="operation">optional NetOffice.MSProjectApi.Enums.PjResAssignOperation Operation = 0</param>
		/// <param name="with">optional object with</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignment(object resources, object operation, object with)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignment", resources, operation, with);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="resources">object resources</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignment(object resources)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignment", resources);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="resources">object resources</param>
		/// <param name="operation">optional NetOffice.MSProjectApi.Enums.PjResAssignOperation Operation = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignment(object resources, object operation)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignment", resources, operation);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="iD">optional object iD</param>
		/// <param name="date">optional object date</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditGoTo(object iD, object date)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditGoTo", iD, date);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditGoTo()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditGoTo");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="iD">optional object iD</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditGoTo(object iD)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditGoTo", iD);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GotoNextOverAllocation()
		{
			return Factory.ExecuteBoolMethodGet(this, "GotoNextOverAllocation");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InsertNotes()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertNotes");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="testID">optional object testID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find(object field, object test, object value, object next, object matchCase, object fieldID, object testID)
		{
			return Factory.ExecuteBoolMethodGet(this, "Find", new object[]{ field, test, value, next, matchCase, fieldID, testID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find()
		{
			return Factory.ExecuteBoolMethodGet(this, "Find");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find(object field)
		{
			return Factory.ExecuteBoolMethodGet(this, "Find", field);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find(object field, object test)
		{
			return Factory.ExecuteBoolMethodGet(this, "Find", field, test);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find(object field, object test, object value)
		{
			return Factory.ExecuteBoolMethodGet(this, "Find", field, test, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find(object field, object test, object value, object next)
		{
			return Factory.ExecuteBoolMethodGet(this, "Find", field, test, value, next);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find(object field, object test, object value, object next, object matchCase)
		{
			return Factory.ExecuteBoolMethodGet(this, "Find", new object[]{ field, test, value, next, matchCase });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Find(object field, object test, object value, object next, object matchCase, object fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "Find", new object[]{ field, test, value, next, matchCase, fieldID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="testID">optional object testID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test, object value, object replacement, object replaceAll, object next, object matchCase, object fieldID, object testID)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", new object[]{ field, test, value, replacement, replaceAll, next, matchCase, fieldID, testID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace()
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", field);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", field, test);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test, object value)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", field, test, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test, object value, object replacement)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", field, test, value, replacement);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test, object value, object replacement, object replaceAll)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", new object[]{ field, test, value, replacement, replaceAll });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test, object value, object replacement, object replaceAll, object next)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", new object[]{ field, test, value, replacement, replaceAll, next });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test, object value, object replacement, object replaceAll, object next, object matchCase)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", new object[]{ field, test, value, replacement, replaceAll, next, matchCase });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Replace(object field, object test, object value, object replacement, object replaceAll, object next, object matchCase, object fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "Replace", new object[]{ field, test, value, replacement, replaceAll, next, matchCase, fieldID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectAll()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectAll");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ObjectInsert()
		{
			return Factory.ExecuteBoolMethodGet(this, "ObjectInsert");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="edition">object edition</param>
		/// <param name="format">optional NetOffice.MSProjectApi.Enums.PjSubscribeFormat Format = 1</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscribeTo(object edition, object format)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscribeTo", edition, format);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="edition">object edition</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscribeTo(object edition)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscribeTo", edition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		/// <param name="field">optional object field</param>
		/// <param name="automatically">optional object automatically</param>
		/// <param name="action">optional object action</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscriberOptions(object name, object isTask, object uniqueID, object field, object automatically, object action)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscriberOptions", new object[]{ name, isTask, uniqueID, field, automatically, action });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscriberOptions()
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscriberOptions");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscriberOptions(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscriberOptions", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="isTask">optional object isTask</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscriberOptions(object name, object isTask)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscriberOptions", name, isTask);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscriberOptions(object name, object isTask, object uniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscriberOptions", name, isTask, uniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		/// <param name="field">optional object field</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscriberOptions(object name, object isTask, object uniqueID, object field)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscriberOptions", name, isTask, uniqueID, field);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		/// <param name="field">optional object field</param>
		/// <param name="automatically">optional object automatically</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SubscriberOptions(object name, object isTask, object uniqueID, object field, object automatically)
		{
			return Factory.ExecuteBoolMethodGet(this, "SubscriberOptions", new object[]{ name, isTask, uniqueID, field, automatically });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="edition">optional object edition</param>
		/// <param name="contains">optional object contains</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreatePublisher(object edition, object contains)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreatePublisher", edition, contains);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreatePublisher()
		{
			return Factory.ExecuteBoolMethodGet(this, "CreatePublisher");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="edition">optional object edition</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreatePublisher(object edition)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreatePublisher", edition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="view">optional object view</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		/// <param name="field">optional object field</param>
		/// <param name="onSave">optional object onSave</param>
		/// <param name="action">optional object action</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions(object name, object view, object isTask, object uniqueID, object field, object onSave, object action)
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions", new object[]{ name, view, isTask, uniqueID, field, onSave, action });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions()
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="view">optional object view</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions(object name, object view)
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions", name, view);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="view">optional object view</param>
		/// <param name="isTask">optional object isTask</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions(object name, object view, object isTask)
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions", name, view, isTask);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="view">optional object view</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions(object name, object view, object isTask, object uniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions", name, view, isTask, uniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="view">optional object view</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		/// <param name="field">optional object field</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions(object name, object view, object isTask, object uniqueID, object field)
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions", new object[]{ name, view, isTask, uniqueID, field });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="view">optional object view</param>
		/// <param name="isTask">optional object isTask</param>
		/// <param name="uniqueID">optional object uniqueID</param>
		/// <param name="field">optional object field</param>
		/// <param name="onSave">optional object onSave</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PublisherOptions(object name, object view, object isTask, object uniqueID, object field, object onSave)
		{
			return Factory.ExecuteBoolMethodGet(this, "PublisherOptions", new object[]{ name, view, isTask, uniqueID, field, onSave });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="stop">optional object stop</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditionStopAll(object stop)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditionStopAll", stop);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditionStopAll()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditionStopAll");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ClipboardShow()
		{
			return Factory.ExecuteBoolMethodGet(this, "ClipboardShow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="singlePane">optional object singlePane</param>
		/// <param name="toggle">optional object toggle</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewApply(object name, object singlePane, object toggle)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewApply", name, singlePane, toggle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewApply()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewApply");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewApply(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewApply", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="singlePane">optional object singlePane</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewApply(object name, object singlePane)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewApply", name, singlePane);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="screen">optional object screen</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="highlightFilter">optional object highlightFilter</param>
		/// <param name="table">optional object table</param>
		/// <param name="filter">optional object filter</param>
		/// <param name="group">optional object group</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create, object newName, object screen, object showInMenu, object highlightFilter, object table, object filter, object group)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", new object[]{ name, create, newName, screen, showInMenu, highlightFilter, table, filter, group });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", name, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", name, create, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="screen">optional object screen</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create, object newName, object screen)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", name, create, newName, screen);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="screen">optional object screen</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create, object newName, object screen, object showInMenu)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", new object[]{ name, create, newName, screen, showInMenu });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="screen">optional object screen</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="highlightFilter">optional object highlightFilter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create, object newName, object screen, object showInMenu, object highlightFilter)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", new object[]{ name, create, newName, screen, showInMenu, highlightFilter });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="screen">optional object screen</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="highlightFilter">optional object highlightFilter</param>
		/// <param name="table">optional object table</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create, object newName, object screen, object showInMenu, object highlightFilter, object table)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", new object[]{ name, create, newName, screen, showInMenu, highlightFilter, table });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="screen">optional object screen</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="highlightFilter">optional object highlightFilter</param>
		/// <param name="table">optional object table</param>
		/// <param name="filter">optional object filter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditSingle(object name, object create, object newName, object screen, object showInMenu, object highlightFilter, object table, object filter)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditSingle", new object[]{ name, create, newName, screen, showInMenu, highlightFilter, table, filter });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="topView">optional object topView</param>
		/// <param name="bottomView">optional object bottomView</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditCombination(object name, object create, object newName, object topView, object bottomView, object showInMenu)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditCombination", new object[]{ name, create, newName, topView, bottomView, showInMenu });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditCombination()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditCombination");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditCombination(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditCombination", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditCombination(object name, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditCombination", name, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditCombination(object name, object create, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditCombination", name, create, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="topView">optional object topView</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditCombination(object name, object create, object newName, object topView)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditCombination", name, create, newName, topView);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="topView">optional object topView</param>
		/// <param name="bottomView">optional object bottomView</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewEditCombination(object name, object create, object newName, object topView, object bottomView)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewEditCombination", new object[]{ name, create, newName, topView, bottomView });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableApply(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableApply", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableApply()
		{
			return Factory.ExecuteBoolMethodGet(this, "TableApply");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		/// <param name="headerAutoRowHeightAdjustment">optional object headerAutoRowHeightAdjustment</param>
		/// <param name="headerTextWrap">optional object headerTextWrap</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle, object headerAutoRowHeightAdjustment, object headerTextWrap)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle, headerAutoRowHeightAdjustment, headerTextWrap });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", name, taskTable);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", name, taskTable, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", name, taskTable, create, overwriteExisting);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		/// <param name="headerAutoRowHeightAdjustment">optional object headerAutoRowHeightAdjustment</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TableEdit(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle, object headerAutoRowHeightAdjustment)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEdit", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle, headerAutoRowHeightAdjustment });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="highlight">optional object highlight</param>
		/// <param name="value1">optional object value1</param>
		/// <param name="value2">optional object value2</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterApply(object name, object highlight, object value1, object value2)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterApply", name, highlight, value1, value2);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterApply()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterApply");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterApply(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterApply", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="highlight">optional object highlight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterApply(object name, object highlight)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterApply", name, highlight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="highlight">optional object highlight</param>
		/// <param name="value1">optional object value1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterApply(object name, object highlight, object value1)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterApply", name, highlight, value1);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="operation">optional object operation</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="showSummaryTasks">optional object showSummaryTasks</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName, object fieldName, object newFieldName, object test, object value, object operation, object showInMenu, object showSummaryTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName, fieldName, newFieldName, test, value, operation, showInMenu, showSummaryTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", name, taskFilter);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", name, taskFilter, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", name, taskFilter, create, overwriteExisting);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName, object fieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName, fieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName, object fieldName, object newFieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName, fieldName, newFieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="test">optional object test</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName, object fieldName, object newFieldName, object test)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName, fieldName, newFieldName, test });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName, object fieldName, object newFieldName, object test, object value)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName, fieldName, newFieldName, test, value });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="operation">optional object operation</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName, object fieldName, object newFieldName, object test, object value, object operation)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName, fieldName, newFieldName, test, value, operation });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskFilter">bool taskFilter</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="parenthesis">optional object parenthesis</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="operation">optional object operation</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FilterEdit(string name, bool taskFilter, object create, object overwriteExisting, object parenthesis, object newName, object fieldName, object newFieldName, object test, object value, object operation, object showInMenu)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterEdit", new object[]{ name, taskFilter, create, overwriteExisting, parenthesis, newName, fieldName, newFieldName, test, value, operation, showInMenu });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		/// <param name="finish">optional object finish</param>
		/// <param name="scheduleFrom">optional object scheduleFrom</param>
		/// <param name="currentDate">optional object currentDate</param>
		/// <param name="calendar">optional object calendar</param>
		/// <param name="statusDate">optional object statusDate</param>
		/// <param name="priority">optional object priority</param>
		/// <param name="partiallyDisabled">optional object partiallyDisabled</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start, object finish, object scheduleFrom, object currentDate, object calendar, object statusDate, object priority, object partiallyDisabled)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start, finish, scheduleFrom, currentDate, calendar, statusDate, priority, partiallyDisabled });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo()
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", project);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", project, title);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", project, title, subject);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", project, title, subject, author);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		/// <param name="finish">optional object finish</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start, object finish)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start, finish });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		/// <param name="finish">optional object finish</param>
		/// <param name="scheduleFrom">optional object scheduleFrom</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start, object finish, object scheduleFrom)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start, finish, scheduleFrom });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		/// <param name="finish">optional object finish</param>
		/// <param name="scheduleFrom">optional object scheduleFrom</param>
		/// <param name="currentDate">optional object currentDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start, object finish, object scheduleFrom, object currentDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start, finish, scheduleFrom, currentDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		/// <param name="finish">optional object finish</param>
		/// <param name="scheduleFrom">optional object scheduleFrom</param>
		/// <param name="currentDate">optional object currentDate</param>
		/// <param name="calendar">optional object calendar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start, object finish, object scheduleFrom, object currentDate, object calendar)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start, finish, scheduleFrom, currentDate, calendar });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		/// <param name="finish">optional object finish</param>
		/// <param name="scheduleFrom">optional object scheduleFrom</param>
		/// <param name="currentDate">optional object currentDate</param>
		/// <param name="calendar">optional object calendar</param>
		/// <param name="statusDate">optional object statusDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start, object finish, object scheduleFrom, object currentDate, object calendar, object statusDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start, finish, scheduleFrom, currentDate, calendar, statusDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		/// <param name="title">optional object title</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="author">optional object author</param>
		/// <param name="company">optional object company</param>
		/// <param name="manager">optional object manager</param>
		/// <param name="keywords">optional object keywords</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="start">optional object start</param>
		/// <param name="finish">optional object finish</param>
		/// <param name="scheduleFrom">optional object scheduleFrom</param>
		/// <param name="currentDate">optional object currentDate</param>
		/// <param name="calendar">optional object calendar</param>
		/// <param name="statusDate">optional object statusDate</param>
		/// <param name="priority">optional object priority</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectSummaryInfo(object project, object title, object subject, object author, object company, object manager, object keywords, object comments, object start, object finish, object scheduleFrom, object currentDate, object calendar, object statusDate, object priority)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectSummaryInfo", new object[]{ project, title, subject, author, company, manager, keywords, comments, start, finish, scheduleFrom, currentDate, calendar, statusDate, priority });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="project">optional object project</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectStatistics(object project)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectStatistics", project);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProjectStatistics()
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectStatistics");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		/// <param name="finishTime">optional object finishTime</param>
		/// <param name="hoursPerDay">optional object hoursPerDay</param>
		/// <param name="hoursPerWeek">optional object hoursPerWeek</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="startWeekOn">optional object startWeekOn</param>
		/// <param name="useFYStartYear">optional object useFYStartYear</param>
		/// <param name="daysPerMonth">optional object daysPerMonth</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime, object finishTime, object hoursPerDay, object hoursPerWeek, object setDefaults, object startWeekOn, object useFYStartYear, object daysPerMonth)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", new object[]{ startWeekOnMonday, startYearIn, startTime, finishTime, hoursPerDay, hoursPerWeek, setDefaults, startWeekOn, useFYStartYear, daysPerMonth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", startWeekOnMonday);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", startWeekOnMonday, startYearIn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", startWeekOnMonday, startYearIn, startTime);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		/// <param name="finishTime">optional object finishTime</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime, object finishTime)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", startWeekOnMonday, startYearIn, startTime, finishTime);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		/// <param name="finishTime">optional object finishTime</param>
		/// <param name="hoursPerDay">optional object hoursPerDay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime, object finishTime, object hoursPerDay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", new object[]{ startWeekOnMonday, startYearIn, startTime, finishTime, hoursPerDay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		/// <param name="finishTime">optional object finishTime</param>
		/// <param name="hoursPerDay">optional object hoursPerDay</param>
		/// <param name="hoursPerWeek">optional object hoursPerWeek</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime, object finishTime, object hoursPerDay, object hoursPerWeek)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", new object[]{ startWeekOnMonday, startYearIn, startTime, finishTime, hoursPerDay, hoursPerWeek });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		/// <param name="finishTime">optional object finishTime</param>
		/// <param name="hoursPerDay">optional object hoursPerDay</param>
		/// <param name="hoursPerWeek">optional object hoursPerWeek</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime, object finishTime, object hoursPerDay, object hoursPerWeek, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", new object[]{ startWeekOnMonday, startYearIn, startTime, finishTime, hoursPerDay, hoursPerWeek, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		/// <param name="finishTime">optional object finishTime</param>
		/// <param name="hoursPerDay">optional object hoursPerDay</param>
		/// <param name="hoursPerWeek">optional object hoursPerWeek</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="startWeekOn">optional object startWeekOn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime, object finishTime, object hoursPerDay, object hoursPerWeek, object setDefaults, object startWeekOn)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", new object[]{ startWeekOnMonday, startYearIn, startTime, finishTime, hoursPerDay, hoursPerWeek, setDefaults, startWeekOn });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="startWeekOnMonday">optional object startWeekOnMonday</param>
		/// <param name="startYearIn">optional object startYearIn</param>
		/// <param name="startTime">optional object startTime</param>
		/// <param name="finishTime">optional object finishTime</param>
		/// <param name="hoursPerDay">optional object hoursPerDay</param>
		/// <param name="hoursPerWeek">optional object hoursPerWeek</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="startWeekOn">optional object startWeekOn</param>
		/// <param name="useFYStartYear">optional object useFYStartYear</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalendar(object startWeekOnMonday, object startYearIn, object startTime, object finishTime, object hoursPerDay, object hoursPerWeek, object setDefaults, object startWeekOn, object useFYStartYear)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalendar", new object[]{ startWeekOnMonday, startYearIn, startTime, finishTime, hoursPerDay, hoursPerWeek, setDefaults, startWeekOn, useFYStartYear });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaultsHyperlink">optional object setDefaultsHyperlink</param>
		/// <param name="inCellEditing">optional object inCellEditing</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaultsHyperlink, object inCellEditing)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaultsHyperlink, inCellEditing });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", moveAfterReturn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", moveAfterReturn, dragAndDrop);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", moveAfterReturn, dragAndDrop, updateLinks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaultsHyperlink">optional object setDefaultsHyperlink</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsEdit(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaultsHyperlink)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEdit", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaultsHyperlink });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		/// <param name="recentFilesMaximum">optional object recentFilesMaximum</param>
		/// <param name="fontConversion">optional object fontConversion</param>
		/// <param name="showStartupWorkpane">optional object showStartupWorkpane</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles, object recentFilesMaximum, object fontConversion, object showStartupWorkpane)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles, recentFilesMaximum, fontConversion, showStartupWorkpane });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", planningWizard);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", planningWizard, wizardUsage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", planningWizard, wizardUsage, wizardErrors);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", planningWizard, wizardUsage, wizardErrors, wizardScheduling);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		/// <param name="recentFilesMaximum">optional object recentFilesMaximum</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles, object recentFilesMaximum)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles, recentFilesMaximum });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		/// <param name="recentFilesMaximum">optional object recentFilesMaximum</param>
		/// <param name="fontConversion">optional object fontConversion</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneral(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles, object recentFilesMaximum, object fontConversion)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneral", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles, recentFilesMaximum, fontConversion });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="assignmentUnits">optional object assignmentUnits</param>
		/// <param name="effortDriven">optional object effortDriven</param>
		/// <param name="honorConstraints">optional object honorConstraints</param>
		/// <param name="showEstimated">optional object showEstimated</param>
		/// <param name="newTasksEstimated">optional object newTasksEstimated</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits, object autoTrack, object setDefaults, object assignmentUnits, object effortDriven, object honorConstraints, object showEstimated, object newTasksEstimated)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits, autoTrack, setDefaults, assignmentUnits, effortDriven, honorConstraints, showEstimated, newTasksEstimated });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", scheduleMessages);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", scheduleMessages, startOnCurrentDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", scheduleMessages, startOnCurrentDate, autoLink);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", scheduleMessages, startOnCurrentDate, autoLink, autoSplit);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits, object autoTrack)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits, autoTrack });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits, object autoTrack, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits, autoTrack, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="assignmentUnits">optional object assignmentUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits, object autoTrack, object setDefaults, object assignmentUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits, autoTrack, setDefaults, assignmentUnits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="assignmentUnits">optional object assignmentUnits</param>
		/// <param name="effortDriven">optional object effortDriven</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits, object autoTrack, object setDefaults, object assignmentUnits, object effortDriven)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits, autoTrack, setDefaults, assignmentUnits, effortDriven });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="assignmentUnits">optional object assignmentUnits</param>
		/// <param name="effortDriven">optional object effortDriven</param>
		/// <param name="honorConstraints">optional object honorConstraints</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits, object autoTrack, object setDefaults, object assignmentUnits, object effortDriven, object honorConstraints)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits, autoTrack, setDefaults, assignmentUnits, effortDriven, honorConstraints });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="scheduleMessages">optional object scheduleMessages</param>
		/// <param name="startOnCurrentDate">optional object startOnCurrentDate</param>
		/// <param name="autoLink">optional object autoLink</param>
		/// <param name="autoSplit">optional object autoSplit</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="taskType">optional object taskType</param>
		/// <param name="durationUnits">optional object durationUnits</param>
		/// <param name="workUnits">optional object workUnits</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="assignmentUnits">optional object assignmentUnits</param>
		/// <param name="effortDriven">optional object effortDriven</param>
		/// <param name="honorConstraints">optional object honorConstraints</param>
		/// <param name="showEstimated">optional object showEstimated</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSchedule(object scheduleMessages, object startOnCurrentDate, object autoLink, object autoSplit, object criticalSlack, object taskType, object durationUnits, object workUnits, object autoTrack, object setDefaults, object assignmentUnits, object effortDriven, object honorConstraints, object showEstimated)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSchedule", new object[]{ scheduleMessages, startOnCurrentDate, autoLink, autoSplit, criticalSlack, taskType, durationUnits, workUnits, autoTrack, setDefaults, assignmentUnits, effortDriven, honorConstraints, showEstimated });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		/// <param name="displayWindowsInTaskbar">optional object displayWindowsInTaskbar</param>
		/// <param name="displayScreentips">optional object displayScreentips</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData, object displayWindowsInTaskbar, object displayScreentips)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData, displayWindowsInTaskbar, displayScreentips });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", defaultView);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", defaultView, dateFormat);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", defaultView, dateFormat, projectSummary);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", defaultView, dateFormat, projectSummary, displayStatusBar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		/// <param name="displayWindowsInTaskbar">optional object displayWindowsInTaskbar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsView(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData, object displayWindowsInTaskbar)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsView", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData, displayWindowsInTaskbar });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		/// <param name="updateProjectToWeb">optional object updateProjectToWeb</param>
		/// <param name="publishInformationOnSave">optional object publishInformationOnSave</param>
		/// <param name="setDefaultsMessaging">optional object setDefaultsMessaging</param>
		/// <param name="setDefaultsWebServer">optional object setDefaultsWebServer</param>
		/// <param name="managerEmail">optional object managerEmail</param>
		/// <param name="confirmationDialog">optional object confirmationDialog</param>
		/// <param name="changesMarkAssnDirty">optional object changesMarkAssnDirty</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation, object updateProjectToWeb, object publishInformationOnSave, object setDefaultsMessaging, object setDefaultsWebServer, object managerEmail, object confirmationDialog, object changesMarkAssnDirty)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation, updateProjectToWeb, publishInformationOnSave, setDefaultsMessaging, setDefaultsWebServer, managerEmail, confirmationDialog, changesMarkAssnDirty });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", workgroupMessages);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", workgroupMessages, serverURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", workgroupMessages, serverURL, serverPath);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", workgroupMessages, serverURL, serverPath, receiveNotifications);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		/// <param name="updateProjectToWeb">optional object updateProjectToWeb</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation, object updateProjectToWeb)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation, updateProjectToWeb });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		/// <param name="updateProjectToWeb">optional object updateProjectToWeb</param>
		/// <param name="publishInformationOnSave">optional object publishInformationOnSave</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation, object updateProjectToWeb, object publishInformationOnSave)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation, updateProjectToWeb, publishInformationOnSave });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		/// <param name="updateProjectToWeb">optional object updateProjectToWeb</param>
		/// <param name="publishInformationOnSave">optional object publishInformationOnSave</param>
		/// <param name="setDefaultsMessaging">optional object setDefaultsMessaging</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation, object updateProjectToWeb, object publishInformationOnSave, object setDefaultsMessaging)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation, updateProjectToWeb, publishInformationOnSave, setDefaultsMessaging });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		/// <param name="updateProjectToWeb">optional object updateProjectToWeb</param>
		/// <param name="publishInformationOnSave">optional object publishInformationOnSave</param>
		/// <param name="setDefaultsMessaging">optional object setDefaultsMessaging</param>
		/// <param name="setDefaultsWebServer">optional object setDefaultsWebServer</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation, object updateProjectToWeb, object publishInformationOnSave, object setDefaultsMessaging, object setDefaultsWebServer)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation, updateProjectToWeb, publishInformationOnSave, setDefaultsMessaging, setDefaultsWebServer });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		/// <param name="updateProjectToWeb">optional object updateProjectToWeb</param>
		/// <param name="publishInformationOnSave">optional object publishInformationOnSave</param>
		/// <param name="setDefaultsMessaging">optional object setDefaultsMessaging</param>
		/// <param name="setDefaultsWebServer">optional object setDefaultsWebServer</param>
		/// <param name="managerEmail">optional object managerEmail</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation, object updateProjectToWeb, object publishInformationOnSave, object setDefaultsMessaging, object setDefaultsWebServer, object managerEmail)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation, updateProjectToWeb, publishInformationOnSave, setDefaultsMessaging, setDefaultsWebServer, managerEmail });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="workgroupMessages">optional object workgroupMessages</param>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="serverPath">optional object serverPath</param>
		/// <param name="receiveNotifications">optional object receiveNotifications</param>
		/// <param name="sendHyperlinkNote">optional object sendHyperlinkNote</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="serverIdentification">optional object serverIdentification</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		/// <param name="updateProjectToWeb">optional object updateProjectToWeb</param>
		/// <param name="publishInformationOnSave">optional object publishInformationOnSave</param>
		/// <param name="setDefaultsMessaging">optional object setDefaultsMessaging</param>
		/// <param name="setDefaultsWebServer">optional object setDefaultsWebServer</param>
		/// <param name="managerEmail">optional object managerEmail</param>
		/// <param name="confirmationDialog">optional object confirmationDialog</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsWorkgroup(object workgroupMessages, object serverURL, object serverPath, object receiveNotifications, object sendHyperlinkNote, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaults, object serverIdentification, object allowTaskDelegation, object updateProjectToWeb, object publishInformationOnSave, object setDefaultsMessaging, object setDefaultsWebServer, object managerEmail, object confirmationDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsWorkgroup", new object[]{ workgroupMessages, serverURL, serverPath, receiveNotifications, sendHyperlinkNote, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaults, serverIdentification, allowTaskDelegation, updateProjectToWeb, publishInformationOnSave, setDefaultsMessaging, setDefaultsWebServer, managerEmail, confirmationDialog });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="calcInsProjLikeSummTask">optional object calcInsProjLikeSummTask</param>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		/// <param name="andMoveRemaining">optional object andMoveRemaining</param>
		/// <param name="moveRemaining">optional object moveRemaining</param>
		/// <param name="andMoveCompleted">optional object andMoveCompleted</param>
		/// <param name="eVMethod">optional object eVMethod</param>
		/// <param name="eVBaseline">optional object eVBaseline</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults, object calcInsProjLikeSummTask, object moveCompleted, object andMoveRemaining, object moveRemaining, object andMoveCompleted, object eVMethod, object eVBaseline)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults, calcInsProjLikeSummTask, moveCompleted, andMoveRemaining, moveRemaining, andMoveCompleted, eVMethod, eVBaseline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", automatic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", automatic, autoTrack);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", automatic, autoTrack, spreadPercentToStatusDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="calcInsProjLikeSummTask">optional object calcInsProjLikeSummTask</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults, object calcInsProjLikeSummTask)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults, calcInsProjLikeSummTask });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="calcInsProjLikeSummTask">optional object calcInsProjLikeSummTask</param>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults, object calcInsProjLikeSummTask, object moveCompleted)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults, calcInsProjLikeSummTask, moveCompleted });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="calcInsProjLikeSummTask">optional object calcInsProjLikeSummTask</param>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		/// <param name="andMoveRemaining">optional object andMoveRemaining</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults, object calcInsProjLikeSummTask, object moveCompleted, object andMoveRemaining)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults, calcInsProjLikeSummTask, moveCompleted, andMoveRemaining });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="calcInsProjLikeSummTask">optional object calcInsProjLikeSummTask</param>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		/// <param name="andMoveRemaining">optional object andMoveRemaining</param>
		/// <param name="moveRemaining">optional object moveRemaining</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults, object calcInsProjLikeSummTask, object moveCompleted, object andMoveRemaining, object moveRemaining)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults, calcInsProjLikeSummTask, moveCompleted, andMoveRemaining, moveRemaining });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="calcInsProjLikeSummTask">optional object calcInsProjLikeSummTask</param>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		/// <param name="andMoveRemaining">optional object andMoveRemaining</param>
		/// <param name="moveRemaining">optional object moveRemaining</param>
		/// <param name="andMoveCompleted">optional object andMoveCompleted</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults, object calcInsProjLikeSummTask, object moveCompleted, object andMoveRemaining, object moveRemaining, object andMoveCompleted)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults, calcInsProjLikeSummTask, moveCompleted, andMoveRemaining, moveRemaining, andMoveCompleted });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="autoTrack">optional object autoTrack</param>
		/// <param name="spreadPercentToStatusDate">optional object spreadPercentToStatusDate</param>
		/// <param name="spreadCostsToStatusDate">optional object spreadCostsToStatusDate</param>
		/// <param name="autoCalcCosts">optional object autoCalcCosts</param>
		/// <param name="fixedCostAccrual">optional object fixedCostAccrual</param>
		/// <param name="calcMultipleCriticalPaths">optional object calcMultipleCriticalPaths</param>
		/// <param name="criticalSlack">optional object criticalSlack</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="calcInsProjLikeSummTask">optional object calcInsProjLikeSummTask</param>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		/// <param name="andMoveRemaining">optional object andMoveRemaining</param>
		/// <param name="moveRemaining">optional object moveRemaining</param>
		/// <param name="andMoveCompleted">optional object andMoveCompleted</param>
		/// <param name="eVMethod">optional object eVMethod</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsCalculation(object automatic, object autoTrack, object spreadPercentToStatusDate, object spreadCostsToStatusDate, object autoCalcCosts, object fixedCostAccrual, object calcMultipleCriticalPaths, object criticalSlack, object setDefaults, object calcInsProjLikeSummTask, object moveCompleted, object andMoveRemaining, object moveRemaining, object andMoveCompleted, object eVMethod)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsCalculation", new object[]{ automatic, autoTrack, spreadPercentToStatusDate, spreadCostsToStatusDate, autoCalcCosts, fixedCostAccrual, calcMultipleCriticalPaths, criticalSlack, setDefaults, calcInsProjLikeSummTask, moveCompleted, andMoveRemaining, moveRemaining, andMoveCompleted, eVMethod });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalculateAll()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalculateAll");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsPreferences()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsPreferences");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="calendarName">optional object calendarName</param>
		/// <param name="locked">optional object locked</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTime(object calendarName, object locked)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTime", calendarName, locked);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTime()
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTime");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="calendarName">optional object calendarName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTime(object calendarName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTime", calendarName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="index">optional object index</param>
		/// <param name="locked">optional object locked</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendars(object index, object locked)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendars", index, locked);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendars()
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendars");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="index">optional object index</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendars(object index)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendars", index);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="fromName">optional object fromName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarCreate(string name, object fromName)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarCreate", name, fromName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarCreate(string name)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarCreate", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fromName">string fromName</param>
		/// <param name="toName">string toName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarRename(string fromName, string toName)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarRename", fromName, toName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarDelete(string name)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarDelete", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from4">optional object from4</param>
		/// <param name="to4">optional object to4</param>
		/// <param name="from5">optional object from5</param>
		/// <param name="to5">optional object to5</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2, object from3, object to3, object _default, object from4, object to4, object from5, object to5)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2, from3, to3, _default, from4, to4, from5, to5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", name, startDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", name, startDate, endDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", name, startDate, endDate, weekDay);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2, object from3)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2, from3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2, object from3, object to3)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2, from3, to3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="_default">optional object default</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2, object from3, object to3, object _default)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2, from3, to3, _default });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from4">optional object from4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2, object from3, object to3, object _default, object from4)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2, from3, to3, _default, from4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from4">optional object from4</param>
		/// <param name="to4">optional object to4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2, object from3, object to3, object _default, object from4, object to4)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2, from3, to3, _default, from4, to4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from4">optional object from4</param>
		/// <param name="to4">optional object to4</param>
		/// <param name="from5">optional object from5</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarEditDays(string name, object startDate, object endDate, object weekDay, object working, object from1, object to1, object from2, object to2, object from3, object to3, object _default, object from4, object to4, object from5)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarEditDays", new object[]{ name, startDate, endDate, weekDay, working, from1, to1, from2, to2, from3, to3, _default, from4, to4, from5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="from4">optional object from4</param>
		/// <param name="to4">optional object to4</param>
		/// <param name="from5">optional object from5</param>
		/// <param name="to5">optional object to5</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2, object to2, object from3, object to3, object from4, object to4, object from5, object to5)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2, to2, from3, to3, from4, to4, from5, to5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", projectName, resourceName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", projectName, resourceName, startDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", projectName, resourceName, startDate, endDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2, object to2)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2, to2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2, object to2, object from3)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2, to2, from3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2, object to2, object from3, object to3)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2, to2, from3, to3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="from4">optional object from4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2, object to2, object from3, object to3, object from4)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2, to2, from3, to3, from4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="from4">optional object from4</param>
		/// <param name="to4">optional object to4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2, object to2, object from3, object to3, object from4, object to4)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2, to2, from3, to3, from4, to4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		/// <param name="weekDay">optional object weekDay</param>
		/// <param name="working">optional object working</param>
		/// <param name="_default">optional object default</param>
		/// <param name="from1">optional object from1</param>
		/// <param name="to1">optional object to1</param>
		/// <param name="from2">optional object from2</param>
		/// <param name="to2">optional object to2</param>
		/// <param name="from3">optional object from3</param>
		/// <param name="to3">optional object to3</param>
		/// <param name="from4">optional object from4</param>
		/// <param name="to4">optional object to4</param>
		/// <param name="from5">optional object from5</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarEditDays(string projectName, string resourceName, object startDate, object endDate, object weekDay, object working, object _default, object from1, object to1, object from2, object to2, object from3, object to3, object from4, object to4, object from5)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarEditDays", new object[]{ projectName, resourceName, startDate, endDate, weekDay, working, _default, from1, to1, from2, to2, from3, to3, from4, to4, from5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaseCalendarReset(string name)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaseCalendarReset", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		/// <param name="baseCalendar">optional object baseCalendar</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarReset(string projectName, string resourceName, object baseCalendar)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarReset", projectName, resourceName, baseCalendar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">string projectName</param>
		/// <param name="resourceName">string resourceName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendarReset(string projectName, string resourceName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendarReset", projectName, resourceName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="index">optional object index</param>
		/// <param name="locked">optional object locked</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendars(object index, object locked)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendars", index, locked);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendars()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendars");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="index">optional object index</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceCalendars(object index)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceCalendars", index);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		/// <param name="levelIndividualAssignments">optional object levelIndividualAssignments</param>
		/// <param name="levelingCanSplit">optional object levelingCanSplit</param>
		/// <param name="levelProposedBookings">optional object levelProposedBookings</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis, object levelIndividualAssignments, object levelingCanSplit, object levelProposedBookings)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis, levelIndividualAssignments, levelingCanSplit, levelProposedBookings });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions()
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", automatic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", automatic, delayInSlack);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", automatic, delayInSlack, autoClearLeveling);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", automatic, delayInSlack, autoClearLeveling, order);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		/// <param name="levelIndividualAssignments">optional object levelIndividualAssignments</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis, object levelIndividualAssignments)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis, levelIndividualAssignments });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		/// <param name="levelIndividualAssignments">optional object levelIndividualAssignments</param>
		/// <param name="levelingCanSplit">optional object levelingCanSplit</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingOptions(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis, object levelIndividualAssignments, object levelingCanSplit)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptions", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis, levelIndividualAssignments, levelingCanSplit });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelNow(object all)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelNow", all);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelNow()
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelNow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="copy">optional object copy</param>
		/// <param name="into">optional object into</param>
		/// <param name="rollupToSummaryTasks">optional object rollupToSummaryTasks</param>
		/// <param name="rollupFromSubtasks">optional object rollupFromSubtasks</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineSave(object all, object copy, object into, object rollupToSummaryTasks, object rollupFromSubtasks, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineSave", new object[]{ all, copy, into, rollupToSummaryTasks, rollupFromSubtasks, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineSave()
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineSave");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineSave(object all)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineSave", all);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="copy">optional object copy</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineSave(object all, object copy)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineSave", all, copy);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="copy">optional object copy</param>
		/// <param name="into">optional object into</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineSave(object all, object copy, object into)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineSave", all, copy, into);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="copy">optional object copy</param>
		/// <param name="into">optional object into</param>
		/// <param name="rollupToSummaryTasks">optional object rollupToSummaryTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineSave(object all, object copy, object into, object rollupToSummaryTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineSave", all, copy, into, rollupToSummaryTasks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="copy">optional object copy</param>
		/// <param name="into">optional object into</param>
		/// <param name="rollupToSummaryTasks">optional object rollupToSummaryTasks</param>
		/// <param name="rollupFromSubtasks">optional object rollupFromSubtasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineSave(object all, object copy, object into, object rollupToSummaryTasks, object rollupFromSubtasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineSave", new object[]{ all, copy, into, rollupToSummaryTasks, rollupFromSubtasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="updateDate">optional object updateDate</param>
		/// <param name="action">optional object action</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProject(object all, object updateDate, object action)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProject", all, updateDate, action);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProject()
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProject");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProject(object all)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProject", all);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="updateDate">optional object updateDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProject(object all, object updateDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProject", all, updateDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percentComplete">optional object percentComplete</param>
		/// <param name="actualDuration">optional object actualDuration</param>
		/// <param name="remainingDuration">optional object remainingDuration</param>
		/// <param name="actualStart">optional object actualStart</param>
		/// <param name="actualFinish">optional object actualFinish</param>
		/// <param name="notes">optional object notes</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateTasks(object percentComplete, object actualDuration, object remainingDuration, object actualStart, object actualFinish, object notes)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateTasks", new object[]{ percentComplete, actualDuration, remainingDuration, actualStart, actualFinish, notes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percentComplete">optional object percentComplete</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateTasks(object percentComplete)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateTasks", percentComplete);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percentComplete">optional object percentComplete</param>
		/// <param name="actualDuration">optional object actualDuration</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateTasks(object percentComplete, object actualDuration)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateTasks", percentComplete, actualDuration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percentComplete">optional object percentComplete</param>
		/// <param name="actualDuration">optional object actualDuration</param>
		/// <param name="remainingDuration">optional object remainingDuration</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateTasks(object percentComplete, object actualDuration, object remainingDuration)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateTasks", percentComplete, actualDuration, remainingDuration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percentComplete">optional object percentComplete</param>
		/// <param name="actualDuration">optional object actualDuration</param>
		/// <param name="remainingDuration">optional object remainingDuration</param>
		/// <param name="actualStart">optional object actualStart</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateTasks(object percentComplete, object actualDuration, object remainingDuration, object actualStart)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateTasks", percentComplete, actualDuration, remainingDuration, actualStart);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="percentComplete">optional object percentComplete</param>
		/// <param name="actualDuration">optional object actualDuration</param>
		/// <param name="remainingDuration">optional object remainingDuration</param>
		/// <param name="actualStart">optional object actualStart</param>
		/// <param name="actualFinish">optional object actualFinish</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateTasks(object percentComplete, object actualDuration, object remainingDuration, object actualStart, object actualFinish)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateTasks", new object[]{ percentComplete, actualDuration, remainingDuration, actualStart, actualFinish });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projects">optional object projects</param>
		/// <param name="view">optional object view</param>
		/// <param name="allProjects">optional object allProjects</param>
		/// <param name="showDialog">optional object showDialog</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowNewWindow(object projects, object view, object allProjects, object showDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowNewWindow", projects, view, allProjects, showDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowNewWindow()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowNewWindow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projects">optional object projects</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowNewWindow(object projects)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowNewWindow", projects);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projects">optional object projects</param>
		/// <param name="view">optional object view</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowNewWindow(object projects, object view)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowNewWindow", projects, view);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projects">optional object projects</param>
		/// <param name="view">optional object view</param>
		/// <param name="allProjects">optional object allProjects</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowNewWindow(object projects, object view, object allProjects)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowNewWindow", projects, view, allProjects);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowArrangeAll()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowArrangeAll");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowHide(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowHide", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowHide()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowHide");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowUnhide(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowUnhide", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowUnhide()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowUnhide");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="windowName">optional object windowName</param>
		/// <param name="dialogID">optional object dialogID</param>
		/// <param name="topPane">optional object topPane</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowActivate(object windowName, object dialogID, object topPane)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowActivate", windowName, dialogID, topPane);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowActivate()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowActivate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="windowName">optional object windowName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowActivate(object windowName)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowActivate", windowName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="windowName">optional object windowName</param>
		/// <param name="dialogID">optional object dialogID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowActivate(object windowName, object dialogID)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowActivate", windowName, dialogID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PageBreakSet()
		{
			return Factory.ExecuteBoolMethodGet(this, "PageBreakSet");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PageBreakRemove()
		{
			return Factory.ExecuteBoolMethodGet(this, "PageBreakRemove");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PageBreaksRemoveAll()
		{
			return Factory.ExecuteBoolMethodGet(this, "PageBreaksRemoveAll");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowResourcesPredecessors()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowResourcesPredecessors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowResourcesSuccessors()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowResourcesSuccessors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowPredecessorsSuccessors()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowPredecessorsSuccessors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowNotes()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowNotes");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowObjects()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowObjects");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowOverallocation()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowOverallocation");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowPercentAllocation()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowPercentAllocation");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowWork()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowWork");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowCost()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowCost");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowSchedule()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowSchedule");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowPeakUnits()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowPeakUnits");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowAvailability()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowAvailability");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowRemainingAvailability()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowRemainingAvailability");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowCumulativeWork()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowCumulativeWork");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowCumulativeCost()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowCumulativeCost");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PaneNext()
		{
			return Factory.ExecuteBoolMethodGet(this, "PaneNext");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PaneCreate()
		{
			return Factory.ExecuteBoolMethodGet(this, "PaneCreate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FormViewShow()
		{
			return Factory.ExecuteBoolMethodGet(this, "FormViewShow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PaneClose()
		{
			return Factory.ExecuteBoolMethodGet(this, "PaneClose");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowSplit()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowSplit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="noWrap">optional object noWrap</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowNext(object noWrap)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowNext", noWrap);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowNext()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowNext");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="noWrap">optional object noWrap</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowPrev(object noWrap)
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowPrev", noWrap);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowPrev()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowPrev");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocClose()
		{
			return Factory.ExecuteBoolMethodGet(this, "DocClose");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppMaximize()
		{
			return Factory.ExecuteBoolMethodGet(this, "AppMaximize");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppMinimize()
		{
			return Factory.ExecuteBoolMethodGet(this, "AppMinimize");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="xPosition">optional object xPosition</param>
		/// <param name="yPosition">optional object yPosition</param>
		/// <param name="points">optional object points</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppMove(object xPosition, object yPosition, object points)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppMove", xPosition, yPosition, points);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppMove()
		{
			return Factory.ExecuteBoolMethodGet(this, "AppMove");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="xPosition">optional object xPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppMove(object xPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppMove", xPosition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="xPosition">optional object xPosition</param>
		/// <param name="yPosition">optional object yPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppMove(object xPosition, object yPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppMove", xPosition, yPosition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppRestore()
		{
			return Factory.ExecuteBoolMethodGet(this, "AppRestore");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="points">optional object points</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppSize(object width, object height, object points)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppSize", width, height, points);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppSize()
		{
			return Factory.ExecuteBoolMethodGet(this, "AppSize");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="width">optional object width</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppSize(object width)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppSize", width);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppSize(object width, object height)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppSize", width, height);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocMaximize()
		{
			return Factory.ExecuteBoolMethodGet(this, "DocMaximize");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="xPosition">optional object xPosition</param>
		/// <param name="yPosition">optional object yPosition</param>
		/// <param name="points">optional object points</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocMove(object xPosition, object yPosition, object points)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocMove", xPosition, yPosition, points);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocMove()
		{
			return Factory.ExecuteBoolMethodGet(this, "DocMove");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="xPosition">optional object xPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocMove(object xPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocMove", xPosition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="xPosition">optional object xPosition</param>
		/// <param name="yPosition">optional object yPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocMove(object xPosition, object yPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocMove", xPosition, yPosition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocRestore()
		{
			return Factory.ExecuteBoolMethodGet(this, "DocRestore");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="points">optional object points</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocSize(object width, object height, object points)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocSize", width, height, points);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocSize()
		{
			return Factory.ExecuteBoolMethodGet(this, "DocSize");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="width">optional object width</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocSize(object width)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocSize", width);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocSize(object width, object height)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocSize", width, height);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="levels">optional object levels</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineOutdent(object levels)
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineOutdent", levels);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineOutdent()
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineOutdent");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="outlineNumber">optional NetOffice.MSProjectApi.Enums.PJTaskOutlineShowLevel OutlineNumber = 65535</param>
		/// <param name="expandInsertedProjects">optional object expandInsertedProjects</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineShowTasks(object outlineNumber, object expandInsertedProjects)
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineShowTasks", outlineNumber, expandInsertedProjects);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineShowTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineShowTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="outlineNumber">optional NetOffice.MSProjectApi.Enums.PJTaskOutlineShowLevel OutlineNumber = 65535</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineShowTasks(object outlineNumber)
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineShowTasks", outlineNumber);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="levels">optional object levels</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineIndent(object levels)
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineIndent", levels);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineIndent()
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineIndent");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineHideSubTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineHideSubTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineShowSubTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineShowSubTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineShowAllTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineShowAllTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectBeginning(object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectBeginning", extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectBeginning()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectBeginning");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectEnd(object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectEnd", extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectEnd()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectEnd");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRowStart(object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRowStart", extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRowStart()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRowStart");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRowEnd(object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRowEnd", extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRowEnd()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRowEnd");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellLeft(object numCells, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellLeft", numCells, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellLeft()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellLeft");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellLeft(object numCells)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellLeft", numCells);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellRight(object numCells, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellRight", numCells, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellRight()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellRight");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellRight(object numCells)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellRight", numCells);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellUp(object numCells, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellUp", numCells, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellUp()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellUp");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellUp(object numCells)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellUp", numCells);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		/// <param name="extend">optional object extend</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellDown(object numCells, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellDown", numCells, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellDown()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellDown");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numCells">optional object numCells</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCellDown(object numCells)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCellDown", numCells);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectionExtend(object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectionExtend", extend, add);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectionExtend()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectionExtend");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectionExtend(object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectionExtend", extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ColumnBestFit(object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "ColumnBestFit", column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ColumnBestFit()
		{
			return Factory.ExecuteBoolMethodGet(this, "ColumnBestFit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ColumnEdit(object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "ColumnEdit", column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ColumnEdit()
		{
			return Factory.ExecuteBoolMethodGet(this, "ColumnEdit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">Int16 column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRange(Int32 row, Int16 column, object rowRelative, object width, object height, object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRange", new object[]{ row, column, rowRelative, width, height, extend, add });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">Int16 column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRange(Int32 row, Int16 column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRange", row, column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">Int16 column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRange(Int32 row, Int16 column, object rowRelative)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRange", row, column, rowRelative);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">Int16 column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRange(Int32 row, Int16 column, object rowRelative, object width)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRange", row, column, rowRelative, width);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">Int16 column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRange(Int32 row, Int16 column, object rowRelative, object width, object height)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRange", new object[]{ row, column, rowRelative, width, height });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">Int16 column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRange(Int32 row, Int16 column, object rowRelative, object width, object height, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRange", new object[]{ row, column, rowRelative, width, height, extend });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="startTime">string startTime</param>
		/// <param name="width">Int16 width</param>
		/// <param name="height">Int32 height</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTimescaleRange(Int32 row, string startTime, Int16 width, Int32 height)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTimescaleRange", row, startTime, width, height);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskField(Int32 row, string column, object rowRelative, object width, object height, object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskField", new object[]{ row, column, rowRelative, width, height, extend, add });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskField(Int32 row, string column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskField", row, column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskField(Int32 row, string column, object rowRelative)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskField", row, column, rowRelative);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskField(Int32 row, string column, object rowRelative, object width)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskField", row, column, rowRelative, width);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskField(Int32 row, string column, object rowRelative, object width, object height)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskField", new object[]{ row, column, rowRelative, width, height });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskField(Int32 row, string column, object rowRelative, object width, object height, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskField", new object[]{ row, column, rowRelative, width, height, extend });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceField(Int32 row, string column, object rowRelative, object width, object height, object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceField", new object[]{ row, column, rowRelative, width, height, extend, add });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceField(Int32 row, string column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceField", row, column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceField(Int32 row, string column, object rowRelative)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceField", row, column, rowRelative);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceField(Int32 row, string column, object rowRelative, object width)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceField", row, column, rowRelative, width);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceField(Int32 row, string column, object rowRelative, object width, object height)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceField", new object[]{ row, column, rowRelative, width, height });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">Int32 row</param>
		/// <param name="column">string column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="width">optional object width</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceField(Int32 row, string column, object rowRelative, object width, object height, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceField", new object[]{ row, column, rowRelative, width, height, extend });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRow(object row, object rowRelative, object height, object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRow", new object[]{ row, rowRelative, height, extend, add });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRow()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRow(object row)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRow", row);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRow(object row, object rowRelative)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRow", row, rowRelative);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="height">optional object height</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRow(object row, object rowRelative, object height)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRow", row, rowRelative, height);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		/// <param name="height">optional object height</param>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectRow(object row, object rowRelative, object height, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectRow", row, rowRelative, height, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectColumn(object column, object additional, object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectColumn", column, additional, extend, add);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectColumn()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectColumn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectColumn(object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectColumn", column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectColumn(object column, object additional)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectColumn", column, additional);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectColumn(object column, object additional, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectColumn", column, additional, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskColumn(object column, object additional, object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskColumn", column, additional, extend, add);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskColumn()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskColumn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskColumn(object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskColumn", column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskColumn(object column, object additional)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskColumn", column, additional);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskColumn(object column, object additional, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskColumn", column, additional, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		/// <param name="extend">optional object extend</param>
		/// <param name="add">optional object add</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceColumn(object column, object additional, object extend, object add)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceColumn", column, additional, extend, add);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceColumn()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceColumn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceColumn(object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceColumn", column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceColumn(object column, object additional)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceColumn", column, additional);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		/// <param name="additional">optional object additional</param>
		/// <param name="extend">optional object extend</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceColumn(object column, object additional, object extend)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceColumn", column, additional, extend);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="column">optional object column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskCell(object row, object column, object rowRelative)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskCell", row, column, rowRelative);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskCell()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskCell");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskCell(object row)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskCell", row);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="column">optional object column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectTaskCell(object row, object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskCell", row, column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="column">optional object column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceCell(object row, object column, object rowRelative)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceCell", row, column, rowRelative);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceCell()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceCell");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceCell(object row)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceCell", row);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="column">optional object column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectResourceCell(object row, object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectResourceCell", row, column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="column">optional object column</param>
		/// <param name="rowRelative">optional object rowRelative</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCell(object row, object column, object rowRelative)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCell", row, column, rowRelative);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCell()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCell");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCell(object row)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCell", row);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="row">optional object row</param>
		/// <param name="column">optional object column</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectCell(object row, object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectCell", row, column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SelectSheet()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectSheet");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="app">string app</param>
		/// <param name="topic">string topic</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DDEInitiate(string app, string topic)
		{
			return Factory.ExecuteBoolMethodGet(this, "DDEInitiate", app, topic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="command">string command</param>
		/// <param name="timeOut">optional object timeOut</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DDEExecute(string command, object timeOut)
		{
			return Factory.ExecuteBoolMethodGet(this, "DDEExecute", command, timeOut);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="command">string command</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DDEExecute(string command)
		{
			return Factory.ExecuteBoolMethodGet(this, "DDEExecute", command);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DDETerminate()
		{
			return Factory.ExecuteBoolMethodGet(this, "DDETerminate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="tab">optional object tab</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InformationDialog(object tab)
		{
			return Factory.ExecuteBoolMethodGet(this, "InformationDialog", tab);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InformationDialog()
		{
			return Factory.ExecuteBoolMethodGet(this, "InformationDialog");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Form(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "Form", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Form()
		{
			return Factory.ExecuteBoolMethodGet(this, "Form");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomForms()
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomForms");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Tables()
		{
			return Factory.ExecuteBoolMethodGet(this, "Tables");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Filters()
		{
			return Factory.ExecuteBoolMethodGet(this, "Filters");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Macro(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "Macro", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Macro()
		{
			return Factory.ExecuteBoolMethodGet(this, "Macro");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="down">optional object down</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FillDown(object down)
		{
			return Factory.ExecuteBoolMethodGet(this, "FillDown", down);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FillDown()
		{
			return Factory.ExecuteBoolMethodGet(this, "FillDown");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Views()
		{
			return Factory.ExecuteBoolMethodGet(this, "Views");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalculateProject()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalculateProject");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingClear(object all)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingClear", all);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LevelingClear()
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingClear");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SpellingCheck()
		{
			return Factory.ExecuteBoolMethodGet(this, "SpellingCheck");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		/// <param name="resourceText4">optional object resourceText4</param>
		/// <param name="resourceText5">optional object resourceText5</param>
		/// <param name="assignNotes">optional object assignNotes</param>
		/// <param name="ignoreUppercase">optional object ignoreUppercase</param>
		/// <param name="ignoreNumberWords">optional object ignoreNumberWords</param>
		/// <param name="alwaysSuggest">optional object alwaysSuggest</param>
		/// <param name="useCustomDictionary">optional object useCustomDictionary</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3, object resourceText4, object resourceText5, object assignNotes, object ignoreUppercase, object ignoreNumberWords, object alwaysSuggest, object useCustomDictionary)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3, resourceText4, resourceText5, assignNotes, ignoreUppercase, ignoreNumberWords, alwaysSuggest, useCustomDictionary });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", taskName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", taskName, taskNotes);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", taskName, taskNotes, taskText1);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", taskName, taskNotes, taskText1, taskText2);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		/// <param name="resourceText4">optional object resourceText4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3, object resourceText4)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3, resourceText4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		/// <param name="resourceText4">optional object resourceText4</param>
		/// <param name="resourceText5">optional object resourceText5</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3, object resourceText4, object resourceText5)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3, resourceText4, resourceText5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		/// <param name="resourceText4">optional object resourceText4</param>
		/// <param name="resourceText5">optional object resourceText5</param>
		/// <param name="assignNotes">optional object assignNotes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3, object resourceText4, object resourceText5, object assignNotes)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3, resourceText4, resourceText5, assignNotes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		/// <param name="resourceText4">optional object resourceText4</param>
		/// <param name="resourceText5">optional object resourceText5</param>
		/// <param name="assignNotes">optional object assignNotes</param>
		/// <param name="ignoreUppercase">optional object ignoreUppercase</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3, object resourceText4, object resourceText5, object assignNotes, object ignoreUppercase)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3, resourceText4, resourceText5, assignNotes, ignoreUppercase });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		/// <param name="resourceText4">optional object resourceText4</param>
		/// <param name="resourceText5">optional object resourceText5</param>
		/// <param name="assignNotes">optional object assignNotes</param>
		/// <param name="ignoreUppercase">optional object ignoreUppercase</param>
		/// <param name="ignoreNumberWords">optional object ignoreNumberWords</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3, object resourceText4, object resourceText5, object assignNotes, object ignoreUppercase, object ignoreNumberWords)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3, resourceText4, resourceText5, assignNotes, ignoreUppercase, ignoreNumberWords });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskName">optional object taskName</param>
		/// <param name="taskNotes">optional object taskNotes</param>
		/// <param name="taskText1">optional object taskText1</param>
		/// <param name="taskText2">optional object taskText2</param>
		/// <param name="taskText3">optional object taskText3</param>
		/// <param name="taskText4">optional object taskText4</param>
		/// <param name="taskText5">optional object taskText5</param>
		/// <param name="taskText6">optional object taskText6</param>
		/// <param name="taskText7">optional object taskText7</param>
		/// <param name="taskText8">optional object taskText8</param>
		/// <param name="taskText9">optional object taskText9</param>
		/// <param name="taskText10">optional object taskText10</param>
		/// <param name="resourceCode">optional object resourceCode</param>
		/// <param name="resourceName">optional object resourceName</param>
		/// <param name="resourceNotes">optional object resourceNotes</param>
		/// <param name="resourceGroup">optional object resourceGroup</param>
		/// <param name="resourceText1">optional object resourceText1</param>
		/// <param name="resourceText2">optional object resourceText2</param>
		/// <param name="resourceText3">optional object resourceText3</param>
		/// <param name="resourceText4">optional object resourceText4</param>
		/// <param name="resourceText5">optional object resourceText5</param>
		/// <param name="assignNotes">optional object assignNotes</param>
		/// <param name="ignoreUppercase">optional object ignoreUppercase</param>
		/// <param name="ignoreNumberWords">optional object ignoreNumberWords</param>
		/// <param name="alwaysSuggest">optional object alwaysSuggest</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSpelling(object taskName, object taskNotes, object taskText1, object taskText2, object taskText3, object taskText4, object taskText5, object taskText6, object taskText7, object taskText8, object taskText9, object taskText10, object resourceCode, object resourceName, object resourceNotes, object resourceGroup, object resourceText1, object resourceText2, object resourceText3, object resourceText4, object resourceText5, object assignNotes, object ignoreUppercase, object ignoreNumberWords, object alwaysSuggest)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSpelling", new object[]{ taskName, taskNotes, taskText1, taskText2, taskText3, taskText4, taskText5, taskText6, taskText7, taskText8, taskText9, taskText10, resourceCode, resourceName, resourceNotes, resourceGroup, resourceText1, resourceText2, resourceText3, resourceText4, resourceText5, assignNotes, ignoreUppercase, ignoreNumberWords, alwaysSuggest });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WindowMoreWindows()
		{
			return Factory.ExecuteBoolMethodGet(this, "WindowMoreWindows");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpContents()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpContents");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpSearch()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpSearch");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpOnlineIndex()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpOnlineIndex");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpAbout()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpAbout");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="contextNumber">optional object contextNumber</param>
		/// <param name="search">optional object search</param>
		/// <param name="searchKey">optional object searchKey</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpLaunch(object fileName, object contextNumber, object search, object searchKey)
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpLaunch", fileName, contextNumber, search, searchKey);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpLaunch()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpLaunch");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fileName">optional object fileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpLaunch(object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpLaunch", fileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="contextNumber">optional object contextNumber</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpLaunch(object fileName, object contextNumber)
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpLaunch", fileName, contextNumber);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="contextNumber">optional object contextNumber</param>
		/// <param name="search">optional object search</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpLaunch(object fileName, object contextNumber, object search)
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpLaunch", fileName, contextNumber, search);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="contextNumber">optional object contextNumber</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpCueCards(object fileName, object contextNumber)
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpCueCards", fileName, contextNumber);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpCueCards()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpCueCards");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fileName">optional object fileName</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpCueCards(object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpCueCards", fileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpTopics()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpTopics");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpAnswerWizard()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpAnswerWizard");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpMSProjectFundamentals()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpMSProjectFundamentals");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AutoCorrect()
		{
			return Factory.ExecuteBoolMethodGet(this, "AutoCorrect");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpQuickPreview()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpQuickPreview");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpTechnicalSupport()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpTechnicalSupport");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpCreateYourProject()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpCreateYourProject");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpContextHelp()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpContextHelp");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles(object item, object font, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles", new object[]{ item, font, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles()
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles(object item, object font)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles", item, font);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles(object item, object font, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles", item, font, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles(object item, object font, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles", item, font, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles(object item, object font, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles", new object[]{ item, font, size, bold, italic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStyles(object item, object font, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles", new object[]{ item, font, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor, object pattern, object showInMenu)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", new object[]{ item, font, size, bold, italic, underline, color, cellColor, pattern, showInMenu });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", item, font);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", item, font, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", item, font, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", new object[]{ item, font, size, bold, italic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", new object[]{ item, font, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", new object[]{ item, font, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", new object[]{ item, font, size, bold, italic, underline, color, cellColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesFormat(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormat", new object[]{ item, font, size, bold, italic, underline, color, cellColor, pattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional NetOffice.MSProjectApi.Enums.PjTimescaledData Item = 0</param>
		/// <param name="position">optional object position</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesAdd(object item, object position)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesAdd", item, position);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesAdd()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesAdd");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional NetOffice.MSProjectApi.Enums.PjTimescaledData Item = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesAdd(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesAdd", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional NetOffice.MSProjectApi.Enums.PjTimescaledData Item = 0</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesRemove(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesRemove", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesRemove()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesRemove");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesRemoveAll()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesRemoveAll");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font(object name, object size, object bold, object italic, object underline, object color, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font", new object[]{ name, size, bold, italic, underline, color, reset });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font()
		{
			return Factory.ExecuteBoolMethodGet(this, "Font");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font(object name, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font", name, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font(object name, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font", name, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font(object name, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font", name, size, bold, italic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font(object name, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font", new object[]{ name, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Font(object name, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font", new object[]{ name, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Timescale()
		{
			return Factory.ExecuteBoolMethodGet(this, "Timescale");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		/// <param name="topUnits">optional object topUnits</param>
		/// <param name="topLabel">optional object topLabel</param>
		/// <param name="topAlign">optional object topAlign</param>
		/// <param name="topCount">optional object topCount</param>
		/// <param name="topTicks">optional object topTicks</param>
		/// <param name="topUseFY">optional object topUseFY</param>
		/// <param name="tierCount">optional object tierCount</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY, object topUnits, object topLabel, object topAlign, object topCount, object topTicks, object topUseFY, object tierCount)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY, topUnits, topLabel, topAlign, topCount, topTicks, topUseFY, tierCount });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", majorUnits);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", majorUnits, minorUnits);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", majorUnits, minorUnits, majorLabel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", majorUnits, minorUnits, majorLabel, minorLabel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		/// <param name="topUnits">optional object topUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY, object topUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY, topUnits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		/// <param name="topUnits">optional object topUnits</param>
		/// <param name="topLabel">optional object topLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY, object topUnits, object topLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY, topUnits, topLabel });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		/// <param name="topUnits">optional object topUnits</param>
		/// <param name="topLabel">optional object topLabel</param>
		/// <param name="topAlign">optional object topAlign</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY, object topUnits, object topLabel, object topAlign)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY, topUnits, topLabel, topAlign });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		/// <param name="topUnits">optional object topUnits</param>
		/// <param name="topLabel">optional object topLabel</param>
		/// <param name="topAlign">optional object topAlign</param>
		/// <param name="topCount">optional object topCount</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY, object topUnits, object topLabel, object topAlign, object topCount)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY, topUnits, topLabel, topAlign, topCount });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		/// <param name="topUnits">optional object topUnits</param>
		/// <param name="topLabel">optional object topLabel</param>
		/// <param name="topAlign">optional object topAlign</param>
		/// <param name="topCount">optional object topCount</param>
		/// <param name="topTicks">optional object topTicks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY, object topUnits, object topLabel, object topAlign, object topCount, object topTicks)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY, topUnits, topLabel, topAlign, topCount, topTicks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="majorUnits">optional object majorUnits</param>
		/// <param name="minorUnits">optional object minorUnits</param>
		/// <param name="majorLabel">optional object majorLabel</param>
		/// <param name="minorLabel">optional object minorLabel</param>
		/// <param name="majorAlign">optional object majorAlign</param>
		/// <param name="minorAlign">optional object minorAlign</param>
		/// <param name="majorCount">optional object majorCount</param>
		/// <param name="minorCount">optional object minorCount</param>
		/// <param name="majorTicks">optional object majorTicks</param>
		/// <param name="minorTicks">optional object minorTicks</param>
		/// <param name="enlarge">optional object enlarge</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="majorUseFY">optional object majorUseFY</param>
		/// <param name="minorUseFY">optional object minorUseFY</param>
		/// <param name="topUnits">optional object topUnits</param>
		/// <param name="topLabel">optional object topLabel</param>
		/// <param name="topAlign">optional object topAlign</param>
		/// <param name="topCount">optional object topCount</param>
		/// <param name="topTicks">optional object topTicks</param>
		/// <param name="topUseFY">optional object topUseFY</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleEdit(object majorUnits, object minorUnits, object majorLabel, object minorLabel, object majorAlign, object minorAlign, object majorCount, object minorCount, object majorTicks, object minorTicks, object enlarge, object separator, object majorUseFY, object minorUseFY, object topUnits, object topLabel, object topAlign, object topCount, object topTicks, object topUseFY)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleEdit", new object[]{ majorUnits, minorUnits, majorLabel, minorLabel, majorAlign, minorAlign, majorCount, minorCount, majorTicks, minorTicks, enlarge, separator, majorUseFY, minorUseFY, topUnits, topLabel, topAlign, topCount, topTicks, topUseFY });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		/// <param name="ascending1">optional object ascending1</param>
		/// <param name="key2">optional object key2</param>
		/// <param name="ascending2">optional object ascending2</param>
		/// <param name="key3">optional object key3</param>
		/// <param name="ascending3">optional object ascending3</param>
		/// <param name="renumber">optional object renumber</param>
		/// <param name="outline">optional object outline</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1, object ascending1, object key2, object ascending2, object key3, object ascending3, object renumber, object outline)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", new object[]{ key1, ascending1, key2, ascending2, key3, ascending3, renumber, outline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort()
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", key1);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		/// <param name="ascending1">optional object ascending1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1, object ascending1)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", key1, ascending1);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		/// <param name="ascending1">optional object ascending1</param>
		/// <param name="key2">optional object key2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1, object ascending1, object key2)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", key1, ascending1, key2);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		/// <param name="ascending1">optional object ascending1</param>
		/// <param name="key2">optional object key2</param>
		/// <param name="ascending2">optional object ascending2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1, object ascending1, object key2, object ascending2)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", key1, ascending1, key2, ascending2);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		/// <param name="ascending1">optional object ascending1</param>
		/// <param name="key2">optional object key2</param>
		/// <param name="ascending2">optional object ascending2</param>
		/// <param name="key3">optional object key3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1, object ascending1, object key2, object ascending2, object key3)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", new object[]{ key1, ascending1, key2, ascending2, key3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		/// <param name="ascending1">optional object ascending1</param>
		/// <param name="key2">optional object key2</param>
		/// <param name="ascending2">optional object ascending2</param>
		/// <param name="key3">optional object key3</param>
		/// <param name="ascending3">optional object ascending3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1, object ascending1, object key2, object ascending2, object key3, object ascending3)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", new object[]{ key1, ascending1, key2, ascending2, key3, ascending3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="key1">optional object key1</param>
		/// <param name="ascending1">optional object ascending1</param>
		/// <param name="key2">optional object key2</param>
		/// <param name="ascending2">optional object ascending2</param>
		/// <param name="key3">optional object key3</param>
		/// <param name="ascending3">optional object ascending3</param>
		/// <param name="renumber">optional object renumber</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Sort(object key1, object ascending1, object key2, object ascending2, object key3, object ascending3, object renumber)
		{
			return Factory.ExecuteBoolMethodGet(this, "Sort", new object[]{ key1, ascending1, key2, ascending2, key3, ascending3, renumber });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BarBoxStyles()
		{
			return Factory.ExecuteBoolMethodGet(this, "BarBoxStyles");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="insideText">optional object insideText</param>
		/// <param name="reset">optional object reset</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText, object insideText, object reset, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText, insideText, reset, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", taskID, ganttStyle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", taskID, ganttStyle, startShape);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", taskID, ganttStyle, startShape, startType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="insideText">optional object insideText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText, object insideText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText, insideText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="insideText">optional object insideText</param>
		/// <param name="reset">optional object reset</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarFormat(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText, object insideText, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormat", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText, insideText, reset });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		/// <param name="calendar">optional object calendar</param>
		/// <param name="color">optional object color</param>
		/// <param name="pattern">optional object pattern</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleNonWorking(object draw, object calendar, object color, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorking", draw, calendar, color, pattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleNonWorking()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorking");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleNonWorking(object draw)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorking", draw);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		/// <param name="calendar">optional object calendar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleNonWorking(object draw, object calendar)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorking", draw, calendar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		/// <param name="calendar">optional object calendar</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TimescaleNonWorking(object draw, object calendar, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorking", draw, calendar, color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxShowHideFields(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxShowHideFields", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxShowHideFields()
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxShowHideFields");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Layout()
		{
			return Factory.ExecuteBoolMethodGet(this, "Layout");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="straight">optional object straight</param>
		/// <param name="displayArrows">optional object displayArrows</param>
		/// <param name="adjustForPageBreaks">optional object adjustForPageBreaks</param>
		/// <param name="displayPageBreaks">optional object displayPageBreaks</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTLayout(object straight, object displayArrows, object adjustForPageBreaks, object displayPageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTLayout", straight, displayArrows, adjustForPageBreaks, displayPageBreaks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTLayout()
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTLayout");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="straight">optional object straight</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTLayout(object straight)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTLayout", straight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="straight">optional object straight</param>
		/// <param name="displayArrows">optional object displayArrows</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTLayout(object straight, object displayArrows)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTLayout", straight, displayArrows);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="straight">optional object straight</param>
		/// <param name="displayArrows">optional object displayArrows</param>
		/// <param name="adjustForPageBreaks">optional object adjustForPageBreaks</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTLayout(object straight, object displayArrows, object adjustForPageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTLayout", straight, displayArrows, adjustForPageBreaks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LayoutNow()
		{
			return Factory.ExecuteBoolMethodGet(this, "LayoutNow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		/// <param name="criticalMarkedColor">optional object criticalMarkedColor</param>
		/// <param name="noncriticalMarkedStyle">optional object noncriticalMarkedStyle</param>
		/// <param name="noncriticalMarkedColor">optional object noncriticalMarkedColor</param>
		/// <param name="criticalExternalTaskStyle">optional object criticalExternalTaskStyle</param>
		/// <param name="criticalExternalTaskColor">optional object criticalExternalTaskColor</param>
		/// <param name="noncriticalExternalTaskStyle">optional object noncriticalExternalTaskStyle</param>
		/// <param name="noncriticalExternalTaskColor">optional object noncriticalExternalTaskColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle, object criticalMarkedColor, object noncriticalMarkedStyle, object noncriticalMarkedColor, object criticalExternalTaskStyle, object criticalExternalTaskColor, object noncriticalExternalTaskStyle, object noncriticalExternalTaskColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle, criticalMarkedColor, noncriticalMarkedStyle, noncriticalMarkedColor, criticalExternalTaskStyle, criticalExternalTaskColor, noncriticalExternalTaskStyle, noncriticalExternalTaskColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders()
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", criticalStyle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", criticalStyle, criticalColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", criticalStyle, criticalColor, noncriticalStyle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", criticalStyle, criticalColor, noncriticalStyle, noncriticalColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		/// <param name="criticalMarkedColor">optional object criticalMarkedColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle, object criticalMarkedColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle, criticalMarkedColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		/// <param name="criticalMarkedColor">optional object criticalMarkedColor</param>
		/// <param name="noncriticalMarkedStyle">optional object noncriticalMarkedStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle, object criticalMarkedColor, object noncriticalMarkedStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle, criticalMarkedColor, noncriticalMarkedStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		/// <param name="criticalMarkedColor">optional object criticalMarkedColor</param>
		/// <param name="noncriticalMarkedStyle">optional object noncriticalMarkedStyle</param>
		/// <param name="noncriticalMarkedColor">optional object noncriticalMarkedColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle, object criticalMarkedColor, object noncriticalMarkedStyle, object noncriticalMarkedColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle, criticalMarkedColor, noncriticalMarkedStyle, noncriticalMarkedColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		/// <param name="criticalMarkedColor">optional object criticalMarkedColor</param>
		/// <param name="noncriticalMarkedStyle">optional object noncriticalMarkedStyle</param>
		/// <param name="noncriticalMarkedColor">optional object noncriticalMarkedColor</param>
		/// <param name="criticalExternalTaskStyle">optional object criticalExternalTaskStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle, object criticalMarkedColor, object noncriticalMarkedStyle, object noncriticalMarkedColor, object criticalExternalTaskStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle, criticalMarkedColor, noncriticalMarkedStyle, noncriticalMarkedColor, criticalExternalTaskStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		/// <param name="criticalMarkedColor">optional object criticalMarkedColor</param>
		/// <param name="noncriticalMarkedStyle">optional object noncriticalMarkedStyle</param>
		/// <param name="noncriticalMarkedColor">optional object noncriticalMarkedColor</param>
		/// <param name="criticalExternalTaskStyle">optional object criticalExternalTaskStyle</param>
		/// <param name="criticalExternalTaskColor">optional object criticalExternalTaskColor</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle, object criticalMarkedColor, object noncriticalMarkedStyle, object noncriticalMarkedColor, object criticalExternalTaskStyle, object criticalExternalTaskColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle, criticalMarkedColor, noncriticalMarkedStyle, noncriticalMarkedColor, criticalExternalTaskStyle, criticalExternalTaskColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="criticalStyle">optional object criticalStyle</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalStyle">optional object noncriticalStyle</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		/// <param name="criticalMilestoneStyle">optional object criticalMilestoneStyle</param>
		/// <param name="criticalMilestoneColor">optional object criticalMilestoneColor</param>
		/// <param name="noncriticalMilestoneStyle">optional object noncriticalMilestoneStyle</param>
		/// <param name="noncriticalMilestoneColor">optional object noncriticalMilestoneColor</param>
		/// <param name="criticalSummaryStyle">optional object criticalSummaryStyle</param>
		/// <param name="criticalSummaryColor">optional object criticalSummaryColor</param>
		/// <param name="noncriticalSummaryStyle">optional object noncriticalSummaryStyle</param>
		/// <param name="noncriticalSummaryColor">optional object noncriticalSummaryColor</param>
		/// <param name="criticalSubprojectStyle">optional object criticalSubprojectStyle</param>
		/// <param name="criticalSubprojectColor">optional object criticalSubprojectColor</param>
		/// <param name="noncriticalSubprojectStyle">optional object noncriticalSubprojectStyle</param>
		/// <param name="noncriticalSubprojectColor">optional object noncriticalSubprojectColor</param>
		/// <param name="criticalMarkedStyle">optional object criticalMarkedStyle</param>
		/// <param name="criticalMarkedColor">optional object criticalMarkedColor</param>
		/// <param name="noncriticalMarkedStyle">optional object noncriticalMarkedStyle</param>
		/// <param name="noncriticalMarkedColor">optional object noncriticalMarkedColor</param>
		/// <param name="criticalExternalTaskStyle">optional object criticalExternalTaskStyle</param>
		/// <param name="criticalExternalTaskColor">optional object criticalExternalTaskColor</param>
		/// <param name="noncriticalExternalTaskStyle">optional object noncriticalExternalTaskStyle</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBorders(object criticalStyle, object criticalColor, object noncriticalStyle, object noncriticalColor, object criticalMilestoneStyle, object criticalMilestoneColor, object noncriticalMilestoneStyle, object noncriticalMilestoneColor, object criticalSummaryStyle, object criticalSummaryColor, object noncriticalSummaryStyle, object noncriticalSummaryColor, object criticalSubprojectStyle, object criticalSubprojectColor, object noncriticalSubprojectStyle, object noncriticalSubprojectColor, object criticalMarkedStyle, object criticalMarkedColor, object noncriticalMarkedStyle, object noncriticalMarkedColor, object criticalExternalTaskStyle, object criticalExternalTaskColor, object noncriticalExternalTaskStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBorders", new object[]{ criticalStyle, criticalColor, noncriticalStyle, noncriticalColor, criticalMilestoneStyle, criticalMilestoneColor, noncriticalMilestoneStyle, noncriticalMilestoneColor, criticalSummaryStyle, criticalSummaryColor, noncriticalSummaryStyle, noncriticalSummaryColor, criticalSubprojectStyle, criticalSubprojectColor, noncriticalSubprojectStyle, noncriticalSubprojectColor, criticalMarkedStyle, criticalMarkedColor, noncriticalMarkedStyle, noncriticalMarkedColor, criticalExternalTaskStyle, criticalExternalTaskColor, noncriticalExternalTaskStyle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Gridlines()
		{
			return Factory.ExecuteBoolMethodGet(this, "Gridlines");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		/// <param name="interval">optional object interval</param>
		/// <param name="intervalType">optional object intervalType</param>
		/// <param name="intervalColor">optional object intervalColor</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GridlinesEdit(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor, object interval, object intervalType, object intervalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEdit", new object[]{ item, normalType, normalColor, interval, intervalType, intervalColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GridlinesEdit(NetOffice.MSProjectApi.Enums.PjGridline item)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEdit", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GridlinesEdit(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEdit", item, normalType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GridlinesEdit(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEdit", item, normalType, normalColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		/// <param name="interval">optional object interval</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GridlinesEdit(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor, object interval)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEdit", item, normalType, normalColor, interval);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		/// <param name="interval">optional object interval</param>
		/// <param name="intervalType">optional object intervalType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GridlinesEdit(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor, object interval, object intervalType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEdit", new object[]{ item, normalType, normalColor, interval, intervalType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowSelectedTasks(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowSelectedTasks", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowSelectedTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowSelectedTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PageBreaksShow(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "PageBreaksShow", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PageBreaksShow()
		{
			return Factory.ExecuteBoolMethodGet(this, "PageBreaksShow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FindNext()
		{
			return Factory.ExecuteBoolMethodGet(this, "FindNext");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FindPrevious()
		{
			return Factory.ExecuteBoolMethodGet(this, "FindPrevious");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomOut()
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomOut");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomIn()
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomIn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="create">optional object create</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetField(string field, string value, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetField", field, value, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetField(string field, string value)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetField", field, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetTaskField(string field, string value, object allSelectedTasks, object create, object taskID, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskField", new object[]{ field, value, allSelectedTasks, create, taskID, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetTaskField(string field, string value)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskField", field, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetTaskField(string field, string value, object allSelectedTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskField", field, value, allSelectedTasks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetTaskField(string field, string value, object allSelectedTasks, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskField", field, value, allSelectedTasks, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		/// <param name="taskID">optional object taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetTaskField(string field, string value, object allSelectedTasks, object create, object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskField", new object[]{ field, value, allSelectedTasks, create, taskID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		/// <param name="create">optional object create</param>
		/// <param name="resourceID">optional object resourceID</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetResourceField(string field, string value, object allSelectedResources, object create, object resourceID, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceField", new object[]{ field, value, allSelectedResources, create, resourceID, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetResourceField(string field, string value)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceField", field, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetResourceField(string field, string value, object allSelectedResources)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceField", field, value, allSelectedResources);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetResourceField(string field, string value, object allSelectedResources, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceField", field, value, allSelectedResources, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		/// <param name="create">optional object create</param>
		/// <param name="resourceID">optional object resourceID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetResourceField(string field, string value, object allSelectedResources, object create, object resourceID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceField", new object[]{ field, value, allSelectedResources, create, resourceID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="value">string value</param>
		/// <param name="create">optional object create</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetActiveCell(string value, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetActiveCell", value, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetActiveCell(string value)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetActiveCell", value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="test">optional object test</param>
		/// <param name="op">optional object op</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="value2">optional object value2</param>
		/// <param name="test2">optional object test2</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public object CheckField(string field, string value, object test, object op, object field2, object value2, object test2)
		{
			return Factory.ExecuteVariantMethodGet(this, "CheckField", new object[]{ field, value, test, op, field2, value2, test2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object CheckField(string field, string value)
		{
			return Factory.ExecuteVariantMethodGet(this, "CheckField", field, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="test">optional object test</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object CheckField(string field, string value, object test)
		{
			return Factory.ExecuteVariantMethodGet(this, "CheckField", field, value, test);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="test">optional object test</param>
		/// <param name="op">optional object op</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object CheckField(string field, string value, object test, object op)
		{
			return Factory.ExecuteVariantMethodGet(this, "CheckField", field, value, test, op);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="test">optional object test</param>
		/// <param name="op">optional object op</param>
		/// <param name="field2">optional object field2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object CheckField(string field, string value, object test, object op, object field2)
		{
			return Factory.ExecuteVariantMethodGet(this, "CheckField", new object[]{ field, value, test, op, field2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="test">optional object test</param>
		/// <param name="op">optional object op</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="value2">optional object value2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public object CheckField(string field, string value, object test, object op, object field2, object value2)
		{
			return Factory.ExecuteVariantMethodGet(this, "CheckField", new object[]{ field, value, test, op, field2, value2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="checkField">string checkField</param>
		/// <param name="checkValue">string checkValue</param>
		/// <param name="checkTest">optional object checkTest</param>
		/// <param name="checkOperation">optional object checkOperation</param>
		/// <param name="checkField2">optional object checkField2</param>
		/// <param name="checkValue2">optional object checkValue2</param>
		/// <param name="checkTest2">optional object checkTest2</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetMatchingField(string field, string value, string checkField, string checkValue, object checkTest, object checkOperation, object checkField2, object checkValue2, object checkTest2)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetMatchingField", new object[]{ field, value, checkField, checkValue, checkTest, checkOperation, checkField2, checkValue2, checkTest2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="checkField">string checkField</param>
		/// <param name="checkValue">string checkValue</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetMatchingField(string field, string value, string checkField, string checkValue)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetMatchingField", field, value, checkField, checkValue);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="checkField">string checkField</param>
		/// <param name="checkValue">string checkValue</param>
		/// <param name="checkTest">optional object checkTest</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetMatchingField(string field, string value, string checkField, string checkValue, object checkTest)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetMatchingField", new object[]{ field, value, checkField, checkValue, checkTest });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="checkField">string checkField</param>
		/// <param name="checkValue">string checkValue</param>
		/// <param name="checkTest">optional object checkTest</param>
		/// <param name="checkOperation">optional object checkOperation</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetMatchingField(string field, string value, string checkField, string checkValue, object checkTest, object checkOperation)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetMatchingField", new object[]{ field, value, checkField, checkValue, checkTest, checkOperation });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="checkField">string checkField</param>
		/// <param name="checkValue">string checkValue</param>
		/// <param name="checkTest">optional object checkTest</param>
		/// <param name="checkOperation">optional object checkOperation</param>
		/// <param name="checkField2">optional object checkField2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetMatchingField(string field, string value, string checkField, string checkValue, object checkTest, object checkOperation, object checkField2)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetMatchingField", new object[]{ field, value, checkField, checkValue, checkTest, checkOperation, checkField2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="checkField">string checkField</param>
		/// <param name="checkValue">string checkValue</param>
		/// <param name="checkTest">optional object checkTest</param>
		/// <param name="checkOperation">optional object checkOperation</param>
		/// <param name="checkField2">optional object checkField2</param>
		/// <param name="checkValue2">optional object checkValue2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetMatchingField(string field, string value, string checkField, string checkValue, object checkTest, object checkOperation, object checkField2, object checkValue2)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetMatchingField", new object[]{ field, value, checkField, checkValue, checkTest, checkOperation, checkField2, checkValue2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="window">optional object window</param>
		/// <param name="command">optional object command</param>
		/// <param name="minimize">optional object minimize</param>
		/// <param name="activate">optional object activate</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppExecute(object window, object command, object minimize, object activate)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppExecute", window, command, minimize, activate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppExecute()
		{
			return Factory.ExecuteBoolMethodGet(this, "AppExecute");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="window">optional object window</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppExecute(object window)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppExecute", window);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="window">optional object window</param>
		/// <param name="command">optional object command</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppExecute(object window, object command)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppExecute", window, command);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="window">optional object window</param>
		/// <param name="command">optional object command</param>
		/// <param name="minimize">optional object minimize</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppExecute(object window, object command, object minimize)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppExecute", window, command, minimize);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="application">string application</param>
		/// <param name="document">optional object document</param>
		/// <param name="activate">optional object activate</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppLaunch(string application, object document, object activate)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppLaunch", application, document, activate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="application">string application</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppLaunch(string application)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppLaunch", application);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="application">string application</param>
		/// <param name="document">optional object document</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AppLaunch(string application, object document)
		{
			return Factory.ExecuteBoolMethodGet(this, "AppLaunch", application, document);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DDELinksUpdate()
		{
			return Factory.ExecuteBoolMethodGet(this, "DDELinksUpdate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GotoTaskDates()
		{
			return Factory.ExecuteBoolMethodGet(this, "GotoTaskDates");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="display">optional NetOffice.MSProjectApi.Enums.PjGanttBarLink Display = 0</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarLinks(object display)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarLinks", display);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarLinks()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarLinks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="display">optional object display</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttShowDrawings(object display)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttShowDrawings", display);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttShowDrawings()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttShowDrawings");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="on">optional object on</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BarRounding(object on)
		{
			return Factory.ExecuteBoolMethodGet(this, "BarRounding", on);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BarRounding()
		{
			return Factory.ExecuteBoolMethodGet(this, "BarRounding");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alwaysRollup">optional object alwaysRollup</param>
		/// <param name="hideWhenSummaryExpanded">optional object hideWhenSummaryExpanded</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttRollup(object alwaysRollup, object hideWhenSummaryExpanded)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttRollup", alwaysRollup, hideWhenSummaryExpanded);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttRollup()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttRollup");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alwaysRollup">optional object alwaysRollup</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttRollup(object alwaysRollup)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttRollup", alwaysRollup);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="dateFormat">NetOffice.MSProjectApi.Enums.PjDateFormat dateFormat</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarTextDateFormat(NetOffice.MSProjectApi.Enums.PjDateFormat dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarTextDateFormat", dateFormat);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">NetOffice.MSProjectApi.Enums.PjBarSize size</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarSize(NetOffice.MSProjectApi.Enums.PjBarSize size)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarSize", size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleDelete(string item)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleDelete", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="insideText">optional object insideText</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText, object leftText, object rightText, object insideText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText, leftText, rightText, insideText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", item, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", item, create, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", item, create, name, startShape);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="leftText">optional object leftText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText, object leftText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText, leftText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttBarStyleEdit(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText, object leftText, object rightText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleEdit", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText, leftText, rightText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="gridlines">optional object gridlines</param>
		/// <param name="crossMarks">optional object crossMarks</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		/// <param name="field5">optional object field5</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat, object gridlines, object crossMarks, object field1, object field2, object field3, object field4, object field5)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", new object[]{ size, dateFormat, gridlines, crossMarks, field1, field2, field3, field4, field5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles()
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", size, dateFormat);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="gridlines">optional object gridlines</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat, object gridlines)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", size, dateFormat, gridlines);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="gridlines">optional object gridlines</param>
		/// <param name="crossMarks">optional object crossMarks</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat, object gridlines, object crossMarks)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", size, dateFormat, gridlines, crossMarks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="gridlines">optional object gridlines</param>
		/// <param name="crossMarks">optional object crossMarks</param>
		/// <param name="field1">optional object field1</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat, object gridlines, object crossMarks, object field1)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", new object[]{ size, dateFormat, gridlines, crossMarks, field1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="gridlines">optional object gridlines</param>
		/// <param name="crossMarks">optional object crossMarks</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat, object gridlines, object crossMarks, object field1, object field2)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", new object[]{ size, dateFormat, gridlines, crossMarks, field1, field2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="gridlines">optional object gridlines</param>
		/// <param name="crossMarks">optional object crossMarks</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat, object gridlines, object crossMarks, object field1, object field2, object field3)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", new object[]{ size, dateFormat, gridlines, crossMarks, field1, field2, field3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="size">optional object size</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="gridlines">optional object gridlines</param>
		/// <param name="crossMarks">optional object crossMarks</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTBoxStyles(object size, object dateFormat, object gridlines, object crossMarks, object field1, object field2, object field3, object field4)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTBoxStyles", new object[]{ size, dateFormat, gridlines, crossMarks, field1, field2, field3, field4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="create">optional object create</param>
		/// <param name="move">optional object move</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="xPosition">optional object xPosition</param>
		/// <param name="yPosition">optional object yPosition</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTSetTask(object create, object move, object taskID, object xPosition, object yPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTSetTask", new object[]{ create, move, taskID, xPosition, yPosition });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTSetTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTSetTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="create">optional object create</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTSetTask(object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTSetTask", create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="create">optional object create</param>
		/// <param name="move">optional object move</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTSetTask(object create, object move)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTSetTask", create, move);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="create">optional object create</param>
		/// <param name="move">optional object move</param>
		/// <param name="taskID">optional object taskID</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTSetTask(object create, object move, object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTSetTask", create, move, taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="create">optional object create</param>
		/// <param name="move">optional object move</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="xPosition">optional object xPosition</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool PERTSetTask(object create, object move, object taskID, object xPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "PERTSetTask", create, move, taskID, xPosition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		/// <param name="proposedRightShowAs">optional object proposedRightShowAs</param>
		/// <param name="proposedRightColor">optional object proposedRightColor</param>
		/// <param name="proposedRightPattern">optional object proposedRightPattern</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern, object proposedRightShowAs, object proposedRightColor, object proposedRightPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern, proposedRightShowAs, proposedRightColor, proposedRightPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", topLeftShowAs);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", topLeftShowAs, topLeftColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", topLeftShowAs, topLeftColor, topLeftPattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		/// <param name="proposedRightShowAs">optional object proposedRightShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern, object proposedRightShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern, proposedRightShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		/// <param name="proposedRightShowAs">optional object proposedRightShowAs</param>
		/// <param name="proposedRightColor">optional object proposedRightColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceGraphBarStyles(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern, object proposedRightShowAs, object proposedRightColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStyles", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern, proposedRightShowAs, proposedRightColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="filenames">object filenames</param>
		/// <param name="newWindow">object newWindow</param>
		/// <param name="attachToSources">object attachToSources</param>
		/// <param name="poolResources">object poolResources</param>
		/// <param name="hideSubtasks">object hideSubtasks</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="password">optional object password</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ConsolidateProjects(object filenames, object newWindow, object attachToSources, object poolResources, object hideSubtasks, object openPool, object userID, object password)
		{
			return Factory.ExecuteBoolMethodGet(this, "ConsolidateProjects", new object[]{ filenames, newWindow, attachToSources, poolResources, hideSubtasks, openPool, userID, password });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="filenames">object filenames</param>
		/// <param name="newWindow">object newWindow</param>
		/// <param name="attachToSources">object attachToSources</param>
		/// <param name="poolResources">object poolResources</param>
		/// <param name="hideSubtasks">object hideSubtasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ConsolidateProjects(object filenames, object newWindow, object attachToSources, object poolResources, object hideSubtasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "ConsolidateProjects", new object[]{ filenames, newWindow, attachToSources, poolResources, hideSubtasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="filenames">object filenames</param>
		/// <param name="newWindow">object newWindow</param>
		/// <param name="attachToSources">object attachToSources</param>
		/// <param name="poolResources">object poolResources</param>
		/// <param name="hideSubtasks">object hideSubtasks</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ConsolidateProjects(object filenames, object newWindow, object attachToSources, object poolResources, object hideSubtasks, object openPool)
		{
			return Factory.ExecuteBoolMethodGet(this, "ConsolidateProjects", new object[]{ filenames, newWindow, attachToSources, poolResources, hideSubtasks, openPool });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="filenames">object filenames</param>
		/// <param name="newWindow">object newWindow</param>
		/// <param name="attachToSources">object attachToSources</param>
		/// <param name="poolResources">object poolResources</param>
		/// <param name="hideSubtasks">object hideSubtasks</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="userID">optional object userID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ConsolidateProjects(object filenames, object newWindow, object attachToSources, object poolResources, object hideSubtasks, object openPool, object userID)
		{
			return Factory.ExecuteBoolMethodGet(this, "ConsolidateProjects", new object[]{ filenames, newWindow, attachToSources, poolResources, hideSubtasks, openPool, userID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjOrganizer Type = 0</param>
		/// <param name="task">optional object task</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Organizer(object type, object task)
		{
			return Factory.ExecuteBoolMethodGet(this, "Organizer", type, task);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Organizer()
		{
			return Factory.ExecuteBoolMethodGet(this, "Organizer");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjOrganizer Type = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Organizer(object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "Organizer", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="toFileName">optional object toFileName</param>
		/// <param name="name">optional object name</param>
		/// <param name="task">optional object task</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerMoveItem(object type, object fileName, object toFileName, object name, object task)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerMoveItem", new object[]{ type, fileName, toFileName, name, task });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerMoveItem()
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerMoveItem");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerMoveItem(object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerMoveItem", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerMoveItem(object type, object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerMoveItem", type, fileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="toFileName">optional object toFileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerMoveItem(object type, object fileName, object toFileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerMoveItem", type, fileName, toFileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="toFileName">optional object toFileName</param>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerMoveItem(object type, object fileName, object toFileName, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerMoveItem", type, fileName, toFileName, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="name">optional object name</param>
		/// <param name="task">optional object task</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerDeleteItem(object type, object fileName, object name, object task)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerDeleteItem", type, fileName, name, task);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerDeleteItem()
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerDeleteItem");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerDeleteItem(object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerDeleteItem", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerDeleteItem(object type, object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerDeleteItem", type, fileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerDeleteItem(object type, object fileName, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerDeleteItem", type, fileName, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="name">optional object name</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="task">optional object task</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerRenameItem(object type, object fileName, object name, object newName, object task)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerRenameItem", new object[]{ type, fileName, name, newName, task });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerRenameItem()
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerRenameItem");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerRenameItem(object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerRenameItem", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerRenameItem(object type, object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerRenameItem", type, fileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerRenameItem(object type, object fileName, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerRenameItem", type, fileName, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="name">optional object name</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OrganizerRenameItem(object type, object fileName, object name, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OrganizerRenameItem", type, fileName, name, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool RecurringTaskInsert()
		{
			return Factory.ExecuteBoolMethodGet(this, "RecurringTaskInsert");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarTimescale()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarTimescale");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		/// <param name="bottomColor">optional object bottomColor</param>
		/// <param name="topPattern">optional object topPattern</param>
		/// <param name="bottomPattern">optional object bottomPattern</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor, object bottomColor, object topPattern, object bottomPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor, bottomColor, topPattern, bottomPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", topLeft);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft, object topRight)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", topLeft, topRight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft, object topRight, object bottomLeft)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", topLeft, topRight, bottomLeft);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft, object topRight, object bottomLeft, object bottomRight)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", topLeft, topRight, bottomLeft, bottomRight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		/// <param name="bottomColor">optional object bottomColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor, object bottomColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor, bottomColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		/// <param name="bottomColor">optional object bottomColor</param>
		/// <param name="topPattern">optional object topPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateBoxes(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor, object bottomColor, object topPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxes", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor, bottomColor, topPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		/// <param name="dayTitle">optional object dayTitle</param>
		/// <param name="showPreview">optional object showPreview</param>
		/// <param name="daysPerWeek">optional object daysPerWeek</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadings(object monthTitle, object weekTitle, object dayTitle, object showPreview, object daysPerWeek)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadings", new object[]{ monthTitle, weekTitle, dayTitle, showPreview, daysPerWeek });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadings()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadings");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadings(object monthTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadings", monthTitle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadings(object monthTitle, object weekTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadings", monthTitle, weekTitle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		/// <param name="dayTitle">optional object dayTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadings(object monthTitle, object weekTitle, object dayTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadings", monthTitle, weekTitle, dayTitle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		/// <param name="dayTitle">optional object dayTitle</param>
		/// <param name="showPreview">optional object showPreview</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadings(object monthTitle, object weekTitle, object dayTitle, object showPreview)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadings", monthTitle, weekTitle, dayTitle, showPreview);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjCalendarShading item</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateShadingEdit(NetOffice.MSProjectApi.Enums.PjCalendarShading item, object pattern, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShadingEdit", item, pattern, color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjCalendarShading item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateShadingEdit(NetOffice.MSProjectApi.Enums.PjCalendarShading item)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShadingEdit", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjCalendarShading item</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateShadingEdit(NetOffice.MSProjectApi.Enums.PjCalendarShading item, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShadingEdit", item, pattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="baseCalendarName">optional object baseCalendarName</param>
		/// <param name="resourceUniqueID">optional object resourceUniqueID</param>
		/// <param name="projectIndex">optional object projectIndex</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateShading(object baseCalendarName, object resourceUniqueID, object projectIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShading", baseCalendarName, resourceUniqueID, projectIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateShading()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShading");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="baseCalendarName">optional object baseCalendarName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateShading(object baseCalendarName)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShading", baseCalendarName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="baseCalendarName">optional object baseCalendarName</param>
		/// <param name="resourceUniqueID">optional object resourceUniqueID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarDateShading(object baseCalendarName, object resourceUniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShading", baseCalendarName, resourceUniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numWeeks">optional object numWeeks</param>
		/// <param name="startDate">optional object startDate</param>
		/// <param name="endDate">optional object endDate</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomCalendar(object numWeeks, object startDate, object endDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomCalendar", numWeeks, startDate, endDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomCalendar()
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomCalendar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numWeeks">optional object numWeeks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomCalendar(object numWeeks)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomCalendar", numWeeks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="numWeeks">optional object numWeeks</param>
		/// <param name="startDate">optional object startDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ZoomCalendar(object numWeeks, object startDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomCalendar", numWeeks, startDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="sortOrder">optional object sortOrder</param>
		/// <param name="autoLayout">optional object autoLayout</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarLayout(object sortOrder, object autoLayout)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarLayout", sortOrder, autoLayout);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarLayout()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarLayout");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="sortOrder">optional object sortOrder</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarLayout(object sortOrder)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarLayout", sortOrder);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="barRounding">optional object barRounding</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStyles(object barRounding)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStyles", barRounding);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStyles()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStyles");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		/// <param name="field5">optional object field5</param>
		/// <param name="splitPattern">optional object splitPattern</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3, object field4, object field5, object splitPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3, field4, field5, splitPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", item, bar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", item, bar, pattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", item, bar, pattern, color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap, shadow });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3, object field4)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3, field4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		/// <param name="field5">optional object field5</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBarStylesEdit(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3, object field4, object field5)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEdit", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3, field4, field5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarBestFitWeekHeight()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBestFitWeekHeight");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">NetOffice.MSProjectApi.Enums.PjShape type</param>
		/// <param name="behind">optional object behind</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingCreate(NetOffice.MSProjectApi.Enums.PjShape type, object behind)
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingCreate", type, behind);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">NetOffice.MSProjectApi.Enums.PjShape type</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingCreate(NetOffice.MSProjectApi.Enums.PjShape type)
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingCreate", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="forward">optional object forward</param>
		/// <param name="full">optional object full</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingMove(object forward, object full)
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingMove", forward, full);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingMove()
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingMove");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="forward">optional object forward</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingMove(object forward)
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingMove", forward);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingReshape()
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingReshape");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="sizePositionTab">optional object sizePositionTab</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingProperties(object sizePositionTab)
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingProperties", sizePositionTab);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingProperties()
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingProperties");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingCycleColor()
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingCycleColor");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FormatCopy()
		{
			return Factory.ExecuteBoolMethodGet(this, "FormatCopy");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FormatPaste()
		{
			return Factory.ExecuteBoolMethodGet(this, "FormatPaste");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FormatPainter()
		{
			return Factory.ExecuteBoolMethodGet(this, "FormatPainter");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="toolbarName">optional object toolbarName</param>
		/// <param name="newToolbarName">optional object newToolbarName</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Toolbars(object action, object toolbarName, object newToolbarName)
		{
			return Factory.ExecuteBoolMethodGet(this, "Toolbars", action, toolbarName, newToolbarName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Toolbars()
		{
			return Factory.ExecuteBoolMethodGet(this, "Toolbars");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Toolbars(object action)
		{
			return Factory.ExecuteBoolMethodGet(this, "Toolbars", action);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="toolbarName">optional object toolbarName</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Toolbars(object action, object toolbarName)
		{
			return Factory.ExecuteBoolMethodGet(this, "Toolbars", action, toolbarName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		/// <param name="command">optional object command</param>
		/// <param name="faceIndex">optional object faceIndex</param>
		/// <param name="description">optional object description</param>
		/// <param name="toolTip">optional object toolTip</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarInsertTool(string toolbarName, Int16 buttonIndex, object command, object faceIndex, object description, object toolTip)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarInsertTool", new object[]{ toolbarName, buttonIndex, command, faceIndex, description, toolTip });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarInsertTool(string toolbarName, Int16 buttonIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarInsertTool", toolbarName, buttonIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		/// <param name="command">optional object command</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarInsertTool(string toolbarName, Int16 buttonIndex, object command)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarInsertTool", toolbarName, buttonIndex, command);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		/// <param name="command">optional object command</param>
		/// <param name="faceIndex">optional object faceIndex</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarInsertTool(string toolbarName, Int16 buttonIndex, object command, object faceIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarInsertTool", toolbarName, buttonIndex, command, faceIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		/// <param name="command">optional object command</param>
		/// <param name="faceIndex">optional object faceIndex</param>
		/// <param name="description">optional object description</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarInsertTool(string toolbarName, Int16 buttonIndex, object command, object faceIndex, object description)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarInsertTool", new object[]{ toolbarName, buttonIndex, command, faceIndex, description });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarDeleteTool(string toolbarName, Int16 buttonIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarDeleteTool", toolbarName, buttonIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarsCustomize()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarsCustomize");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">optional object toolbarName</param>
		/// <param name="buttonIndex">optional object buttonIndex</param>
		/// <param name="command">optional object command</param>
		/// <param name="faceIndex">optional object faceIndex</param>
		/// <param name="description">optional object description</param>
		/// <param name="toolTip">optional object toolTip</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCustomizeTool(object toolbarName, object buttonIndex, object command, object faceIndex, object description, object toolTip)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCustomizeTool", new object[]{ toolbarName, buttonIndex, command, faceIndex, description, toolTip });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCustomizeTool()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCustomizeTool");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">optional object toolbarName</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCustomizeTool(object toolbarName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCustomizeTool", toolbarName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">optional object toolbarName</param>
		/// <param name="buttonIndex">optional object buttonIndex</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCustomizeTool(object toolbarName, object buttonIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCustomizeTool", toolbarName, buttonIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">optional object toolbarName</param>
		/// <param name="buttonIndex">optional object buttonIndex</param>
		/// <param name="command">optional object command</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCustomizeTool(object toolbarName, object buttonIndex, object command)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCustomizeTool", toolbarName, buttonIndex, command);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">optional object toolbarName</param>
		/// <param name="buttonIndex">optional object buttonIndex</param>
		/// <param name="command">optional object command</param>
		/// <param name="faceIndex">optional object faceIndex</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCustomizeTool(object toolbarName, object buttonIndex, object command, object faceIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCustomizeTool", toolbarName, buttonIndex, command, faceIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">optional object toolbarName</param>
		/// <param name="buttonIndex">optional object buttonIndex</param>
		/// <param name="command">optional object command</param>
		/// <param name="faceIndex">optional object faceIndex</param>
		/// <param name="description">optional object description</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCustomizeTool(object toolbarName, object buttonIndex, object command, object faceIndex, object description)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCustomizeTool", new object[]{ toolbarName, buttonIndex, command, faceIndex, description });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarCopyToolFace(string toolbarName, Int16 buttonIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarCopyToolFace", toolbarName, buttonIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="toolbarName">string toolbarName</param>
		/// <param name="buttonIndex">Int16 buttonIndex</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToolbarPasteToolFace(string toolbarName, Int16 buttonIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToolbarPasteToolFace", toolbarName, buttonIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontBold(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontBold", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontBold()
		{
			return Factory.ExecuteBoolMethodGet(this, "FontBold");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontItalic(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontItalic", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontItalic()
		{
			return Factory.ExecuteBoolMethodGet(this, "FontItalic");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontUnderLine(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontUnderLine", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontUnderLine()
		{
			return Factory.ExecuteBoolMethodGet(this, "FontUnderLine");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="align">NetOffice.MSProjectApi.Enums.PjAlignment align</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ColumnAlignment(NetOffice.MSProjectApi.Enums.PjAlignment align)
		{
			return Factory.ExecuteBoolMethodGet(this, "ColumnAlignment", align);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Reports()
		{
			return Factory.ExecuteBoolMethodGet(this, "Reports");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TipOfTheDay()
		{
			return Factory.ExecuteBoolMethodGet(this, "TipOfTheDay");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FindFile()
		{
			return Factory.ExecuteBoolMethodGet(this, "FindFile");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="dataFile">string dataFile</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailUpdateProject(string dataFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailUpdateProject", dataFile);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="fields">optional object fields</param>
		/// <param name="updateAsOf">optional object updateAsOf</param>
		/// <param name="showDialog">optional object showDialog</param>
		/// <param name="installationMessage">optional object installationMessage</param>
		/// <param name="updateFrom">optional object updateFrom</param>
		/// <param name="publishScope">optional object publishScope</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject, object body, object fields, object updateAsOf, object showDialog, object installationMessage, object updateFrom, object publishScope)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", new object[]{ messageType, subject, body, fields, updateAsOf, showDialog, installationMessage, updateFrom, publishScope });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail()
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", messageType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", messageType, subject);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject, object body)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", messageType, subject, body);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="fields">optional object fields</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject, object body, object fields)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", messageType, subject, body, fields);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="fields">optional object fields</param>
		/// <param name="updateAsOf">optional object updateAsOf</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject, object body, object fields, object updateAsOf)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", new object[]{ messageType, subject, body, fields, updateAsOf });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="fields">optional object fields</param>
		/// <param name="updateAsOf">optional object updateAsOf</param>
		/// <param name="showDialog">optional object showDialog</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject, object body, object fields, object updateAsOf, object showDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", new object[]{ messageType, subject, body, fields, updateAsOf, showDialog });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="fields">optional object fields</param>
		/// <param name="updateAsOf">optional object updateAsOf</param>
		/// <param name="showDialog">optional object showDialog</param>
		/// <param name="installationMessage">optional object installationMessage</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject, object body, object fields, object updateAsOf, object showDialog, object installationMessage)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", new object[]{ messageType, subject, body, fields, updateAsOf, showDialog, installationMessage });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="messageType">optional object messageType</param>
		/// <param name="subject">optional object subject</param>
		/// <param name="body">optional object body</param>
		/// <param name="fields">optional object fields</param>
		/// <param name="updateAsOf">optional object updateAsOf</param>
		/// <param name="showDialog">optional object showDialog</param>
		/// <param name="installationMessage">optional object installationMessage</param>
		/// <param name="updateFrom">optional object updateFrom</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailSendProjectMail(object messageType, object subject, object body, object fields, object updateAsOf, object showDialog, object installationMessage, object updateFrom)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailSendProjectMail", new object[]{ messageType, subject, body, fields, updateAsOf, showDialog, installationMessage, updateFrom });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebInbox()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebInbox");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttChartWizard()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttChartWizard");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DrawingToolbarShow()
		{
			return Factory.ExecuteBoolMethodGet(this, "DrawingToolbarShow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="start">optional object start</param>
		/// <param name="leadTime">optional object leadTime</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReminderSet(object start, object leadTime)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReminderSet", start, leadTime);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReminderSet()
		{
			return Factory.ExecuteBoolMethodGet(this, "ReminderSet");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="start">optional object start</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ReminderSet(object start)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReminderSet", start);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="start">optional object start</param>
		/// <param name="leadTime">optional object leadTime</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SchedulePlusReminderSet(object start, object leadTime)
		{
			return Factory.ExecuteBoolMethodGet(this, "SchedulePlusReminderSet", start, leadTime);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SchedulePlusReminderSet()
		{
			return Factory.ExecuteBoolMethodGet(this, "SchedulePlusReminderSet");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="start">optional object start</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SchedulePlusReminderSet(object start)
		{
			return Factory.ExecuteBoolMethodGet(this, "SchedulePlusReminderSet", start);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="date">optional object date</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarTaskList(object date)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarTaskList", date);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarTaskList()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarTaskList");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineSymbolsToggle(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineSymbolsToggle", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OutlineSymbolsToggle()
		{
			return Factory.ExecuteBoolMethodGet(this, "OutlineSymbolsToggle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">NetOffice.MSProjectApi.Enums.PjPoolAction action</param>
		/// <param name="fileName">optional object fileName</param>
		/// <param name="readOnly">optional object readOnly</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharingPoolAction(NetOffice.MSProjectApi.Enums.PjPoolAction action, object fileName, object readOnly)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharingPoolAction", action, fileName, readOnly);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">NetOffice.MSProjectApi.Enums.PjPoolAction action</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharingPoolAction(NetOffice.MSProjectApi.Enums.PjPoolAction action)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharingPoolAction", action);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">NetOffice.MSProjectApi.Enums.PjPoolAction action</param>
		/// <param name="fileName">optional object fileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharingPoolAction(NetOffice.MSProjectApi.Enums.PjPoolAction action, object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharingPoolAction", action, fileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceActiveDirectory()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceActiveDirectory");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAddressBook()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAddressBook");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceDetails(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceDetails", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceDetails()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceDetails");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="position">optional object position</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="title">optional object title</param>
		/// <param name="includeInTeamStatus">optional object includeInTeamStatus</param>
		/// <param name="editable">optional object editable</param>
		/// <param name="useAssignmentField">optional object useAssignmentField</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize(object action, object position, object fieldID, object title, object includeInTeamStatus, object editable, object useAssignmentField)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize", new object[]{ action, position, fieldID, title, includeInTeamStatus, editable, useAssignmentField });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize()
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize(object action)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize", action);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="position">optional object position</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize(object action, object position)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize", action, position);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="position">optional object position</param>
		/// <param name="fieldID">optional object fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize(object action, object position, object fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize", action, position, fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="position">optional object position</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="title">optional object title</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize(object action, object position, object fieldID, object title)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize", action, position, fieldID, title);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="position">optional object position</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="title">optional object title</param>
		/// <param name="includeInTeamStatus">optional object includeInTeamStatus</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize(object action, object position, object fieldID, object title, object includeInTeamStatus)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize", new object[]{ action, position, fieldID, title, includeInTeamStatus });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		/// <param name="position">optional object position</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="title">optional object title</param>
		/// <param name="includeInTeamStatus">optional object includeInTeamStatus</param>
		/// <param name="editable">optional object editable</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MailProjectMailCustomize(object action, object position, object fieldID, object title, object includeInTeamStatus, object editable)
		{
			return Factory.ExecuteBoolMethodGet(this, "MailProjectMailCustomize", new object[]{ action, position, fieldID, title, includeInTeamStatus, editable });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileQuit(object save)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileQuit", save);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileQuit()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileQuit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool About()
		{
			return Factory.ExecuteBoolMethodGet(this, "About");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alignCellData">optional object alignCellData</param>
		/// <param name="repeatRowLabel">optional object repeatRowLabel</param>
		/// <param name="shortLabels">optional object shortLabels</param>
		/// <param name="displayDetailsColumn">optional object displayDetailsColumn</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesProperties(object alignCellData, object repeatRowLabel, object shortLabels, object displayDetailsColumn)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesProperties", alignCellData, repeatRowLabel, shortLabels, displayDetailsColumn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesProperties()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesProperties");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alignCellData">optional object alignCellData</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesProperties(object alignCellData)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesProperties", alignCellData);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alignCellData">optional object alignCellData</param>
		/// <param name="repeatRowLabel">optional object repeatRowLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesProperties(object alignCellData, object repeatRowLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesProperties", alignCellData, repeatRowLabel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alignCellData">optional object alignCellData</param>
		/// <param name="repeatRowLabel">optional object repeatRowLabel</param>
		/// <param name="shortLabels">optional object shortLabels</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesProperties(object alignCellData, object repeatRowLabel, object shortLabels)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesProperties", alignCellData, repeatRowLabel, shortLabels);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional NetOffice.MSProjectApi.Enums.PjTimescaledData Item = 0</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesToggleItem(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesToggleItem", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DetailStylesToggleItem()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesToggleItem");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AutoFilter()
		{
			return Factory.ExecuteBoolMethodGet(this, "AutoFilter");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewBar()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewBar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MacroShowVba()
		{
			return Factory.ExecuteBoolMethodGet(this, "MacroShowVba");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MacroShowCode()
		{
			return Factory.ExecuteBoolMethodGet(this, "MacroShowCode");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebGoBack()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebGoBack");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebGoForward()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebGoForward");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebStopLoading()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebStopLoading");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebRefresh()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebRefresh");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenStartPage()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenStartPage");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenSearchPage()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenSearchPage");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="hide">optional object hide</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebHideToolbars(object hide)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebHideToolbars", hide);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebHideToolbars()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebHideToolbars");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		/// <param name="addHistory">optional object addHistory</param>
		/// <param name="newWindow">optional object newWindow</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FollowHyperlink(object address, object subAddress, object addHistory, object newWindow)
		{
			return Factory.ExecuteBoolMethodGet(this, "FollowHyperlink", address, subAddress, addHistory, newWindow);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FollowHyperlink()
		{
			return Factory.ExecuteBoolMethodGet(this, "FollowHyperlink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FollowHyperlink(object address)
		{
			return Factory.ExecuteBoolMethodGet(this, "FollowHyperlink", address);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FollowHyperlink(object address, object subAddress)
		{
			return Factory.ExecuteBoolMethodGet(this, "FollowHyperlink", address, subAddress);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		/// <param name="addHistory">optional object addHistory</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FollowHyperlink(object address, object subAddress, object addHistory)
		{
			return Factory.ExecuteBoolMethodGet(this, "FollowHyperlink", address, subAddress, addHistory);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditPasteAsHyperlink()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditPasteAsHyperlink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		/// <param name="screenTip">optional object screenTip</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InsertHyperlink(object name, object address, object subAddress, object screenTip)
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertHyperlink", name, address, subAddress, screenTip);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InsertHyperlink()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertHyperlink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InsertHyperlink(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertHyperlink", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="address">optional object address</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InsertHyperlink(object name, object address)
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertHyperlink", name, address);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool InsertHyperlink(object name, object address, object subAddress)
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertHyperlink", name, address, subAddress);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		/// <param name="screenTip">optional object screenTip</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditHyperlink(object name, object address, object subAddress, object screenTip)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditHyperlink", name, address, subAddress, screenTip);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditHyperlink()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditHyperlink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditHyperlink(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditHyperlink", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="address">optional object address</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditHyperlink(object name, object address)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditHyperlink", name, address);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditHyperlink(object name, object address, object subAddress)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditHyperlink", name, address, subAddress);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		/// <param name="addHistory">optional object addHistory</param>
		/// <param name="newWindow">optional object newWindow</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenHyperlink(object address, object subAddress, object addHistory, object newWindow)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenHyperlink", address, subAddress, addHistory, newWindow);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenHyperlink()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenHyperlink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenHyperlink(object address)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenHyperlink", address);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenHyperlink(object address, object subAddress)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenHyperlink", address, subAddress);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		/// <param name="subAddress">optional object subAddress</param>
		/// <param name="addHistory">optional object addHistory</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenHyperlink(object address, object subAddress, object addHistory)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenHyperlink", address, subAddress, addHistory);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebCopyHyperlink()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebCopyHyperlink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="currentLink">optional object currentLink</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebAddToFavorites(object currentLink)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebAddToFavorites", currentLink);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebAddToFavorites()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebAddToFavorites");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditClearHyperlink()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditClearHyperlink");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebSetStartPage(object address)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebSetStartPage", address);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebSetStartPage()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebSetStartPage");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="address">optional object address</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebSetSearchPage(object address)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebSetSearchPage", address);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebSetSearchPage()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebSetSearchPage");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebOpenFavorites()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebOpenFavorites");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebToolbar(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebToolbar", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebToolbar()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebToolbar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="_lock">optional object lock</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SplitTask(object _lock)
		{
			return Factory.ExecuteBoolMethodGet(this, "SplitTask", _lock);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SplitTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "SplitTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="phonetic">optional object phonetic</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldRename(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object newName, object phonetic)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldRename", fieldID, newName, phonetic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldRename(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldRename", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldRename(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldRename", fieldID, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomizeField()
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomizeField");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="display">optional object display</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttShowBarSplits(object display)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttShowBarSplits", display);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GanttShowBarSplits()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttShowBarSplits");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="display">optional object display</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarShowBarSplits(object display)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarShowBarSplits", display);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarShowBarSplits()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarShowBarSplits");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		/// <param name="assignmentData">optional object assignmentData</param>
		/// <param name="textDelimiter">optional object textDelimiter</param>
		/// <param name="textFileOrigin">optional object textFileOrigin</param>
		/// <param name="useHtmlTemplate">optional object useHtmlTemplate</param>
		/// <param name="templateFile">optional object templateFile</param>
		/// <param name="includeImage">optional object includeImage</param>
		/// <param name="imageFile">optional object imageFile</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow, object assignmentData, object textDelimiter, object textFileOrigin, object useHtmlTemplate, object templateFile, object includeImage, object imageFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow, assignmentData, textDelimiter, textFileOrigin, useHtmlTemplate, templateFile, includeImage, imageFile });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit()
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", name, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", name, create, overwriteExisting);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", name, create, overwriteExisting, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		/// <param name="assignmentData">optional object assignmentData</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow, object assignmentData)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow, assignmentData });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		/// <param name="assignmentData">optional object assignmentData</param>
		/// <param name="textDelimiter">optional object textDelimiter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow, object assignmentData, object textDelimiter)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow, assignmentData, textDelimiter });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		/// <param name="assignmentData">optional object assignmentData</param>
		/// <param name="textDelimiter">optional object textDelimiter</param>
		/// <param name="textFileOrigin">optional object textFileOrigin</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow, object assignmentData, object textDelimiter, object textFileOrigin)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow, assignmentData, textDelimiter, textFileOrigin });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		/// <param name="assignmentData">optional object assignmentData</param>
		/// <param name="textDelimiter">optional object textDelimiter</param>
		/// <param name="textFileOrigin">optional object textFileOrigin</param>
		/// <param name="useHtmlTemplate">optional object useHtmlTemplate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow, object assignmentData, object textDelimiter, object textFileOrigin, object useHtmlTemplate)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow, assignmentData, textDelimiter, textFileOrigin, useHtmlTemplate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		/// <param name="assignmentData">optional object assignmentData</param>
		/// <param name="textDelimiter">optional object textDelimiter</param>
		/// <param name="textFileOrigin">optional object textFileOrigin</param>
		/// <param name="useHtmlTemplate">optional object useHtmlTemplate</param>
		/// <param name="templateFile">optional object templateFile</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow, object assignmentData, object textDelimiter, object textFileOrigin, object useHtmlTemplate, object templateFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow, assignmentData, textDelimiter, textFileOrigin, useHtmlTemplate, templateFile });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="dataCategory">optional object dataCategory</param>
		/// <param name="categoryEnabled">optional object categoryEnabled</param>
		/// <param name="tableName">optional object tableName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="externalFieldName">optional object externalFieldName</param>
		/// <param name="exportFilter">optional object exportFilter</param>
		/// <param name="importMethod">optional object importMethod</param>
		/// <param name="mergeKey">optional object mergeKey</param>
		/// <param name="headerRow">optional object headerRow</param>
		/// <param name="assignmentData">optional object assignmentData</param>
		/// <param name="textDelimiter">optional object textDelimiter</param>
		/// <param name="textFileOrigin">optional object textFileOrigin</param>
		/// <param name="useHtmlTemplate">optional object useHtmlTemplate</param>
		/// <param name="templateFile">optional object templateFile</param>
		/// <param name="includeImage">optional object includeImage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MapEdit(object name, object create, object overwriteExisting, object newName, object dataCategory, object categoryEnabled, object tableName, object fieldName, object externalFieldName, object exportFilter, object importMethod, object mergeKey, object headerRow, object assignmentData, object textDelimiter, object textFileOrigin, object useHtmlTemplate, object templateFile, object includeImage)
		{
			return Factory.ExecuteBoolMethodGet(this, "MapEdit", new object[]{ name, create, overwriteExisting, newName, dataCategory, categoryEnabled, tableName, fieldName, externalFieldName, exportFilter, importMethod, mergeKey, headerRow, assignmentData, textDelimiter, textFileOrigin, useHtmlTemplate, templateFile, includeImage });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="right">optional object right</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FillAcross(object right)
		{
			return Factory.ExecuteBoolMethodGet(this, "FillAcross", right);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FillAcross()
		{
			return Factory.ExecuteBoolMethodGet(this, "FillAcross");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="acceptAll">optional object acceptAll</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinksBetweenProjects(object acceptAll)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinksBetweenProjects", acceptAll);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LinksBetweenProjects()
		{
			return Factory.ExecuteBoolMethodGet(this, "LinksBetweenProjects");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToggleAssignments()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleAssignments");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ProgressLines()
		{
			return Factory.ExecuteBoolMethodGet(this, "ProgressLines");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="allSharers">optional object allSharers</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharingPoolUpdate(object allSharers)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharingPoolUpdate", allSharers);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharingPoolUpdate()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharingPoolUpdate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceSharingPoolRefresh()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceSharingPoolRefresh");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="type">optional object type</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebHelp(object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "WebHelp", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WebHelp()
		{
			return Factory.ExecuteBoolMethodGet(this, "WebHelp");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AddProgressLine()
		{
			return Factory.ExecuteBoolMethodGet(this, "AddProgressLine");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">optional NetOffice.MSProjectApi.Enums.PjField FieldID = -1</param>
		/// <param name="iMEMode">optional NetOffice.MSProjectApi.Enums.PjIMEMode IMEMode = -1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomizeIMEMode(object fieldID, object iMEMode)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomizeIMEMode", fieldID, iMEMode);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomizeIMEMode()
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomizeIMEMode");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">optional NetOffice.MSProjectApi.Enums.PjField FieldID = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomizeIMEMode(object fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomizeIMEMode", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		/// <param name="formatID">optional object formatID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DeleteFromDatabase(object name, object userID, object databasePassWord, object formatID)
		{
			return Factory.ExecuteBoolMethodGet(this, "DeleteFromDatabase", name, userID, databasePassWord, formatID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DeleteFromDatabase()
		{
			return Factory.ExecuteBoolMethodGet(this, "DeleteFromDatabase");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DeleteFromDatabase(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "DeleteFromDatabase", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="userID">optional object userID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DeleteFromDatabase(object name, object userID)
		{
			return Factory.ExecuteBoolMethodGet(this, "DeleteFromDatabase", name, userID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="userID">optional object userID</param>
		/// <param name="databasePassWord">optional object databasePassWord</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DeleteFromDatabase(object name, object userID, object databasePassWord)
		{
			return Factory.ExecuteBoolMethodGet(this, "DeleteFromDatabase", name, userID, databasePassWord);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeRenumber(object all)
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeRenumber", all);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeRenumber()
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeRenumber");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="codePrefix">object codePrefix</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjWBSSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="codeGenerate">optional object codeGenerate</param>
		/// <param name="verifyUniqueness">optional object verifyUniqueness</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeMaskEdit(object codePrefix, object level, object sequence, object length, object separator, object codeGenerate, object verifyUniqueness)
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeMaskEdit", new object[]{ codePrefix, level, sequence, length, separator, codeGenerate, verifyUniqueness });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="codePrefix">object codePrefix</param>
		/// <param name="level">object level</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeMaskEdit(object codePrefix, object level)
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeMaskEdit", codePrefix, level);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="codePrefix">object codePrefix</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjWBSSequence Sequence = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeMaskEdit(object codePrefix, object level, object sequence)
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeMaskEdit", codePrefix, level, sequence);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="codePrefix">object codePrefix</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjWBSSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeMaskEdit(object codePrefix, object level, object sequence, object length)
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeMaskEdit", codePrefix, level, sequence, length);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="codePrefix">object codePrefix</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjWBSSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeMaskEdit(object codePrefix, object level, object sequence, object length, object separator)
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeMaskEdit", new object[]{ codePrefix, level, sequence, length, separator });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="codePrefix">object codePrefix</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjWBSSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="codeGenerate">optional object codeGenerate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WBSCodeMaskEdit(object codePrefix, object level, object sequence, object length, object separator, object codeGenerate)
		{
			return Factory.ExecuteBoolMethodGet(this, "WBSCodeMaskEdit", new object[]{ codePrefix, level, sequence, length, separator, codeGenerate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		/// <param name="matchGeneric">optional object matchGeneric</param>
		/// <param name="requiredCode">optional object requiredCode</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves, object matchGeneric, object requiredCode)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves, matchGeneric, requiredCode });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", fieldID, level);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", fieldID, level, sequence);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", fieldID, level, sequence, length);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", new object[]{ fieldID, level, sequence, length, separator });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		/// <param name="matchGeneric">optional object matchGeneric</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEdit(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves, object matchGeneric)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEdit", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves, matchGeneric });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		/// <param name="defaultWorkgroupTemplatesPath">optional object defaultWorkgroupTemplatesPath</param>
		/// <param name="expandDatabaseTimephasedData">optional object expandDatabaseTimephasedData</param>
		/// <param name="automaticSave">optional object automaticSave</param>
		/// <param name="automaticSaveInterval">optional object automaticSaveInterval</param>
		/// <param name="automaticSaveOptions">optional object automaticSaveOptions</param>
		/// <param name="automaticSavePrompt">optional object automaticSavePrompt</param>
		/// <param name="setDefaultsDatabase">optional object setDefaultsDatabase</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath, object defaultWorkgroupTemplatesPath, object expandDatabaseTimephasedData, object automaticSave, object automaticSaveInterval, object automaticSaveOptions, object automaticSavePrompt, object setDefaultsDatabase)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", new object[]{ defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath, defaultWorkgroupTemplatesPath, expandDatabaseTimephasedData, automaticSave, automaticSaveInterval, automaticSaveOptions, automaticSavePrompt, setDefaultsDatabase });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", defaultSaveFormat);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", defaultSaveFormat, defaultProjectsPath);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		/// <param name="defaultWorkgroupTemplatesPath">optional object defaultWorkgroupTemplatesPath</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath, object defaultWorkgroupTemplatesPath)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath, defaultWorkgroupTemplatesPath);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		/// <param name="defaultWorkgroupTemplatesPath">optional object defaultWorkgroupTemplatesPath</param>
		/// <param name="expandDatabaseTimephasedData">optional object expandDatabaseTimephasedData</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath, object defaultWorkgroupTemplatesPath, object expandDatabaseTimephasedData)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", new object[]{ defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath, defaultWorkgroupTemplatesPath, expandDatabaseTimephasedData });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		/// <param name="defaultWorkgroupTemplatesPath">optional object defaultWorkgroupTemplatesPath</param>
		/// <param name="expandDatabaseTimephasedData">optional object expandDatabaseTimephasedData</param>
		/// <param name="automaticSave">optional object automaticSave</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath, object defaultWorkgroupTemplatesPath, object expandDatabaseTimephasedData, object automaticSave)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", new object[]{ defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath, defaultWorkgroupTemplatesPath, expandDatabaseTimephasedData, automaticSave });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		/// <param name="defaultWorkgroupTemplatesPath">optional object defaultWorkgroupTemplatesPath</param>
		/// <param name="expandDatabaseTimephasedData">optional object expandDatabaseTimephasedData</param>
		/// <param name="automaticSave">optional object automaticSave</param>
		/// <param name="automaticSaveInterval">optional object automaticSaveInterval</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath, object defaultWorkgroupTemplatesPath, object expandDatabaseTimephasedData, object automaticSave, object automaticSaveInterval)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", new object[]{ defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath, defaultWorkgroupTemplatesPath, expandDatabaseTimephasedData, automaticSave, automaticSaveInterval });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		/// <param name="defaultWorkgroupTemplatesPath">optional object defaultWorkgroupTemplatesPath</param>
		/// <param name="expandDatabaseTimephasedData">optional object expandDatabaseTimephasedData</param>
		/// <param name="automaticSave">optional object automaticSave</param>
		/// <param name="automaticSaveInterval">optional object automaticSaveInterval</param>
		/// <param name="automaticSaveOptions">optional object automaticSaveOptions</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath, object defaultWorkgroupTemplatesPath, object expandDatabaseTimephasedData, object automaticSave, object automaticSaveInterval, object automaticSaveOptions)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", new object[]{ defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath, defaultWorkgroupTemplatesPath, expandDatabaseTimephasedData, automaticSave, automaticSaveInterval, automaticSaveOptions });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultSaveFormat">optional object defaultSaveFormat</param>
		/// <param name="defaultProjectsPath">optional object defaultProjectsPath</param>
		/// <param name="defaultUserTemplatesPath">optional object defaultUserTemplatesPath</param>
		/// <param name="defaultWorkgroupTemplatesPath">optional object defaultWorkgroupTemplatesPath</param>
		/// <param name="expandDatabaseTimephasedData">optional object expandDatabaseTimephasedData</param>
		/// <param name="automaticSave">optional object automaticSave</param>
		/// <param name="automaticSaveInterval">optional object automaticSaveInterval</param>
		/// <param name="automaticSaveOptions">optional object automaticSaveOptions</param>
		/// <param name="automaticSavePrompt">optional object automaticSavePrompt</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSave(object defaultSaveFormat, object defaultProjectsPath, object defaultUserTemplatesPath, object defaultWorkgroupTemplatesPath, object expandDatabaseTimephasedData, object automaticSave, object automaticSaveInterval, object automaticSaveOptions, object automaticSavePrompt)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSave", new object[]{ defaultSaveFormat, defaultProjectsPath, defaultUserTemplatesPath, defaultWorkgroupTemplatesPath, expandDatabaseTimephasedData, automaticSave, automaticSaveInterval, automaticSaveOptions, automaticSavePrompt });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OfficeOnTheWeb()
		{
			return Factory.ExecuteBoolMethodGet(this, "OfficeOnTheWeb");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FixMe()
		{
			return Factory.ExecuteBoolMethodGet(this, "FixMe");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowWorkAvailability()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowWorkAvailability");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ViewShowUnitAvailability()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewShowUnitAvailability");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		/// <param name="from">optional object from</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineClear(object all, object from)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineClear", all, from);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineClear()
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineClear");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="all">optional object all</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BaselineClear(object all)
		{
			return Factory.ExecuteBoolMethodGet(this, "BaselineClear", all);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Groups()
		{
			return Factory.ExecuteBoolMethodGet(this, "Groups");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GroupApply(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "GroupApply", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GroupApply()
		{
			return Factory.ExecuteBoolMethodGet(this, "GroupApply");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GroupBy()
		{
			return Factory.ExecuteBoolMethodGet(this, "GroupBy");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">optional object level</param>
		/// <param name="code">optional object code</param>
		/// <param name="description">optional object description</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object code, object description)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAdd", fieldID, level, code, description);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAdd", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">optional object level</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAdd", fieldID, level);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">optional object level</param>
		/// <param name="code">optional object code</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object code)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAdd", fieldID, level, code);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor BackgroundColor = -1</param>
		/// <param name="backgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern BackgroundPattern = -1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxStylesEdit(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor, object backgroundPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEdit", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor, backgroundPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxStylesEdit(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEdit", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxStylesEdit(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEdit", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		/// <param name="borderWidth">object borderWidth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxStylesEdit(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEdit", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor BackgroundColor = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxStylesEdit(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEdit", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor BackgroundColor = -1</param>
		/// <param name="backgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern BackgroundPattern = -1</param>
		/// <param name="reset">optional object reset</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxFormat(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor, object backgroundPattern, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormat", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor, backgroundPattern, reset });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxFormat(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormat", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxFormat(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormat", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		/// <param name="borderWidth">object borderWidth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxFormat(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormat", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor BackgroundColor = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxFormat(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormat", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">optional NetOffice.MSProjectApi.Enums.PjColor BorderColor = -1</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor BackgroundColor = -1</param>
		/// <param name="backgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern BackgroundPattern = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxFormat(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor, object backgroundPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormat", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor, backgroundPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BarBoxFormat()
		{
			return Factory.ExecuteBoolMethodGet(this, "BarBoxFormat");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">object serverURL</param>
		/// <param name="name">object name</param>
		/// <param name="authenticationType">optional NetOffice.MSProjectApi.Enums.PjAuthentication AuthenticationType = 0</param>
		/// <param name="accountType">optional NetOffice.MSProjectApi.Enums.PjAccountType AccountType = 0</param>
		/// <param name="showDialog">optional object showDialog</param>
		/// <param name="email">optional object email</param>
		/// <param name="windowsAccount">optional object windowsAccount</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreateWebAccount(object serverURL, object name, object authenticationType, object accountType, object showDialog, object email, object windowsAccount)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateWebAccount", new object[]{ serverURL, name, authenticationType, accountType, showDialog, email, windowsAccount });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">object serverURL</param>
		/// <param name="name">object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreateWebAccount(object serverURL, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateWebAccount", serverURL, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">object serverURL</param>
		/// <param name="name">object name</param>
		/// <param name="authenticationType">optional NetOffice.MSProjectApi.Enums.PjAuthentication AuthenticationType = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreateWebAccount(object serverURL, object name, object authenticationType)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateWebAccount", serverURL, name, authenticationType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">object serverURL</param>
		/// <param name="name">object name</param>
		/// <param name="authenticationType">optional NetOffice.MSProjectApi.Enums.PjAuthentication AuthenticationType = 0</param>
		/// <param name="accountType">optional NetOffice.MSProjectApi.Enums.PjAccountType AccountType = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreateWebAccount(object serverURL, object name, object authenticationType, object accountType)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateWebAccount", serverURL, name, authenticationType, accountType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">object serverURL</param>
		/// <param name="name">object name</param>
		/// <param name="authenticationType">optional NetOffice.MSProjectApi.Enums.PjAuthentication AuthenticationType = 0</param>
		/// <param name="accountType">optional NetOffice.MSProjectApi.Enums.PjAccountType AccountType = 0</param>
		/// <param name="showDialog">optional object showDialog</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreateWebAccount(object serverURL, object name, object authenticationType, object accountType, object showDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateWebAccount", new object[]{ serverURL, name, authenticationType, accountType, showDialog });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">object serverURL</param>
		/// <param name="name">object name</param>
		/// <param name="authenticationType">optional NetOffice.MSProjectApi.Enums.PjAuthentication AuthenticationType = 0</param>
		/// <param name="accountType">optional NetOffice.MSProjectApi.Enums.PjAccountType AccountType = 0</param>
		/// <param name="showDialog">optional object showDialog</param>
		/// <param name="email">optional object email</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreateWebAccount(object serverURL, object name, object authenticationType, object accountType, object showDialog, object email)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateWebAccount", new object[]{ serverURL, name, authenticationType, accountType, showDialog, email });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="action">NetOffice.MSProjectApi.Enums.PjDataTemplate action</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="overwrite">optional object overwrite</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxDataTemplate(string name, NetOffice.MSProjectApi.Enums.PjDataTemplate action, object newName, object overwrite)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxDataTemplate", name, action, newName, overwrite);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="action">NetOffice.MSProjectApi.Enums.PjDataTemplate action</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxDataTemplate(string name, NetOffice.MSProjectApi.Enums.PjDataTemplate action)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxDataTemplate", name, action);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="action">NetOffice.MSProjectApi.Enums.PjDataTemplate action</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxDataTemplate(string name, NetOffice.MSProjectApi.Enums.PjDataTemplate action, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxDataTemplate", name, action, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cellRows">optional object cellRows</param>
		/// <param name="cellColumns">optional object cellColumns</param>
		/// <param name="cellWidth">optional object cellWidth</param>
		/// <param name="mergeCells">optional object mergeCells</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellLayout(string name, object cellRows, object cellColumns, object cellWidth, object mergeCells)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellLayout", new object[]{ name, cellRows, cellColumns, cellWidth, mergeCells });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellLayout(string name)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellLayout", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cellRows">optional object cellRows</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellLayout(string name, object cellRows)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellLayout", name, cellRows);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cellRows">optional object cellRows</param>
		/// <param name="cellColumns">optional object cellColumns</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellLayout(string name, object cellRows, object cellColumns)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellLayout", name, cellRows, cellColumns);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cellRows">optional object cellRows</param>
		/// <param name="cellColumns">optional object cellColumns</param>
		/// <param name="cellWidth">optional object cellWidth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellLayout(string name, object cellRows, object cellColumns, object cellWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellLayout", name, cellRows, cellColumns, cellWidth);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">optional NetOffice.MSProjectApi.Enums.PjColor FontColor = -1</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		/// <param name="showLabel">object showLabel</param>
		/// <param name="label">object label</param>
		/// <param name="dateFormat">optional NetOffice.MSProjectApi.Enums.PjDateFormat DateFormat = -1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellEdit(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit, object showLabel, object label, object dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEdit", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit, showLabel, label, dateFormat });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">optional NetOffice.MSProjectApi.Enums.PjColor FontColor = -1</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellEdit(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEdit", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">optional NetOffice.MSProjectApi.Enums.PjColor FontColor = -1</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellEdit(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEdit", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">optional NetOffice.MSProjectApi.Enums.PjColor FontColor = -1</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellEdit(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEdit", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">optional NetOffice.MSProjectApi.Enums.PjColor FontColor = -1</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		/// <param name="showLabel">object showLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellEdit(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit, object showLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEdit", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit, showLabel });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">optional NetOffice.MSProjectApi.Enums.PjColor FontColor = -1</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		/// <param name="showLabel">object showLabel</param>
		/// <param name="label">object label</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxCellEdit(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit, object showLabel, object label)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEdit", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit, showLabel, label });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="showDialog">optional object showDialog</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceWindowsAccount(object name, object showDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceWindowsAccount", name, showDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceWindowsAccount()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceWindowsAccount");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceWindowsAccount(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceWindowsAccount", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="unit">optional object unit</param>
		/// <param name="rows">optional object rows</param>
		/// <param name="useUniqueID">optional object useUniqueID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetRowHeight(object unit, object rows, object useUniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetRowHeight", unit, rows, useUniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetRowHeight()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetRowHeight");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="unit">optional object unit</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetRowHeight(object unit)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetRowHeight", unit);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="unit">optional object unit</param>
		/// <param name="rows">optional object rows</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetRowHeight(object unit, object rows)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetRowHeight", unit, rows);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ComAddInsDialog()
		{
			return Factory.ExecuteBoolMethodGet(this, "ComAddInsDialog");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MacroSecurity()
		{
			return Factory.ExecuteBoolMethodGet(this, "MacroSecurity");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LayoutSelectionNow()
		{
			return Factory.ExecuteBoolMethodGet(this, "LayoutSelectionNow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlign Alignment = -1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxAlign(object alignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxAlign", alignment);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxAlign()
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxAlign");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ConvertHangulToHanja()
		{
			return Factory.ExecuteBoolMethodGet(this, "ConvertHangulToHanja");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="embedProjectFile">optional object embedProjectFile</param>
		/// <param name="onlyRegisterProject">optional object onlyRegisterProject</param>
		/// <param name="waitForCompletion">optional object waitForCompletion</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProjectToWeb(object serverURL, object embedProjectFile, object onlyRegisterProject, object waitForCompletion)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProjectToWeb", serverURL, embedProjectFile, onlyRegisterProject, waitForCompletion);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProjectToWeb()
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProjectToWeb");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">optional object serverURL</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProjectToWeb(object serverURL)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProjectToWeb", serverURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="embedProjectFile">optional object embedProjectFile</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProjectToWeb(object serverURL, object embedProjectFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProjectToWeb", serverURL, embedProjectFile);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">optional object serverURL</param>
		/// <param name="embedProjectFile">optional object embedProjectFile</param>
		/// <param name="onlyRegisterProject">optional object onlyRegisterProject</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool UpdateProjectToWeb(object serverURL, object embedProjectFile, object onlyRegisterProject)
		{
			return Factory.ExecuteBoolMethodGet(this, "UpdateProjectToWeb", serverURL, embedProjectFile, onlyRegisterProject);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		/// <param name="summaryCalc">optional NetOffice.MSProjectApi.Enums.PjSummaryCalc SummaryCalc = -1</param>
		/// <param name="graphicalIndicators">optional object graphicalIndicators</param>
		/// <param name="required">optional object required</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldProperties(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute, object summaryCalc, object graphicalIndicators, object required)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldProperties", new object[]{ fieldID, attribute, summaryCalc, graphicalIndicators, required });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldProperties(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldProperties", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldProperties(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldProperties", fieldID, attribute);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		/// <param name="summaryCalc">optional NetOffice.MSProjectApi.Enums.PjSummaryCalc SummaryCalc = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldProperties(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute, object summaryCalc)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldProperties", fieldID, attribute, summaryCalc);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		/// <param name="summaryCalc">optional NetOffice.MSProjectApi.Enums.PjSummaryCalc SummaryCalc = -1</param>
		/// <param name="graphicalIndicators">optional object graphicalIndicators</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldProperties(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute, object summaryCalc, object graphicalIndicators)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldProperties", fieldID, attribute, summaryCalc, graphicalIndicators);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="formula">optional object formula</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldSetFormula(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object formula)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldSetFormula", fieldID, formula);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldSetFormula(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldSetFormula", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="test">NetOffice.MSProjectApi.Enums.PjComparison test</param>
		/// <param name="value">string value</param>
		/// <param name="indicatorID">NetOffice.MSProjectApi.Enums.PjIndicator indicatorID</param>
		/// <param name="criteriaList">optional NetOffice.MSProjectApi.Enums.PjCriteriaList CriteriaList = 0</param>
		/// <param name="index">optional object index</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicatorAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, NetOffice.MSProjectApi.Enums.PjComparison test, string value, NetOffice.MSProjectApi.Enums.PjIndicator indicatorID, object criteriaList, object index)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicatorAdd", new object[]{ fieldID, test, value, indicatorID, criteriaList, index });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="test">NetOffice.MSProjectApi.Enums.PjComparison test</param>
		/// <param name="value">string value</param>
		/// <param name="indicatorID">NetOffice.MSProjectApi.Enums.PjIndicator indicatorID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicatorAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, NetOffice.MSProjectApi.Enums.PjComparison test, string value, NetOffice.MSProjectApi.Enums.PjIndicator indicatorID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicatorAdd", fieldID, test, value, indicatorID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="test">NetOffice.MSProjectApi.Enums.PjComparison test</param>
		/// <param name="value">string value</param>
		/// <param name="indicatorID">NetOffice.MSProjectApi.Enums.PjIndicator indicatorID</param>
		/// <param name="criteriaList">optional NetOffice.MSProjectApi.Enums.PjCriteriaList CriteriaList = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicatorAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, NetOffice.MSProjectApi.Enums.PjComparison test, string value, NetOffice.MSProjectApi.Enums.PjIndicator indicatorID, object criteriaList)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicatorAdd", new object[]{ fieldID, test, value, indicatorID, criteriaList });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="summaryInheritsNonsummary">optional object summaryInheritsNonsummary</param>
		/// <param name="projectInheritsSummary">optional object projectInheritsSummary</param>
		/// <param name="showToolTips">optional object showToolTips</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicators(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object summaryInheritsNonsummary, object projectInheritsSummary, object showToolTips)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicators", fieldID, summaryInheritsNonsummary, projectInheritsSummary, showToolTips);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicators(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicators", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="summaryInheritsNonsummary">optional object summaryInheritsNonsummary</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicators(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object summaryInheritsNonsummary)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicators", fieldID, summaryInheritsNonsummary);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="summaryInheritsNonsummary">optional object summaryInheritsNonsummary</param>
		/// <param name="projectInheritsSummary">optional object projectInheritsSummary</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicators(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object summaryInheritsNonsummary, object projectInheritsSummary)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicators", fieldID, summaryInheritsNonsummary, projectInheritsSummary);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="index">Int16 index</param>
		/// <param name="criteriaList">optional NetOffice.MSProjectApi.Enums.PjCriteriaList CriteriaList = 0</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicatorDelete(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, Int16 index, object criteriaList)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicatorDelete", fieldID, index, criteriaList);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="index">Int16 index</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldIndicatorDelete(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, Int16 index)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldIndicatorDelete", fieldID, index);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="listDefault">object listDefault</param>
		/// <param name="defaultValue">object defaultValue</param>
		/// <param name="restrictToList">object restrictToList</param>
		/// <param name="appendNew">object appendNew</param>
		/// <param name="promptOnNew">object promptOnNew</param>
		/// <param name="displayOrder">optional NetOffice.MSProjectApi.Enums.PjListOrder DisplayOrder = -1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueList(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object listDefault, object defaultValue, object restrictToList, object appendNew, object promptOnNew, object displayOrder)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueList", new object[]{ fieldID, listDefault, defaultValue, restrictToList, appendNew, promptOnNew, displayOrder });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="listDefault">object listDefault</param>
		/// <param name="defaultValue">object defaultValue</param>
		/// <param name="restrictToList">object restrictToList</param>
		/// <param name="appendNew">object appendNew</param>
		/// <param name="promptOnNew">object promptOnNew</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueList(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object listDefault, object defaultValue, object restrictToList, object appendNew, object promptOnNew)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueList", new object[]{ fieldID, listDefault, defaultValue, restrictToList, appendNew, promptOnNew });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="value">optional object value</param>
		/// <param name="description">optional object description</param>
		/// <param name="phonetic">optional object phonetic</param>
		/// <param name="index">optional object index</param>
		/// <param name="fieldDefault">optional object fieldDefault</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueListAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object value, object description, object phonetic, object index, object fieldDefault)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueListAdd", new object[]{ fieldID, value, description, phonetic, index, fieldDefault });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueListAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueListAdd", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="value">optional object value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueListAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object value)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueListAdd", fieldID, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="value">optional object value</param>
		/// <param name="description">optional object description</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueListAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object value, object description)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueListAdd", fieldID, value, description);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="value">optional object value</param>
		/// <param name="description">optional object description</param>
		/// <param name="phonetic">optional object phonetic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueListAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object value, object description, object phonetic)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueListAdd", fieldID, value, description, phonetic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="value">optional object value</param>
		/// <param name="description">optional object description</param>
		/// <param name="phonetic">optional object phonetic</param>
		/// <param name="index">optional object index</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueListAdd(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object value, object description, object phonetic, object index)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueListAdd", new object[]{ fieldID, value, description, phonetic, index });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="index">Int16 index</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldValueListDelete(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, Int16 index)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldValueListDelete", fieldID, index);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor ViewBackgroundColor = -1</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		/// <param name="showProgressMarks">optional object showProgressMarks</param>
		/// <param name="showPageBreaks">optional object showPageBreaks</param>
		/// <param name="showIDOnly">optional object showIDOnly</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern, object showProgressMarks, object showPageBreaks, object showIDOnly)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern, showProgressMarks, showPageBreaks, showIDOnly });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor ViewBackgroundColor = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor ViewBackgroundColor = -1</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor ViewBackgroundColor = -1</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		/// <param name="showProgressMarks">optional object showProgressMarks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern, object showProgressMarks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern, showProgressMarks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">optional NetOffice.MSProjectApi.Enums.PjColor ViewBackgroundColor = -1</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		/// <param name="showProgressMarks">optional object showProgressMarks</param>
		/// <param name="showPageBreaks">optional object showPageBreaks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLayout(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern, object showProgressMarks, object showPageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayout", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern, showProgressMarks, showPageBreaks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		/// <param name="colorMode">optional NetOffice.MSProjectApi.Enums.PjLinkColorMode ColorMode = -1</param>
		/// <param name="criticalColor">optional NetOffice.MSProjectApi.Enums.PjColor CriticalColor = 1</param>
		/// <param name="noncriticalColor">optional NetOffice.MSProjectApi.Enums.PjColor NoncriticalColor = 0</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinks(object style, object showArrows, object showLabels, object colorMode, object criticalColor, object noncriticalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinks", new object[]{ style, showArrows, showLabels, colorMode, criticalColor, noncriticalColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinks(object style, object showArrows)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinks", style, showArrows);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinks(object style, object showArrows, object showLabels)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinks", style, showArrows, showLabels);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		/// <param name="colorMode">optional NetOffice.MSProjectApi.Enums.PjLinkColorMode ColorMode = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinks(object style, object showArrows, object showLabels, object colorMode)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinks", style, showArrows, showLabels, colorMode);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		/// <param name="colorMode">optional NetOffice.MSProjectApi.Enums.PjLinkColorMode ColorMode = -1</param>
		/// <param name="criticalColor">optional NetOffice.MSProjectApi.Enums.PjColor CriticalColor = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinks(object style, object showArrows, object showLabels, object colorMode, object criticalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinks", new object[]{ style, showArrows, showLabels, colorMode, criticalColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SummaryTasksShow(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "SummaryTasksShow", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SummaryTasksShow()
		{
			return Factory.ExecuteBoolMethodGet(this, "SummaryTasksShow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxProgressMarksShow(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxProgressMarksShow", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxProgressMarksShow()
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxProgressMarksShow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinkLabelsShow(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinkLabelsShow", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinkLabelsShow()
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinkLabelsShow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="straightLinks">optional object straightLinks</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinkStyleToggle(object straightLinks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinkStyleToggle", straightLinks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxLinkStyleToggle()
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinkStyleToggle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LayoutRelatedNow()
		{
			return Factory.ExecuteBoolMethodGet(this, "LayoutRelatedNow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional NetOffice.MSProjectApi.Enums.PjBoxSet Action = 4</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="xPosition">optional object xPosition</param>
		/// <param name="yPosition">optional object yPosition</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxSet(object action, object taskID, object xPosition, object yPosition, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxSet", new object[]{ action, taskID, xPosition, yPosition, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxSet()
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxSet");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional NetOffice.MSProjectApi.Enums.PjBoxSet Action = 4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxSet(object action)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxSet", action);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional NetOffice.MSProjectApi.Enums.PjBoxSet Action = 4</param>
		/// <param name="taskID">optional object taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxSet(object action, object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxSet", action, taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional NetOffice.MSProjectApi.Enums.PjBoxSet Action = 4</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="xPosition">optional object xPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxSet(object action, object taskID, object xPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxSet", action, taskID, xPosition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="action">optional NetOffice.MSProjectApi.Enums.PjBoxSet Action = 4</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="xPosition">optional object xPosition</param>
		/// <param name="yPosition">optional object yPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool BoxSet(object action, object taskID, object xPosition, object yPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxSet", action, taskID, xPosition, yPosition);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showColumns">optional object showColumns</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetSplitBar(object showColumns)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetSplitBar", showColumns);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetSplitBar()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetSplitBar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="titleHeight">optional object titleHeight</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetTitleRowHeight(object titleHeight)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTitleRowHeight", titleHeight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SetTitleRowHeight()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTitleRowHeight");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="goalArea">Int16 goalArea</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool GoalAreaChange(Int16 goalArea)
		{
			return Factory.ExecuteBoolMethodGet(this, "GoalAreaChange", goalArea);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SidepaneToggle(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "SidepaneToggle", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SidepaneToggle()
		{
			return Factory.ExecuteBoolMethodGet(this, "SidepaneToggle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SearchFiles()
		{
			return Factory.ExecuteBoolMethodGet(this, "SearchFiles");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ImportOutlookTasks()
		{
			return Factory.ExecuteBoolMethodGet(this, "ImportOutlookTasks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		/// <param name="projectGuideUseDefaultContent">optional object projectGuideUseDefaultContent</param>
		/// <param name="projectGuideContent">optional object projectGuideContent</param>
		/// <param name="setAsDefaults">optional object setAsDefaults</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage, object projectGuideUseDefaultContent, object projectGuideContent, object setAsDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage, projectGuideUseDefaultContent, projectGuideContent, setAsDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", showResourceAssignmentIndicators);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", showResourceAssignmentIndicators, showEditToStartFinishDates);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		/// <param name="projectGuideUseDefaultContent">optional object projectGuideUseDefaultContent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage, object projectGuideUseDefaultContent)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage, projectGuideUseDefaultContent });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		/// <param name="projectGuideUseDefaultContent">optional object projectGuideUseDefaultContent</param>
		/// <param name="projectGuideContent">optional object projectGuideContent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterface(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage, object projectGuideUseDefaultContent, object projectGuideContent)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterface", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage, projectGuideUseDefaultContent, projectGuideContent });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="iD">Int16 iD</param>
		/// <param name="isGoalArea">optional object isGoalArea</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SidepaneTaskChange(Int16 iD, object isGoalArea)
		{
			return Factory.ExecuteBoolMethodGet(this, "SidepaneTaskChange", iD, isGoalArea);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="iD">Int16 iD</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SidepaneTaskChange(Int16 iD)
		{
			return Factory.ExecuteBoolMethodGet(this, "SidepaneTaskChange", iD);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="serverURL">optional object serverURL</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ImportResourceList(object serverURL)
		{
			return Factory.ExecuteBoolMethodGet(this, "ImportResourceList", serverURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ImportResourceList()
		{
			return Factory.ExecuteBoolMethodGet(this, "ImportResourceList");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		/// <param name="rBSorResourceList">optional object rBSorResourceList</param>
		/// <param name="freezeHorizonDate">optional object freezeHorizonDate</param>
		/// <param name="updateProjects">optional object updateProjects</param>
		/// <param name="saveReport">optional object saveReport</param>
		/// <param name="path">optional object path</param>
		/// <param name="assignProposedResources">optional object assignProposedResources</param>
		/// <param name="levelProposedBookings">optional object levelProposedBookings</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption, object rBSorResourceList, object freezeHorizonDate, object updateProjects, object saveReport, object path, object assignProposedResources, object levelProposedBookings)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", new object[]{ projectList, poolOption, rBSorResourceList, freezeHorizonDate, updateProjects, saveReport, path, assignProposedResources, levelProposedBookings });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", projectList);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", projectList, poolOption);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		/// <param name="rBSorResourceList">optional object rBSorResourceList</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption, object rBSorResourceList)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", projectList, poolOption, rBSorResourceList);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		/// <param name="rBSorResourceList">optional object rBSorResourceList</param>
		/// <param name="freezeHorizonDate">optional object freezeHorizonDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption, object rBSorResourceList, object freezeHorizonDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", projectList, poolOption, rBSorResourceList, freezeHorizonDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		/// <param name="rBSorResourceList">optional object rBSorResourceList</param>
		/// <param name="freezeHorizonDate">optional object freezeHorizonDate</param>
		/// <param name="updateProjects">optional object updateProjects</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption, object rBSorResourceList, object freezeHorizonDate, object updateProjects)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", new object[]{ projectList, poolOption, rBSorResourceList, freezeHorizonDate, updateProjects });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		/// <param name="rBSorResourceList">optional object rBSorResourceList</param>
		/// <param name="freezeHorizonDate">optional object freezeHorizonDate</param>
		/// <param name="updateProjects">optional object updateProjects</param>
		/// <param name="saveReport">optional object saveReport</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption, object rBSorResourceList, object freezeHorizonDate, object updateProjects, object saveReport)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", new object[]{ projectList, poolOption, rBSorResourceList, freezeHorizonDate, updateProjects, saveReport });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		/// <param name="rBSorResourceList">optional object rBSorResourceList</param>
		/// <param name="freezeHorizonDate">optional object freezeHorizonDate</param>
		/// <param name="updateProjects">optional object updateProjects</param>
		/// <param name="saveReport">optional object saveReport</param>
		/// <param name="path">optional object path</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption, object rBSorResourceList, object freezeHorizonDate, object updateProjects, object saveReport, object path)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", new object[]{ projectList, poolOption, rBSorResourceList, freezeHorizonDate, updateProjects, saveReport, path });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectList">object projectList</param>
		/// <param name="poolOption">optional NetOffice.MSProjectApi.Enums.PjResSubstitutionPoolOption PoolOption = 0</param>
		/// <param name="rBSorResourceList">optional object rBSorResourceList</param>
		/// <param name="freezeHorizonDate">optional object freezeHorizonDate</param>
		/// <param name="updateProjects">optional object updateProjects</param>
		/// <param name="saveReport">optional object saveReport</param>
		/// <param name="path">optional object path</param>
		/// <param name="assignProposedResources">optional object assignProposedResources</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResSubstitutionWizard(object projectList, object poolOption, object rBSorResourceList, object freezeHorizonDate, object updateProjects, object saveReport, object path, object assignProposedResources)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResSubstitutionWizard", new object[]{ projectList, poolOption, rBSorResourceList, freezeHorizonDate, updateProjects, saveReport, path, assignProposedResources });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="eUID">object eUID</param>
		/// <param name="openType">optional NetOffice.MSProjectApi.Enums.PjCheckOutType OpenType = 1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourcesOpen(object eUID, object openType)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourcesOpen", eUID, openType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="eUID">object eUID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourcesOpen(object eUID)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourcesOpen", eUID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="localRUIDs">optional object localRUIDs</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourcesImport(object localRUIDs)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourcesImport", localRUIDs);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourcesImport()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourcesImport");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="eUID">optional object eUID</param>
		/// <param name="rUID">optional object rUID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourceGet(object eUID, object rUID)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourceGet", eUID, rUID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourceGet()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourceGet");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="eUID">optional object eUID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourceGet(object eUID)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourceGet", eUID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseProjectImportWizard(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseProjectImportWizard", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseProjectImportWizard()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseProjectImportWizard");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseTeamBuilder()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseTeamBuilder");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="linkFrom">Int32 linkFrom</param>
		/// <param name="linkTo">optional object linkTo</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseCustomOutlineCodeShare(Int32 linkFrom, object linkTo)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseCustomOutlineCodeShare", linkFrom, linkTo);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="linkFrom">Int32 linkFrom</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseCustomOutlineCodeShare(Int32 linkFrom)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseCustomOutlineCodeShare", linkFrom);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseCustomizeFields()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseCustomizeFields");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseGlobalCheckOut()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseGlobalCheckOut");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseProjectProfiles()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseProjectProfiles");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceListOptions">object showResourceListOptions</param>
		/// <param name="resourceListFields">optional NetOffice.MSProjectApi.Enums.PjAssignResourcesListFields ResourceListFields = 2</param>
		/// <param name="useNamedFilter">optional object useNamedFilter</param>
		/// <param name="filterName">optional object filterName</param>
		/// <param name="useAvailableToWorkFilter">optional object useAvailableToWorkFilter</param>
		/// <param name="availableToWork">optional object availableToWork</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignmentDialog(object showResourceListOptions, object resourceListFields, object useNamedFilter, object filterName, object useAvailableToWorkFilter, object availableToWork)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignmentDialog", new object[]{ showResourceListOptions, resourceListFields, useNamedFilter, filterName, useAvailableToWorkFilter, availableToWork });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceListOptions">object showResourceListOptions</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignmentDialog(object showResourceListOptions)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignmentDialog", showResourceListOptions);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceListOptions">object showResourceListOptions</param>
		/// <param name="resourceListFields">optional NetOffice.MSProjectApi.Enums.PjAssignResourcesListFields ResourceListFields = 2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignmentDialog(object showResourceListOptions, object resourceListFields)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignmentDialog", showResourceListOptions, resourceListFields);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceListOptions">object showResourceListOptions</param>
		/// <param name="resourceListFields">optional NetOffice.MSProjectApi.Enums.PjAssignResourcesListFields ResourceListFields = 2</param>
		/// <param name="useNamedFilter">optional object useNamedFilter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignmentDialog(object showResourceListOptions, object resourceListFields, object useNamedFilter)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignmentDialog", showResourceListOptions, resourceListFields, useNamedFilter);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceListOptions">object showResourceListOptions</param>
		/// <param name="resourceListFields">optional NetOffice.MSProjectApi.Enums.PjAssignResourcesListFields ResourceListFields = 2</param>
		/// <param name="useNamedFilter">optional object useNamedFilter</param>
		/// <param name="filterName">optional object filterName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignmentDialog(object showResourceListOptions, object resourceListFields, object useNamedFilter, object filterName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignmentDialog", showResourceListOptions, resourceListFields, useNamedFilter, filterName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceListOptions">object showResourceListOptions</param>
		/// <param name="resourceListFields">optional NetOffice.MSProjectApi.Enums.PjAssignResourcesListFields ResourceListFields = 2</param>
		/// <param name="useNamedFilter">optional object useNamedFilter</param>
		/// <param name="filterName">optional object filterName</param>
		/// <param name="useAvailableToWorkFilter">optional object useAvailableToWorkFilter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceAssignmentDialog(object showResourceListOptions, object resourceListFields, object useNamedFilter, object filterName, object useAvailableToWorkFilter)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceAssignmentDialog", new object[]{ showResourceListOptions, resourceListFields, useNamedFilter, filterName, useAvailableToWorkFilter });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="targetPage">string targetPage</param>
		/// <param name="wrapperPage">optional object wrapperPage</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadWebBrowserControl(string targetPage, object wrapperPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "LoadWebBrowserControl", targetPage, wrapperPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="targetPage">string targetPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadWebBrowserControl(string targetPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "LoadWebBrowserControl", targetPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveOffline(object save)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveOffline", save);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileSaveOffline()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileSaveOffline");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpReference()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpReference");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool HelpWhatsNew()
		{
			return Factory.ExecuteBoolMethodGet(this, "HelpWhatsNew");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool StopWebBrowserControlNavigation()
		{
			return Factory.ExecuteBoolMethodGet(this, "StopWebBrowserControlNavigation");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="backupFileName">optional object backupFileName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseGlobalBackup(object backupFileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseGlobalBackup", backupFileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseGlobalBackup()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseGlobalBackup");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="profileName">optional object profileName</param>
		/// <param name="restoreFileName">optional object restoreFileName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseGlobalRestore(object profileName, object restoreFileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseGlobalRestore", profileName, restoreFileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseGlobalRestore()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseGlobalRestore");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="profileName">optional object profileName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseGlobalRestore(object profileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseGlobalRestore", profileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjSpellingField FieldName = -1</param>
		/// <param name="enableSpellCheck">optional object enableSpellCheck</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SpellCheckField(object fieldName, object enableSpellCheck)
		{
			return Factory.ExecuteBoolMethodGet(this, "SpellCheckField", fieldName, enableSpellCheck);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SpellCheckField()
		{
			return Factory.ExecuteBoolMethodGet(this, "SpellCheckField");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjSpellingField FieldName = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SpellCheckField(object fieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SpellCheckField", fieldName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool AddResourcesFromProjectServer()
		{
			return Factory.ExecuteBoolMethodGet(this, "AddResourcesFromProjectServer");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResetTrackingMethod()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResetTrackingMethod");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ServiceOptionsDialog()
		{
			return Factory.ExecuteBoolMethodGet(this, "ServiceOptionsDialog");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseProjectDelete(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseProjectDelete", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseProjectDelete()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseProjectDelete");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fSaveChanges">optional object fSaveChanges</param>
		/// <param name="comments">optional object comments</param>
		/// <param name="fMakePublic">optional object fMakePublic</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckIn(object fSaveChanges, object comments, object fMakePublic)
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckIn", fSaveChanges, comments, fMakePublic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckIn()
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckIn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fSaveChanges">optional object fSaveChanges</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckIn(object fSaveChanges)
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckIn", fSaveChanges);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fSaveChanges">optional object fSaveChanges</param>
		/// <param name="comments">optional object comments</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckIn(object fSaveChanges, object comments)
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckIn", fSaveChanges, comments);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckOut()
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckOut");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DocumentLibraryVersionsDialog()
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentLibraryVersionsDialog");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DisplaySharedWorkspace()
		{
			return Factory.ExecuteBoolMethodGet(this, "DisplaySharedWorkspace");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseSynchActuals(object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseSynchActuals", projectName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseSynchActuals()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseSynchActuals");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="removeFileProperties">optional object removeFileProperties</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSecurity(object removeFileProperties)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurity", removeFileProperties);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSecurity()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurity");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SaveSheetSelection()
		{
			return Factory.ExecuteBoolMethodGet(this, "SaveSheetSelection");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool RestoreSheetSelection()
		{
			return Factory.ExecuteBoolMethodGet(this, "RestoreSheetSelection");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="field">Int32 field</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldDelete(Int32 field)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldDelete", field);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="commitmentDate">optional object commitmentDate</param>
		/// <param name="commitmentGuid">optional object commitmentGuid</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ImportCommitment(object commitmentDate, object commitmentGuid)
		{
			return Factory.ExecuteBoolMethodGet(this, "ImportCommitment", commitmentDate, commitmentGuid);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ImportCommitment()
		{
			return Factory.ExecuteBoolMethodGet(this, "ImportCommitment");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="commitmentDate">optional object commitmentDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ImportCommitment(object commitmentDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ImportCommitment", commitmentDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SummaryResourceAssignmentsRefresh()
		{
			return Factory.ExecuteBoolMethodGet(this, "SummaryResourceAssignmentsRefresh");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="uniqueID">optional object uniqueID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditEnterpriseCalendar(object uniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditEnterpriseCalendar", uniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditEnterpriseCalendar()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditEnterpriseCalendar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CreateEnterpriseCalendar()
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateEnterpriseCalendar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="targetPage">string targetPage</param>
		/// <param name="wrapperPage">optional object wrapperPage</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadWebPaneControl(string targetPage, object wrapperPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "LoadWebPaneControl", targetPage, wrapperPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="targetPage">string targetPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadWebPaneControl(string targetPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "LoadWebPaneControl", targetPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ResourceMappingDialog()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceMappingDialog");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="oldName">optional object oldName</param>
		/// <param name="newName">optional object newName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MakeLocalCalendarEnterprise(object oldName, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MakeLocalCalendarEnterprise", oldName, newName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MakeLocalCalendarEnterprise()
		{
			return Factory.ExecuteBoolMethodGet(this, "MakeLocalCalendarEnterprise");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="oldName">optional object oldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MakeLocalCalendarEnterprise(object oldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MakeLocalCalendarEnterprise", oldName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskCustomFields">optional object taskCustomFields</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldMappingDialog(object taskCustomFields)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldMappingDialog", taskCustomFields);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldMappingDialog()
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldMappingDialog");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckTaskErrors(object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckTaskErrors", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckTaskErrors()
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckTaskErrors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="localRUID">optional object localRUID</param>
		/// <param name="resetImport">optional object resetImport</param>
		/// <param name="checkEnterprise">optional object checkEnterprise</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckResourceErrors(object localRUID, object resetImport, object checkEnterprise)
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckResourceErrors", localRUID, resetImport, checkEnterprise);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckResourceErrors()
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckResourceErrors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="localRUID">optional object localRUID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckResourceErrors(object localRUID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckResourceErrors", localRUID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="localRUID">optional object localRUID</param>
		/// <param name="resetImport">optional object resetImport</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CheckResourceErrors(object localRUID, object resetImport)
		{
			return Factory.ExecuteBoolMethodGet(this, "CheckResourceErrors", localRUID, resetImport);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EditRedo()
		{
			return Factory.ExecuteBoolMethodGet(this, "EditRedo");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="republish">optional object republish</param>
		/// <param name="wssUrl">optional object wssUrl</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Publish(object republish, object wssUrl)
		{
			return Factory.ExecuteBoolMethodGet(this, "Publish", republish, wssUrl);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Publish()
		{
			return Factory.ExecuteBoolMethodGet(this, "Publish");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="republish">optional object republish</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Publish(object republish)
		{
			return Factory.ExecuteBoolMethodGet(this, "Publish", republish);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="lookupTableName">optional object lookupTableName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MakeFieldEnterprise(object fieldID, object fieldName, object lookupTableName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MakeFieldEnterprise", fieldID, fieldName, lookupTableName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MakeFieldEnterprise()
		{
			return Factory.ExecuteBoolMethodGet(this, "MakeFieldEnterprise");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">optional object fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MakeFieldEnterprise(object fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "MakeFieldEnterprise", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="fieldName">optional object fieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool MakeFieldEnterprise(object fieldID, object fieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "MakeFieldEnterprise", fieldID, fieldName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fileName">optional object fileName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SaveForSharing(object fileName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SaveForSharing", fileName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool SaveForSharing()
		{
			return Factory.ExecuteBoolMethodGet(this, "SaveForSharing");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CacheSettings()
		{
			return Factory.ExecuteBoolMethodGet(this, "CacheSettings");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CleanupCache()
		{
			return Factory.ExecuteBoolMethodGet(this, "CleanupCache");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CacheStatus()
		{
			return Factory.ExecuteBoolMethodGet(this, "CacheStatus");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fOffline">optional object fOffline</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WorkOffline(object fOffline)
		{
			return Factory.ExecuteBoolMethodGet(this, "WorkOffline", fOffline);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool WorkOffline()
		{
			return Factory.ExecuteBoolMethodGet(this, "WorkOffline");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TaskDrivers()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskDrivers");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ToggleChangeHighlighting()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleChangeHighlighting");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="pjVisualReportsTab">optional NetOffice.MSProjectApi.Enums.PjVisualReportsTab PjVisualReportsTab = 0</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReports(object pjVisualReportsTab)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReports", pjVisualReportsTab);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReports()
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReports");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strNamePath">object strNamePath</param>
		/// <param name="pjVisualReportsDataLevel">optional NetOffice.MSProjectApi.Enums.PjVisualReportsDataLevel PjVisualReportsDataLevel = 5</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsSaveDatabase(object strNamePath, object pjVisualReportsDataLevel)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsSaveDatabase", strNamePath, pjVisualReportsDataLevel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strNamePath">object strNamePath</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsSaveDatabase(object strNamePath)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsSaveDatabase", strNamePath);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strNamePath">object strNamePath</param>
		/// <param name="pjVisualReportsCubeType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsCubeType PjVisualReportsCubeType = 1</param>
		/// <param name="reportAllFields">object reportAllFields</param>
		/// <param name="pjVisualReportsDataLevel">optional NetOffice.MSProjectApi.Enums.PjVisualReportsDataLevel PjVisualReportsDataLevel = 5</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsSaveCube(object strNamePath, object pjVisualReportsCubeType, object reportAllFields, object pjVisualReportsDataLevel)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsSaveCube", strNamePath, pjVisualReportsCubeType, reportAllFields, pjVisualReportsDataLevel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strNamePath">object strNamePath</param>
		/// <param name="pjVisualReportsCubeType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsCubeType PjVisualReportsCubeType = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsSaveCube(object strNamePath, object pjVisualReportsCubeType)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsSaveCube", strNamePath, pjVisualReportsCubeType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strNamePath">object strNamePath</param>
		/// <param name="pjVisualReportsCubeType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsCubeType PjVisualReportsCubeType = 1</param>
		/// <param name="reportAllFields">object reportAllFields</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsSaveCube(object strNamePath, object pjVisualReportsCubeType, object reportAllFields)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsSaveCube", strNamePath, pjVisualReportsCubeType, reportAllFields);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="pjVisualReportsTemplateType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsTemplateType PjVisualReportsTemplateType = 1</param>
		/// <param name="pjVisualReportsCubeType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsCubeType PjVisualReportsCubeType = 1</param>
		/// <param name="reportAllFields">object reportAllFields</param>
		/// <param name="pjVisualReportsDataLevel">optional NetOffice.MSProjectApi.Enums.PjVisualReportsDataLevel PjVisualReportsDataLevel = 5</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsNewTemplate(object pjVisualReportsTemplateType, object pjVisualReportsCubeType, object reportAllFields, object pjVisualReportsDataLevel)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsNewTemplate", pjVisualReportsTemplateType, pjVisualReportsCubeType, reportAllFields, pjVisualReportsDataLevel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="pjVisualReportsTemplateType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsTemplateType PjVisualReportsTemplateType = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsNewTemplate(object pjVisualReportsTemplateType)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsNewTemplate", pjVisualReportsTemplateType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="pjVisualReportsTemplateType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsTemplateType PjVisualReportsTemplateType = 1</param>
		/// <param name="pjVisualReportsCubeType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsCubeType PjVisualReportsCubeType = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsNewTemplate(object pjVisualReportsTemplateType, object pjVisualReportsCubeType)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsNewTemplate", pjVisualReportsTemplateType, pjVisualReportsCubeType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="pjVisualReportsTemplateType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsTemplateType PjVisualReportsTemplateType = 1</param>
		/// <param name="pjVisualReportsCubeType">optional NetOffice.MSProjectApi.Enums.PjVisualReportsCubeType PjVisualReportsCubeType = 1</param>
		/// <param name="reportAllFields">object reportAllFields</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsNewTemplate(object pjVisualReportsTemplateType, object pjVisualReportsCubeType, object reportAllFields)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsNewTemplate", pjVisualReportsTemplateType, pjVisualReportsCubeType, reportAllFields);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strVisualReportTemplateFile">object strVisualReportTemplateFile</param>
		/// <param name="pjVisualReportsDataLevel">optional NetOffice.MSProjectApi.Enums.PjVisualReportsDataLevel PjVisualReportsDataLevel = 5</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsView(object strVisualReportTemplateFile, object pjVisualReportsDataLevel)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsView", strVisualReportTemplateFile, pjVisualReportsDataLevel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strVisualReportTemplateFile">object strVisualReportTemplateFile</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsView(object strVisualReportTemplateFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsView", strVisualReportTemplateFile);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CommitmentsPane()
		{
			return Factory.ExecuteBoolMethodGet(this, "CommitmentsPane");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool DependenciesPane()
		{
			return Factory.ExecuteBoolMethodGet(this, "DependenciesPane");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strVisualReportTemplateFile">object strVisualReportTemplateFile</param>
		/// <param name="pjVisualReportsDataLevel">optional NetOffice.MSProjectApi.Enums.PjVisualReportsDataLevel PjVisualReportsDataLevel = 5</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsEdit(object strVisualReportTemplateFile, object pjVisualReportsDataLevel)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsEdit", strVisualReportTemplateFile, pjVisualReportsDataLevel);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="strVisualReportTemplateFile">object strVisualReportTemplateFile</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool VisualReportsEdit(object strVisualReportTemplateFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "VisualReportsEdit", strVisualReportTemplateFile);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="ignoreReadOnlyRecommended">optional object ignoreReadOnlyRecommended</param>
		/// <param name="xMLName">optional object xMLName</param>
		/// <param name="doNotLoadFromEnterprise">optional object doNotLoadFromEnterprise</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpenEx(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password, object writeResPassword, object ignoreReadOnlyRecommended, object xMLName, object doNotLoadFromEnterprise)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenEx", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password, writeResPassword, ignoreReadOnlyRecommended, xMLName, doNotLoadFromEnterprise });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpenEx(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenEx", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpenEx(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenEx", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpenEx(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenEx", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpenEx(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password, object writeResPassword)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenEx", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password, writeResPassword });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="ignoreReadOnlyRecommended">optional object ignoreReadOnlyRecommended</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpenEx(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password, object writeResPassword, object ignoreReadOnlyRecommended)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenEx", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password, writeResPassword, ignoreReadOnlyRecommended });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="readOnly">object readOnly</param>
		/// <param name="merge">object merge</param>
		/// <param name="taskInformation">object taskInformation</param>
		/// <param name="table">object table</param>
		/// <param name="sheet">object sheet</param>
		/// <param name="noAuto">object noAuto</param>
		/// <param name="userID">object userID</param>
		/// <param name="databasePassWord">object databasePassWord</param>
		/// <param name="formatID">object formatID</param>
		/// <param name="map">object map</param>
		/// <param name="openPool">optional NetOffice.MSProjectApi.Enums.PjPoolOpen openPool = 0</param>
		/// <param name="password">optional object password</param>
		/// <param name="writeResPassword">optional object writeResPassword</param>
		/// <param name="ignoreReadOnlyRecommended">optional object ignoreReadOnlyRecommended</param>
		/// <param name="xMLName">optional object xMLName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileOpenEx(object name, object readOnly, object merge, object taskInformation, object table, object sheet, object noAuto, object userID, object databasePassWord, object formatID, object map, object openPool, object password, object writeResPassword, object ignoreReadOnlyRecommended, object xMLName)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenEx", new object[]{ name, readOnly, merge, taskInformation, table, sheet, noAuto, userID, databasePassWord, formatID, map, openPool, password, writeResPassword, ignoreReadOnlyRecommended, xMLName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		/// <param name="noAuto">optional object noAuto</param>
		/// <param name="checkIn">optional object checkIn</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseEx(object save, object noAuto, object checkIn)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseEx", save, noAuto, checkIn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseEx(object save)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseEx", save);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		/// <param name="noAuto">optional object noAuto</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseEx(object save, object noAuto)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseEx", save, noAuto);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		/// <param name="checkIn">optional object checkIn</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseAllEx(object save, object checkIn)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseAllEx", save, checkIn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseAllEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseAllEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="save">optional NetOffice.MSProjectApi.Enums.PjSaveType Save = 2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FileCloseAllEx(object save)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileCloseAllEx", save);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		/// <param name="recentFilesMaximum">optional object recentFilesMaximum</param>
		/// <param name="fontConversion">optional object fontConversion</param>
		/// <param name="showStartupWorkpane">optional object showStartupWorkpane</param>
		/// <param name="maxUndoRecords">optional object maxUndoRecords</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles, object recentFilesMaximum, object fontConversion, object showStartupWorkpane, object maxUndoRecords)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles, recentFilesMaximum, fontConversion, showStartupWorkpane, maxUndoRecords });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", planningWizard);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", planningWizard, wizardUsage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", planningWizard, wizardUsage, wizardErrors);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", planningWizard, wizardUsage, wizardErrors, wizardScheduling);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		/// <param name="recentFilesMaximum">optional object recentFilesMaximum</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles, object recentFilesMaximum)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles, recentFilesMaximum });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		/// <param name="recentFilesMaximum">optional object recentFilesMaximum</param>
		/// <param name="fontConversion">optional object fontConversion</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles, object recentFilesMaximum, object fontConversion)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles, recentFilesMaximum, fontConversion });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="planningWizard">optional object planningWizard</param>
		/// <param name="wizardUsage">optional object wizardUsage</param>
		/// <param name="wizardErrors">optional object wizardErrors</param>
		/// <param name="wizardScheduling">optional object wizardScheduling</param>
		/// <param name="showTipOfDay">optional object showTipOfDay</param>
		/// <param name="autoAddResources">optional object autoAddResources</param>
		/// <param name="standardRate">optional object standardRate</param>
		/// <param name="overtimeRate">optional object overtimeRate</param>
		/// <param name="lastFile">optional object lastFile</param>
		/// <param name="summaryInfo">optional object summaryInfo</param>
		/// <param name="userName">optional object userName</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="showWelcome">optional object showWelcome</param>
		/// <param name="autoFilter">optional object autoFilter</param>
		/// <param name="macroVirusProtection">optional object macroVirusProtection</param>
		/// <param name="displayRecentFiles">optional object displayRecentFiles</param>
		/// <param name="recentFilesMaximum">optional object recentFilesMaximum</param>
		/// <param name="fontConversion">optional object fontConversion</param>
		/// <param name="showStartupWorkpane">optional object showStartupWorkpane</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsGeneralEx(object planningWizard, object wizardUsage, object wizardErrors, object wizardScheduling, object showTipOfDay, object autoAddResources, object standardRate, object overtimeRate, object lastFile, object summaryInfo, object userName, object setDefaults, object showWelcome, object autoFilter, object macroVirusProtection, object displayRecentFiles, object recentFilesMaximum, object fontConversion, object showStartupWorkpane)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsGeneralEx", new object[]{ planningWizard, wizardUsage, wizardErrors, wizardScheduling, showTipOfDay, autoAddResources, standardRate, overtimeRate, lastFile, summaryInfo, userName, setDefaults, showWelcome, autoFilter, macroVirusProtection, displayRecentFiles, recentFilesMaximum, fontConversion, showStartupWorkpane });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		/// <param name="displayWindowsInTaskbar">optional object displayWindowsInTaskbar</param>
		/// <param name="displayScreentips">optional object displayScreentips</param>
		/// <param name="calendarType">optional object calendarType</param>
		/// <param name="use3DLook">optional object use3DLook</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData, object displayWindowsInTaskbar, object displayScreentips, object calendarType, object use3DLook)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData, displayWindowsInTaskbar, displayScreentips, calendarType, use3DLook });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", defaultView);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", defaultView, dateFormat);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", defaultView, dateFormat, projectSummary);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", defaultView, dateFormat, projectSummary, displayStatusBar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		/// <param name="displayWindowsInTaskbar">optional object displayWindowsInTaskbar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData, object displayWindowsInTaskbar)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData, displayWindowsInTaskbar });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		/// <param name="displayWindowsInTaskbar">optional object displayWindowsInTaskbar</param>
		/// <param name="displayScreentips">optional object displayScreentips</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData, object displayWindowsInTaskbar, object displayScreentips)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData, displayWindowsInTaskbar, displayScreentips });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="defaultView">optional object defaultView</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="projectSummary">optional object projectSummary</param>
		/// <param name="displayStatusBar">optional object displayStatusBar</param>
		/// <param name="displayEntryBar">optional object displayEntryBar</param>
		/// <param name="displayScrollBars">optional object displayScrollBars</param>
		/// <param name="currencySymbol">optional object currencySymbol</param>
		/// <param name="symbolPlacement">optional object symbolPlacement</param>
		/// <param name="currencyDigits">optional object currencyDigits</param>
		/// <param name="projectCurrency">optional object projectCurrency</param>
		/// <param name="displayOutlineNumber">optional object displayOutlineNumber</param>
		/// <param name="displayOutlineSymbols">optional object displayOutlineSymbols</param>
		/// <param name="displayNameIndent">optional object displayNameIndent</param>
		/// <param name="displaySummaryTasks">optional object displaySummaryTasks</param>
		/// <param name="displayOLEIndicator">optional object displayOLEIndicator</param>
		/// <param name="displayExternalSuccessors">optional object displayExternalSuccessors</param>
		/// <param name="displayExternalPredecessors">optional object displayExternalPredecessors</param>
		/// <param name="crossProjectLinksInfo">optional object crossProjectLinksInfo</param>
		/// <param name="acceptNewExternalData">optional object acceptNewExternalData</param>
		/// <param name="displayWindowsInTaskbar">optional object displayWindowsInTaskbar</param>
		/// <param name="displayScreentips">optional object displayScreentips</param>
		/// <param name="calendarType">optional object calendarType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsViewEx(object defaultView, object dateFormat, object projectSummary, object displayStatusBar, object displayEntryBar, object displayScrollBars, object currencySymbol, object symbolPlacement, object currencyDigits, object projectCurrency, object displayOutlineNumber, object displayOutlineSymbols, object displayNameIndent, object displaySummaryTasks, object displayOLEIndicator, object displayExternalSuccessors, object displayExternalPredecessors, object crossProjectLinksInfo, object acceptNewExternalData, object displayWindowsInTaskbar, object displayScreentips, object calendarType)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsViewEx", new object[]{ defaultView, dateFormat, projectSummary, displayStatusBar, displayEntryBar, displayScrollBars, currencySymbol, symbolPlacement, currencyDigits, projectCurrency, displayOutlineNumber, displayOutlineSymbols, displayNameIndent, displaySummaryTasks, displayOLEIndicator, displayExternalSuccessors, displayExternalPredecessors, crossProjectLinksInfo, acceptNewExternalData, displayWindowsInTaskbar, displayScreentips, calendarType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="calendarName">optional object calendarName</param>
		/// <param name="locked">optional object locked</param>
		/// <param name="selectedDate">optional object selectedDate</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTimeEx(object calendarName, object locked, object selectedDate, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTimeEx", calendarName, locked, selectedDate, projectName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTimeEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTimeEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="calendarName">optional object calendarName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTimeEx(object calendarName)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTimeEx", calendarName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="calendarName">optional object calendarName</param>
		/// <param name="locked">optional object locked</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTimeEx(object calendarName, object locked)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTimeEx", calendarName, locked);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="calendarName">optional object calendarName</param>
		/// <param name="locked">optional object locked</param>
		/// <param name="selectedDate">optional object selectedDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool ChangeWorkingTimeEx(object calendarName, object locked, object selectedDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeWorkingTimeEx", calendarName, locked, selectedDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", new object[]{ item, font, size, bold, italic, underline, color, cellColor, pattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", item, font);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", item, font, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", item, font, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", new object[]{ item, font, size, bold, italic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", new object[]{ item, font, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", new object[]{ item, font, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool TextStylesEx(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStylesEx", new object[]{ item, font, size, bold, italic, underline, color, cellColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size, object bold, object italic, object underline, object color, object reset, object cellColor, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", new object[]{ name, size, bold, italic, underline, color, reset, cellColor, pattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", name, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", name, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", name, size, bold, italic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", new object[]{ name, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", new object[]{ name, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size, object bold, object italic, object underline, object color, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", new object[]{ name, size, bold, italic, underline, color, reset });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		/// <param name="cellColor">optional object cellColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool FontEx(object name, object size, object bold, object italic, object underline, object color, object reset, object cellColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontEx", new object[]{ name, size, bold, italic, underline, color, reset, cellColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		/// <param name="dayTitle">optional object dayTitle</param>
		/// <param name="showPreview">optional object showPreview</param>
		/// <param name="daysPerWeek">optional object daysPerWeek</param>
		/// <param name="showTitleBeginningEndDates">optional object showTitleBeginningEndDates</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadingsEx(object monthTitle, object weekTitle, object dayTitle, object showPreview, object daysPerWeek, object showTitleBeginningEndDates)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadingsEx", new object[]{ monthTitle, weekTitle, dayTitle, showPreview, daysPerWeek, showTitleBeginningEndDates });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadingsEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadingsEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadingsEx(object monthTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadingsEx", monthTitle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadingsEx(object monthTitle, object weekTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadingsEx", monthTitle, weekTitle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		/// <param name="dayTitle">optional object dayTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadingsEx(object monthTitle, object weekTitle, object dayTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadingsEx", monthTitle, weekTitle, dayTitle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		/// <param name="dayTitle">optional object dayTitle</param>
		/// <param name="showPreview">optional object showPreview</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadingsEx(object monthTitle, object weekTitle, object dayTitle, object showPreview)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadingsEx", monthTitle, weekTitle, dayTitle, showPreview);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="monthTitle">optional object monthTitle</param>
		/// <param name="weekTitle">optional object weekTitle</param>
		/// <param name="dayTitle">optional object dayTitle</param>
		/// <param name="showPreview">optional object showPreview</param>
		/// <param name="daysPerWeek">optional object daysPerWeek</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CalendarWeekHeadingsEx(object monthTitle, object weekTitle, object dayTitle, object showPreview, object daysPerWeek)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarWeekHeadingsEx", new object[]{ monthTitle, weekTitle, dayTitle, showPreview, daysPerWeek });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		/// <param name="matchGeneric">optional object matchGeneric</param>
		/// <param name="requiredCode">optional object requiredCode</param>
		/// <param name="lookupDefault">optional object lookupDefault</param>
		/// <param name="defaultValue">optional object defaultValue</param>
		/// <param name="sortOrder">optional object sortOrder</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves, object matchGeneric, object requiredCode, object lookupDefault, object defaultValue, object sortOrder)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves, matchGeneric, requiredCode, lookupDefault, defaultValue, sortOrder });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", fieldID, level);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", fieldID, level, sequence);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", fieldID, level, sequence, length);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		/// <param name="matchGeneric">optional object matchGeneric</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves, object matchGeneric)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves, matchGeneric });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		/// <param name="matchGeneric">optional object matchGeneric</param>
		/// <param name="requiredCode">optional object requiredCode</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves, object matchGeneric, object requiredCode)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves, matchGeneric, requiredCode });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		/// <param name="matchGeneric">optional object matchGeneric</param>
		/// <param name="requiredCode">optional object requiredCode</param>
		/// <param name="lookupDefault">optional object lookupDefault</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves, object matchGeneric, object requiredCode, object lookupDefault)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves, matchGeneric, requiredCode, lookupDefault });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">object level</param>
		/// <param name="sequence">optional NetOffice.MSProjectApi.Enums.PjCustomOutlineCodeSequence Sequence = -1</param>
		/// <param name="length">optional object length</param>
		/// <param name="separator">optional object separator</param>
		/// <param name="onlyLookUpTableCodes">optional object onlyLookUpTableCodes</param>
		/// <param name="onlyCompleteCodes">optional object onlyCompleteCodes</param>
		/// <param name="lookupTableLink">optional object lookupTableLink</param>
		/// <param name="onlyLeaves">optional object onlyLeaves</param>
		/// <param name="matchGeneric">optional object matchGeneric</param>
		/// <param name="requiredCode">optional object requiredCode</param>
		/// <param name="lookupDefault">optional object lookupDefault</param>
		/// <param name="defaultValue">optional object defaultValue</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomOutlineCodeEditEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object sequence, object length, object separator, object onlyLookUpTableCodes, object onlyCompleteCodes, object lookupTableLink, object onlyLeaves, object matchGeneric, object requiredCode, object lookupDefault, object defaultValue)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomOutlineCodeEditEx", new object[]{ fieldID, level, sequence, length, separator, onlyLookUpTableCodes, onlyCompleteCodes, lookupTableLink, onlyLeaves, matchGeneric, requiredCode, lookupDefault, defaultValue });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">optional object level</param>
		/// <param name="code">optional object code</param>
		/// <param name="description">optional object description</param>
		/// <param name="phonetic">optional object phonetic</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAddEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object code, object description, object phonetic)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAddEx", new object[]{ fieldID, level, code, description, phonetic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAddEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAddEx", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">optional object level</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAddEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAddEx", fieldID, level);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">optional object level</param>
		/// <param name="code">optional object code</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAddEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object code)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAddEx", fieldID, level, code);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="level">optional object level</param>
		/// <param name="code">optional object code</param>
		/// <param name="description">optional object description</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LookUpTableAddEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object level, object code, object description)
		{
			return Factory.ExecuteBoolMethodGet(this, "LookUpTableAddEx", fieldID, level, code, description);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		/// <param name="summaryCalc">optional NetOffice.MSProjectApi.Enums.PjSummaryCalc SummaryCalc = -1</param>
		/// <param name="graphicalIndicators">optional object graphicalIndicators</param>
		/// <param name="required">optional object required</param>
		/// <param name="automaticallyRolldownToAssn">optional object automaticallyRolldownToAssn</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldPropertiesEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute, object summaryCalc, object graphicalIndicators, object required, object automaticallyRolldownToAssn)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldPropertiesEx", new object[]{ fieldID, attribute, summaryCalc, graphicalIndicators, required, automaticallyRolldownToAssn });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldPropertiesEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldPropertiesEx", fieldID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldPropertiesEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldPropertiesEx", fieldID, attribute);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		/// <param name="summaryCalc">optional NetOffice.MSProjectApi.Enums.PjSummaryCalc SummaryCalc = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldPropertiesEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute, object summaryCalc)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldPropertiesEx", fieldID, attribute, summaryCalc);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		/// <param name="summaryCalc">optional NetOffice.MSProjectApi.Enums.PjSummaryCalc SummaryCalc = -1</param>
		/// <param name="graphicalIndicators">optional object graphicalIndicators</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldPropertiesEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute, object summaryCalc, object graphicalIndicators)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldPropertiesEx", fieldID, attribute, summaryCalc, graphicalIndicators);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjCustomField fieldID</param>
		/// <param name="attribute">optional NetOffice.MSProjectApi.Enums.PjCustomFieldAttribute Attribute = -1</param>
		/// <param name="summaryCalc">optional NetOffice.MSProjectApi.Enums.PjSummaryCalc SummaryCalc = -1</param>
		/// <param name="graphicalIndicators">optional object graphicalIndicators</param>
		/// <param name="required">optional object required</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool CustomFieldPropertiesEx(NetOffice.MSProjectApi.Enums.PjCustomField fieldID, object attribute, object summaryCalc, object graphicalIndicators, object required)
		{
			return Factory.ExecuteBoolMethodGet(this, "CustomFieldPropertiesEx", new object[]{ fieldID, attribute, summaryCalc, graphicalIndicators, required });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		/// <param name="projectGuideUseDefaultContent">optional object projectGuideUseDefaultContent</param>
		/// <param name="projectGuideContent">optional object projectGuideContent</param>
		/// <param name="setAsDefaults">optional object setAsDefaults</param>
		/// <param name="useOMIDs">optional object useOMIDs</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage, object projectGuideUseDefaultContent, object projectGuideContent, object setAsDefaults, object useOMIDs)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage, projectGuideUseDefaultContent, projectGuideContent, setAsDefaults, useOMIDs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", showResourceAssignmentIndicators);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", showResourceAssignmentIndicators, showEditToStartFinishDates);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		/// <param name="projectGuideUseDefaultContent">optional object projectGuideUseDefaultContent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage, object projectGuideUseDefaultContent)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage, projectGuideUseDefaultContent });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		/// <param name="projectGuideUseDefaultContent">optional object projectGuideUseDefaultContent</param>
		/// <param name="projectGuideContent">optional object projectGuideContent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage, object projectGuideUseDefaultContent, object projectGuideContent)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage, projectGuideUseDefaultContent, projectGuideContent });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="showResourceAssignmentIndicators">optional object showResourceAssignmentIndicators</param>
		/// <param name="showEditToStartFinishDates">optional object showEditToStartFinishDates</param>
		/// <param name="showEditsToWorkUnitsDurationIndicators">optional object showEditsToWorkUnitsDurationIndicators</param>
		/// <param name="showDeletionInNameColumn">optional object showDeletionInNameColumn</param>
		/// <param name="displayProjectGuide">optional object displayProjectGuide</param>
		/// <param name="projectGuideUseDefaultFunctionalLayoutPage">optional object projectGuideUseDefaultFunctionalLayoutPage</param>
		/// <param name="projectGuideFunctionalLayoutPage">optional object projectGuideFunctionalLayoutPage</param>
		/// <param name="projectGuideUseDefaultContent">optional object projectGuideUseDefaultContent</param>
		/// <param name="projectGuideContent">optional object projectGuideContent</param>
		/// <param name="setAsDefaults">optional object setAsDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsInterfaceEx(object showResourceAssignmentIndicators, object showEditToStartFinishDates, object showEditsToWorkUnitsDurationIndicators, object showDeletionInNameColumn, object displayProjectGuide, object projectGuideUseDefaultFunctionalLayoutPage, object projectGuideFunctionalLayoutPage, object projectGuideUseDefaultContent, object projectGuideContent, object setAsDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsInterfaceEx", new object[]{ showResourceAssignmentIndicators, showEditToStartFinishDates, showEditsToWorkUnitsDurationIndicators, showDeletionInNameColumn, displayProjectGuide, projectGuideUseDefaultFunctionalLayoutPage, projectGuideFunctionalLayoutPage, projectGuideUseDefaultContent, projectGuideContent, setAsDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="localRUIDs">optional object localRUIDs</param>
		/// <param name="useImportColumn">optional object useImportColumn</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourcesImportEx(object localRUIDs, object useImportColumn)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourcesImportEx", localRUIDs, useImportColumn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourcesImportEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourcesImportEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="localRUIDs">optional object localRUIDs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool EnterpriseResourcesImportEx(object localRUIDs)
		{
			return Factory.ExecuteBoolMethodGet(this, "EnterpriseResourcesImportEx", localRUIDs);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="targetPage">string targetPage</param>
		/// <param name="wrapperPage">optional object wrapperPage</param>
		/// <param name="functionalityName">optional object functionalityName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadWebBrowserControlEx(string targetPage, object wrapperPage, object functionalityName)
		{
			return Factory.ExecuteBoolMethodGet(this, "LoadWebBrowserControlEx", targetPage, wrapperPage, functionalityName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="targetPage">string targetPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadWebBrowserControlEx(string targetPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "LoadWebBrowserControlEx", targetPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="targetPage">string targetPage</param>
		/// <param name="wrapperPage">optional object wrapperPage</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool LoadWebBrowserControlEx(string targetPage, object wrapperPage)
		{
			return Factory.ExecuteBoolMethodGet(this, "LoadWebBrowserControlEx", targetPage, wrapperPage);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="removeFileProperties">optional object removeFileProperties</param>
		/// <param name="trustWSS">optional object trustWSS</param>
		/// <param name="legacyFileFormats">optional object legacyFileFormats</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSecurityEx(object removeFileProperties, object trustWSS, object legacyFileFormats)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurityEx", removeFileProperties, trustWSS, legacyFileFormats);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSecurityEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurityEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="removeFileProperties">optional object removeFileProperties</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSecurityEx(object removeFileProperties)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurityEx", removeFileProperties);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="removeFileProperties">optional object removeFileProperties</param>
		/// <param name="trustWSS">optional object trustWSS</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool OptionsSecurityEx(object removeFileProperties, object trustWSS)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurityEx", removeFileProperties, trustWSS);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool IsUndoingOrRedoing()
		{
			return Factory.ExecuteBoolMethodGet(this, "IsUndoingOrRedoing");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="propertyID">Int32 propertyID</param>
		/// <param name="strFormula">string strFormula</param>
		/// <param name="localized">optional bool Localized = false</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public string ValidateEnterpriseFormula(Int32 propertyID, string strFormula, object localized)
		{
			return Factory.ExecuteStringMethodGet(this, "ValidateEnterpriseFormula", propertyID, strFormula, localized);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="propertyID">Int32 propertyID</param>
		/// <param name="strFormula">string strFormula</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public string ValidateEnterpriseFormula(Int32 propertyID, string strFormula)
		{
			return Factory.ExecuteStringMethodGet(this, "ValidateEnterpriseFormula", propertyID, strFormula);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public void UndoClear()
		{
			 Factory.ExecuteMethod(this, "UndoClear");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="howManyUndos">optional Int32 HowManyUndos = 1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Undo(object howManyUndos)
		{
			return Factory.ExecuteBoolMethodGet(this, "Undo", howManyUndos);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Undo()
		{
			return Factory.ExecuteBoolMethodGet(this, "Undo");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="howManyRedos">optional Int32 HowManyRedos = 1</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Redo(object howManyRedos)
		{
			return Factory.ExecuteBoolMethodGet(this, "Redo", howManyRedos);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public bool Redo()
		{
			return Factory.ExecuteBoolMethodGet(this, "Redo");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="label">string label</param>
		/// <param name="guid">optional object guid</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public void OpenUndoTransaction(string label, object guid)
		{
			 Factory.ExecuteMethod(this, "OpenUndoTransaction", label, guid);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="label">string label</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public void OpenUndoTransaction(string label)
		{
			 Factory.ExecuteMethod(this, "OpenUndoTransaction", label);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public void CloseUndoTransaction()
		{
			 Factory.ExecuteMethod(this, "CloseUndoTransaction");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="propertyID">Int32 propertyID</param>
		/// <param name="strGraphicalIndicators">string strGraphicalIndicators</param>
		/// <param name="localized">optional bool Localized = false</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,12,14)]
		public string ValidateGraphicalIndicators(Int32 propertyID, string strGraphicalIndicators, object localized)
		{
			return Factory.ExecuteStringMethodGet(this, "ValidateGraphicalIndicators", propertyID, strGraphicalIndicators, localized);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="propertyID">Int32 propertyID</param>
		/// <param name="strGraphicalIndicators">string strGraphicalIndicators</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,12,14)]
		public string ValidateGraphicalIndicators(Int32 propertyID, string strGraphicalIndicators)
		{
			return Factory.ExecuteStringMethodGet(this, "ValidateGraphicalIndicators", propertyID, strGraphicalIndicators);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 GetUndoListCount()
		{
			return Factory.ExecuteInt32MethodGet(this, "GetUndoListCount");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 GetRedoListCount()
		{
			return Factory.ExecuteInt32MethodGet(this, "GetRedoListCount");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="itemIndex">Int32 itemIndex</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string GetUndoListItem(Int32 itemIndex)
		{
			return Factory.ExecuteStringMethodGet(this, "GetUndoListItem", itemIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="itemIndex">Int32 itemIndex</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string GetRedoListItem(Int32 itemIndex)
		{
			return Factory.ExecuteStringMethodGet(this, "GetRedoListItem", itemIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="x">Int32 x</param>
		/// <param name="y">Int32 y</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public NetOffice.MSProjectApi.Cell GetCellInfo(Int32 x, Int32 y)
		{
			return Factory.ExecuteKnownReferenceMethodGet<NetOffice.MSProjectApi.Cell>(this, "GetCellInfo", NetOffice.MSProjectApi.Cell.LateBindingApiWrapperType, x, y);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public string GetProjectServerSettingsEx()
		{
			return Factory.ExecuteStringMethodGet(this, "GetProjectServerSettingsEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public void AfterUnloadWebBrowserControl()
		{
			 Factory.ExecuteMethod(this, "AfterUnloadWebBrowserControl");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool IsOffline()
		{
			return Factory.ExecuteBoolMethodGet(this, "IsOffline");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,12,14)]
		public bool IsReducedFunctionalityMode()
		{
			return Factory.ExecuteBoolMethodGet(this, "IsReducedFunctionalityMode");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="elementType">NetOffice.MSProjectApi.Enums.PjThemeElement elementType</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public string GetThemedColor(NetOffice.MSProjectApi.Enums.PjThemeElement elementType)
		{
			return Factory.ExecuteStringMethodGet(this, "GetThemedColor", elementType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 12, 14
		/// </summary>
		/// <param name="commandName">string commandName</param>
		[SupportByVersion("MSProject", 11,12,14)]
		public Int32 IsCommandEnabled(string commandName)
		{
			return Factory.ExecuteInt32MethodGet(this, "IsCommandEnabled", commandName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="strURL">string strURL</param>
		/// <param name="strListGuid">string strListGuid</param>
		/// <param name="strListName">string strListName</param>
		/// <param name="bstrViewGUID">string bstrViewGUID</param>
		/// <param name="bstrViewName">string bstrViewName</param>
		/// <param name="iListID">Int32 iListID</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,14)]
		public string LoadTasksFromServer(string strURL, string strListGuid, string strListName, string bstrViewGUID, string bstrViewName, Int32 iListID)
		{
			return Factory.ExecuteStringMethodGet(this, "LoadTasksFromServer", new object[]{ strURL, strListGuid, strListName, bstrViewGUID, bstrViewName, iListID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="start">object start</param>
		/// <param name="finish">object finish</param>
		[SupportByVersion("MSProject", 11,14)]
		public void PanZoomZoomTo(object start, object finish)
		{
			 Factory.ExecuteMethod(this, "PanZoomZoomTo", start, finish);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="start">object start</param>
		[SupportByVersion("MSProject", 11,14)]
		public void PanZoomPanTo(object start)
		{
			 Factory.ExecuteMethod(this, "PanZoomPanTo", start);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="applyTo">optional object applyTo</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewCopy(object name, object applyTo)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewCopy", name, applyTo);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewCopy()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewCopy");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewCopy(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewCopy", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewReset()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewReset");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TableCopy(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableCopy", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableCopy()
		{
			return Factory.ExecuteBoolMethodGet(this, "TableCopy");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TableReset()
		{
			return Factory.ExecuteBoolMethodGet(this, "TableReset");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="onOff">optional object onOff</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool AutoSaveToGlobal(object onOff)
		{
			return Factory.ExecuteBoolMethodGet(this, "AutoSaveToGlobal", onOff);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool AutoSaveToGlobal()
		{
			return Factory.ExecuteBoolMethodGet(this, "AutoSaveToGlobal");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="applyTo">optional object applyTo</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewsEx(object applyTo)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewsEx", applyTo);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewsEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewsEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="singlePane">object singlePane</param>
		/// <param name="toggle">object toggle</param>
		/// <param name="applyTo">object applyTo</param>
		/// <param name="builtInView">optional NetOffice.MSProjectApi.Enums.PjViewType BuiltInView = -1</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewApplyEx(object name, object singlePane, object toggle, object applyTo, object builtInView)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewApplyEx", new object[]{ name, singlePane, toggle, applyTo, builtInView });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="singlePane">object singlePane</param>
		/// <param name="toggle">object toggle</param>
		/// <param name="applyTo">object applyTo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ViewApplyEx(object name, object singlePane, object toggle, object applyTo)
		{
			return Factory.ExecuteBoolMethodGet(this, "ViewApplyEx", name, singlePane, toggle, applyTo);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool WrapText(object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "WrapText", column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool WrapText()
		{
			return Factory.ExecuteBoolMethodGet(this, "WrapText");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ShowAddNewColumn(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "ShowAddNewColumn", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ShowAddNewColumn()
		{
			return Factory.ExecuteBoolMethodGet(this, "ShowAddNewColumn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjFieldTypes Type = 0</param>
		/// <param name="column">optional object column</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ChangeColumnDataType(object type, object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeColumnDataType", type, column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ChangeColumnDataType()
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeColumnDataType");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjFieldTypes Type = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ChangeColumnDataType(object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeColumnDataType", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="column">optional object column</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool AddNewColumn(object column)
		{
			return Factory.ExecuteBoolMethodGet(this, "AddNewColumn", column);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool AddNewColumn()
		{
			return Factory.ExecuteBoolMethodGet(this, "AddNewColumn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		/// <param name="headerAutoRowHeightAdjustment">optional object headerAutoRowHeightAdjustment</param>
		/// <param name="headerTextWrap">optional object headerTextWrap</param>
		/// <param name="wrapText">optional object wrapText</param>
		/// <param name="showAddNewColumn">optional object showAddNewColumn</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle, object headerAutoRowHeightAdjustment, object headerTextWrap, object wrapText, object showAddNewColumn)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle, headerAutoRowHeightAdjustment, headerTextWrap, wrapText, showAddNewColumn });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", name, taskTable);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", name, taskTable, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", name, taskTable, create, overwriteExisting);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		/// <param name="headerAutoRowHeightAdjustment">optional object headerAutoRowHeightAdjustment</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle, object headerAutoRowHeightAdjustment)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle, headerAutoRowHeightAdjustment });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		/// <param name="headerAutoRowHeightAdjustment">optional object headerAutoRowHeightAdjustment</param>
		/// <param name="headerTextWrap">optional object headerTextWrap</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle, object headerAutoRowHeightAdjustment, object headerTextWrap)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle, headerAutoRowHeightAdjustment, headerTextWrap });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="taskTable">bool taskTable</param>
		/// <param name="create">optional object create</param>
		/// <param name="overwriteExisting">optional object overwriteExisting</param>
		/// <param name="newName">optional object newName</param>
		/// <param name="fieldName">optional object fieldName</param>
		/// <param name="newFieldName">optional object newFieldName</param>
		/// <param name="title">optional object title</param>
		/// <param name="width">optional object width</param>
		/// <param name="align">optional object align</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="lockFirstColumn">optional object lockFirstColumn</param>
		/// <param name="dateFormat">optional object dateFormat</param>
		/// <param name="rowHeight">optional object rowHeight</param>
		/// <param name="columnPosition">optional object columnPosition</param>
		/// <param name="alignTitle">optional object alignTitle</param>
		/// <param name="headerAutoRowHeightAdjustment">optional object headerAutoRowHeightAdjustment</param>
		/// <param name="headerTextWrap">optional object headerTextWrap</param>
		/// <param name="wrapText">optional object wrapText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TableEditEx(string name, bool taskTable, object create, object overwriteExisting, object newName, object fieldName, object newFieldName, object title, object width, object align, object showInMenu, object lockFirstColumn, object dateFormat, object rowHeight, object columnPosition, object alignTitle, object headerAutoRowHeightAdjustment, object headerTextWrap, object wrapText)
		{
			return Factory.ExecuteBoolMethodGet(this, "TableEditEx", new object[]{ name, taskTable, create, overwriteExisting, newName, fieldName, newFieldName, title, width, align, showInMenu, lockFirstColumn, dateFormat, rowHeight, columnPosition, alignTitle, headerAutoRowHeightAdjustment, headerTextWrap, wrapText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		/// <param name="listName">optional object listName</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SynchronizeWithSite(object siteURL, object listName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSite", siteURL, listName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SynchronizeWithSite()
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSite");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SynchronizeWithSite(object siteURL)
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSite", siteURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ManageSiteColumns()
		{
			return Factory.ExecuteBoolMethodGet(this, "ManageSiteColumns");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		/// <param name="listName">optional object listName</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool OpenFromSharePoint(object siteURL, object listName)
		{
			return Factory.ExecuteBoolMethodGet(this, "OpenFromSharePoint", siteURL, listName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OpenFromSharePoint()
		{
			return Factory.ExecuteBoolMethodGet(this, "OpenFromSharePoint");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OpenFromSharePoint(object siteURL)
		{
			return Factory.ExecuteBoolMethodGet(this, "OpenFromSharePoint", siteURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="insideText">optional object insideText</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText, object leftText, object rightText, object insideText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText, leftText, rightText, insideText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", item, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", item, create, name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", item, create, name, startShape);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="leftText">optional object leftText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText, object leftText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText, leftText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">string item</param>
		/// <param name="create">optional object create</param>
		/// <param name="name">optional object name</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="showFor">optional object showFor</param>
		/// <param name="row">optional object row</param>
		/// <param name="from">optional object from</param>
		/// <param name="to">optional object to</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarEditEx(string item, object create, object name, object startShape, object startType, object startColor, object middleShape, object middleColor, object middlePattern, object endShape, object endType, object endColor, object showFor, object row, object from, object to, object bottomText, object topText, object leftText, object rightText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarEditEx", new object[]{ item, create, name, startShape, startType, startColor, middleShape, middleColor, middlePattern, endShape, endType, endColor, showFor, row, from, to, bottomText, topText, leftText, rightText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		/// <param name="field5">optional object field5</param>
		/// <param name="splitPattern">optional object splitPattern</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3, object field4, object field5, object splitPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3, field4, field5, splitPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", item, bar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", item, bar, pattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", item, bar, pattern, color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap, shadow });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3, object field4)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3, field4 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjBarItem item</param>
		/// <param name="bar">optional object bar</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		/// <param name="align">optional object align</param>
		/// <param name="wrap">optional object wrap</param>
		/// <param name="shadow">optional object shadow</param>
		/// <param name="field1">optional object field1</param>
		/// <param name="field2">optional object field2</param>
		/// <param name="field3">optional object field3</param>
		/// <param name="field4">optional object field4</param>
		/// <param name="field5">optional object field5</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarBarStylesEditEx(NetOffice.MSProjectApi.Enums.PjBarItem item, object bar, object pattern, object color, object align, object wrap, object shadow, object field1, object field2, object field3, object field4, object field5)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarBarStylesEditEx", new object[]{ item, bar, pattern, color, align, wrap, shadow, field1, field2, field3, field4, field5 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjCalendarShading item</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="color">optional object color</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateShadingEditEx(NetOffice.MSProjectApi.Enums.PjCalendarShading item, object pattern, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShadingEditEx", item, pattern, color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjCalendarShading item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateShadingEditEx(NetOffice.MSProjectApi.Enums.PjCalendarShading item)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShadingEditEx", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjCalendarShading item</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateShadingEditEx(NetOffice.MSProjectApi.Enums.PjCalendarShading item, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateShadingEditEx", item, pattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		/// <param name="bottomColor">optional object bottomColor</param>
		/// <param name="topPattern">optional object topPattern</param>
		/// <param name="bottomPattern">optional object bottomPattern</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor, object bottomColor, object topPattern, object bottomPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor, bottomColor, topPattern, bottomPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", topLeft);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft, object topRight)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", topLeft, topRight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft, object topRight, object bottomLeft)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", topLeft, topRight, bottomLeft);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft, object topRight, object bottomLeft, object bottomRight)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", topLeft, topRight, bottomLeft, bottomRight);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		/// <param name="bottomColor">optional object bottomColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor, object bottomColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor, bottomColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeft">optional object topLeft</param>
		/// <param name="topRight">optional object topRight</param>
		/// <param name="bottomLeft">optional object bottomLeft</param>
		/// <param name="bottomRight">optional object bottomRight</param>
		/// <param name="topColor">optional object topColor</param>
		/// <param name="bottomColor">optional object bottomColor</param>
		/// <param name="topPattern">optional object topPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CalendarDateBoxesEx(object topLeft, object topRight, object bottomLeft, object bottomRight, object topColor, object bottomColor, object topPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "CalendarDateBoxesEx", new object[]{ topLeft, topRight, bottomLeft, bottomRight, topColor, bottomColor, topPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="strikethrough">optional object strikethrough</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold, object italic, object underline, object color, object reset, object cellColor, object pattern, object strikethrough)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", new object[]{ name, size, bold, italic, underline, color, reset, cellColor, pattern, strikethrough });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex()
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", name, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", name, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", name, size, bold, italic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", new object[]{ name, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", new object[]{ name, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold, object italic, object underline, object color, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", new object[]{ name, size, bold, italic, underline, color, reset });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		/// <param name="cellColor">optional object cellColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold, object italic, object underline, object color, object reset, object cellColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", new object[]{ name, size, bold, italic, underline, color, reset, cellColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="reset">optional object reset</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool Font32Ex(object name, object size, object bold, object italic, object underline, object color, object reset, object cellColor, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "Font32Ex", new object[]{ name, size, bold, italic, underline, color, reset, cellColor, pattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", new object[]{ item, font, size, bold, italic, underline, color, cellColor, pattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex()
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", item, font);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", item, font, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", item, font, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", new object[]{ item, font, size, bold, italic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", new object[]{ item, font, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", new object[]{ item, font, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TextStyles32Ex(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "TextStyles32Ex", new object[]{ item, font, size, bold, italic, underline, color, cellColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		/// <param name="calendar">optional object calendar</param>
		/// <param name="color">optional object color</param>
		/// <param name="pattern">optional object pattern</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimescaleNonWorkingEx(object draw, object calendar, object color, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorkingEx", draw, calendar, color, pattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimescaleNonWorkingEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorkingEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimescaleNonWorkingEx(object draw)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorkingEx", draw);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		/// <param name="calendar">optional object calendar</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimescaleNonWorkingEx(object draw, object calendar)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorkingEx", draw, calendar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="draw">optional object draw</param>
		/// <param name="calendar">optional object calendar</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimescaleNonWorkingEx(object draw, object calendar, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimescaleNonWorkingEx", draw, calendar, color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		/// <param name="interval">optional object interval</param>
		/// <param name="intervalType">optional object intervalType</param>
		/// <param name="intervalColor">optional object intervalColor</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GridlinesEditEx(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor, object interval, object intervalType, object intervalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEditEx", new object[]{ item, normalType, normalColor, interval, intervalType, intervalColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GridlinesEditEx(NetOffice.MSProjectApi.Enums.PjGridline item)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEditEx", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GridlinesEditEx(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEditEx", item, normalType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GridlinesEditEx(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEditEx", item, normalType, normalColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		/// <param name="interval">optional object interval</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GridlinesEditEx(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor, object interval)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEditEx", item, normalType, normalColor, interval);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjGridline item</param>
		/// <param name="normalType">optional object normalType</param>
		/// <param name="normalColor">optional object normalColor</param>
		/// <param name="interval">optional object interval</param>
		/// <param name="intervalType">optional object intervalType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GridlinesEditEx(NetOffice.MSProjectApi.Enums.PjGridline item, object normalType, object normalColor, object interval, object intervalType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GridlinesEditEx", new object[]{ item, normalType, normalColor, interval, intervalType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		/// <param name="proposedRightShowAs">optional object proposedRightShowAs</param>
		/// <param name="proposedRightColor">optional object proposedRightColor</param>
		/// <param name="proposedRightPattern">optional object proposedRightPattern</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern, object proposedRightShowAs, object proposedRightColor, object proposedRightPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern, proposedRightShowAs, proposedRightColor, proposedRightPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", topLeftShowAs);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", topLeftShowAs, topLeftColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", topLeftShowAs, topLeftColor, topLeftPattern);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		/// <param name="proposedRightShowAs">optional object proposedRightShowAs</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern, object proposedRightShowAs)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern, proposedRightShowAs });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="topLeftShowAs">optional object topLeftShowAs</param>
		/// <param name="topLeftColor">optional object topLeftColor</param>
		/// <param name="topLeftPattern">optional object topLeftPattern</param>
		/// <param name="bottomLeftShowAs">optional object bottomLeftShowAs</param>
		/// <param name="bottomLeftColor">optional object bottomLeftColor</param>
		/// <param name="bottomLeftPattern">optional object bottomLeftPattern</param>
		/// <param name="topRightShowAs">optional object topRightShowAs</param>
		/// <param name="topRightColor">optional object topRightColor</param>
		/// <param name="topRightPattern">optional object topRightPattern</param>
		/// <param name="bottomRightShowAs">optional object bottomRightShowAs</param>
		/// <param name="bottomRightColor">optional object bottomRightColor</param>
		/// <param name="bottomRightPattern">optional object bottomRightPattern</param>
		/// <param name="showValues">optional object showValues</param>
		/// <param name="showAvailabilityLine">optional object showAvailabilityLine</param>
		/// <param name="percentBarOverlap">optional object percentBarOverlap</param>
		/// <param name="proposedLeftShowAs">optional object proposedLeftShowAs</param>
		/// <param name="proposedLeftColor">optional object proposedLeftColor</param>
		/// <param name="proposedLeftPattern">optional object proposedLeftPattern</param>
		/// <param name="proposedRightShowAs">optional object proposedRightShowAs</param>
		/// <param name="proposedRightColor">optional object proposedRightColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceGraphBarStylesEx(object topLeftShowAs, object topLeftColor, object topLeftPattern, object bottomLeftShowAs, object bottomLeftColor, object bottomLeftPattern, object topRightShowAs, object topRightColor, object topRightPattern, object bottomRightShowAs, object bottomRightColor, object bottomRightPattern, object showValues, object showAvailabilityLine, object percentBarOverlap, object proposedLeftShowAs, object proposedLeftColor, object proposedLeftPattern, object proposedRightShowAs, object proposedRightColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceGraphBarStylesEx", new object[]{ topLeftShowAs, topLeftColor, topLeftPattern, bottomLeftShowAs, bottomLeftColor, bottomLeftPattern, topRightShowAs, topRightColor, topRightPattern, bottomRightShowAs, bottomRightColor, bottomRightPattern, showValues, showAvailabilityLine, percentBarOverlap, proposedLeftShowAs, proposedLeftColor, proposedLeftPattern, proposedRightShowAs, proposedRightColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">object borderColor</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">object backgroundColor</param>
		/// <param name="backgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern BackgroundPattern = -1</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxStylesEditEx(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor, object backgroundPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEditEx", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor, backgroundPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">object borderColor</param>
		/// <param name="borderWidth">object borderWidth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxStylesEditEx(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEditEx", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjBoxStyle style</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">object borderColor</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">object backgroundColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxStylesEditEx(NetOffice.MSProjectApi.Enums.PjBoxStyle style, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxStylesEditEx", new object[]{ style, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">object borderColor</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">object backgroundColor</param>
		/// <param name="backgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern BackgroundPattern = -1</param>
		/// <param name="reset">optional object reset</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxFormatEx(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor, object backgroundPattern, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormatEx", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor, backgroundPattern, reset });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">object borderColor</param>
		/// <param name="borderWidth">object borderWidth</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxFormatEx(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormatEx", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">object borderColor</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">object backgroundColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxFormatEx(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormatEx", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="projectName">object projectName</param>
		/// <param name="taskID">object taskID</param>
		/// <param name="dataTemplate">object dataTemplate</param>
		/// <param name="horizontalGridlines">object horizontalGridlines</param>
		/// <param name="verticalGridlines">object verticalGridlines</param>
		/// <param name="borderShape">optional NetOffice.MSProjectApi.Enums.PjBoxShape BorderShape = -1</param>
		/// <param name="borderColor">object borderColor</param>
		/// <param name="borderWidth">object borderWidth</param>
		/// <param name="backgroundColor">object backgroundColor</param>
		/// <param name="backgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern BackgroundPattern = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxFormatEx(object projectName, object taskID, object dataTemplate, object horizontalGridlines, object verticalGridlines, object borderShape, object borderColor, object borderWidth, object backgroundColor, object backgroundPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxFormatEx", new object[]{ projectName, taskID, dataTemplate, horizontalGridlines, verticalGridlines, borderShape, borderColor, borderWidth, backgroundColor, backgroundPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">object fontColor</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		/// <param name="showLabel">object showLabel</param>
		/// <param name="label">object label</param>
		/// <param name="dateFormat">optional NetOffice.MSProjectApi.Enums.PjDateFormat DateFormat = -1</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxCellEditEx(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit, object showLabel, object label, object dateFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEditEx", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit, showLabel, label, dateFormat });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">object fontColor</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxCellEditEx(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEditEx", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">object fontColor</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxCellEditEx(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEditEx", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">object fontColor</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		/// <param name="showLabel">object showLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxCellEditEx(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit, object showLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEditEx", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit, showLabel });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">string name</param>
		/// <param name="cell">NetOffice.MSProjectApi.Enums.PjCell cell</param>
		/// <param name="fieldName">optional NetOffice.MSProjectApi.Enums.PjField FieldName = -1</param>
		/// <param name="font">object font</param>
		/// <param name="fontSize">object fontSize</param>
		/// <param name="fontColor">object fontColor</param>
		/// <param name="bold">object bold</param>
		/// <param name="italic">object italic</param>
		/// <param name="underline">object underline</param>
		/// <param name="horizontalAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment HorizontalAlignment = -1</param>
		/// <param name="verticalAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment VerticalAlignment = -1</param>
		/// <param name="textLineLimit">object textLineLimit</param>
		/// <param name="showLabel">object showLabel</param>
		/// <param name="label">object label</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxCellEditEx(string name, NetOffice.MSProjectApi.Enums.PjCell cell, object fieldName, object font, object fontSize, object fontColor, object bold, object italic, object underline, object horizontalAlignment, object verticalAlignment, object textLineLimit, object showLabel, object label)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxCellEditEx", new object[]{ name, cell, fieldName, font, fontSize, fontColor, bold, italic, underline, horizontalAlignment, verticalAlignment, textLineLimit, showLabel, label });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">object viewBackgroundColor</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		/// <param name="showProgressMarks">optional object showProgressMarks</param>
		/// <param name="showPageBreaks">optional object showPageBreaks</param>
		/// <param name="showIDOnly">optional object showIDOnly</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern, object showProgressMarks, object showPageBreaks, object showIDOnly)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern, showProgressMarks, showPageBreaks, showIDOnly });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">object viewBackgroundColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">object viewBackgroundColor</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">object viewBackgroundColor</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		/// <param name="showProgressMarks">optional object showProgressMarks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern, object showProgressMarks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern, showProgressMarks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="layoutMode">optional NetOffice.MSProjectApi.Enums.PjLayoutMode LayoutMode = -1</param>
		/// <param name="layoutScheme">optional NetOffice.MSProjectApi.Enums.PjLayoutScheme LayoutScheme = -1</param>
		/// <param name="summaryPrecedence">object summaryPrecedence</param>
		/// <param name="rowAlignment">optional NetOffice.MSProjectApi.Enums.PjVerticalAlignment RowAlignment = -1</param>
		/// <param name="columnAlignment">optional NetOffice.MSProjectApi.Enums.PjAlignment ColumnAlignment = -1</param>
		/// <param name="rowSpacing">object rowSpacing</param>
		/// <param name="columnSpacing">object columnSpacing</param>
		/// <param name="rowHeight">optional NetOffice.MSProjectApi.Enums.PjRowColSize RowHeight = -1</param>
		/// <param name="columnWidth">optional NetOffice.MSProjectApi.Enums.PjRowColSize ColumnWidth = -1</param>
		/// <param name="adjustForPageBreaks">object adjustForPageBreaks</param>
		/// <param name="showSummaryTasks">object showSummaryTasks</param>
		/// <param name="viewBackgroundColor">object viewBackgroundColor</param>
		/// <param name="viewBackgroundPattern">optional NetOffice.MSProjectApi.Enums.PjBackgroundPattern ViewBackgroundPattern = -1</param>
		/// <param name="showProgressMarks">optional object showProgressMarks</param>
		/// <param name="showPageBreaks">optional object showPageBreaks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLayoutEx(object layoutMode, object layoutScheme, object summaryPrecedence, object rowAlignment, object columnAlignment, object rowSpacing, object columnSpacing, object rowHeight, object columnWidth, object adjustForPageBreaks, object showSummaryTasks, object viewBackgroundColor, object viewBackgroundPattern, object showProgressMarks, object showPageBreaks)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLayoutEx", new object[]{ layoutMode, layoutScheme, summaryPrecedence, rowAlignment, columnAlignment, rowSpacing, columnSpacing, rowHeight, columnWidth, adjustForPageBreaks, showSummaryTasks, viewBackgroundColor, viewBackgroundPattern, showProgressMarks, showPageBreaks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		/// <param name="colorMode">optional NetOffice.MSProjectApi.Enums.PjLinkColorMode ColorMode = -1</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		/// <param name="noncriticalColor">optional object noncriticalColor</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLinksEx(object style, object showArrows, object showLabels, object colorMode, object criticalColor, object noncriticalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinksEx", new object[]{ style, showArrows, showLabels, colorMode, criticalColor, noncriticalColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLinksEx(object style, object showArrows)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinksEx", style, showArrows);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLinksEx(object style, object showArrows, object showLabels)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinksEx", style, showArrows, showLabels);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		/// <param name="colorMode">optional NetOffice.MSProjectApi.Enums.PjLinkColorMode ColorMode = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLinksEx(object style, object showArrows, object showLabels, object colorMode)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinksEx", style, showArrows, showLabels, colorMode);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">optional NetOffice.MSProjectApi.Enums.PjLinkStyle Style = -1</param>
		/// <param name="showArrows">object showArrows</param>
		/// <param name="showLabels">object showLabels</param>
		/// <param name="colorMode">optional NetOffice.MSProjectApi.Enums.PjLinkColorMode ColorMode = -1</param>
		/// <param name="criticalColor">optional object criticalColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool BoxLinksEx(object style, object showArrows, object showLabels, object colorMode, object criticalColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "BoxLinksEx", new object[]{ style, showArrows, showLabels, colorMode, criticalColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaultsHyperlink">optional object setDefaultsHyperlink</param>
		/// <param name="inCellEditing">optional object inCellEditing</param>
		/// <param name="allowTaskDelegation">optional object allowTaskDelegation</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaultsHyperlink, object inCellEditing, object allowTaskDelegation)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaultsHyperlink, inCellEditing, allowTaskDelegation });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", moveAfterReturn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", moveAfterReturn, dragAndDrop);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", moveAfterReturn, dragAndDrop, updateLinks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaultsHyperlink">optional object setDefaultsHyperlink</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaultsHyperlink)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaultsHyperlink });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveAfterReturn">optional object moveAfterReturn</param>
		/// <param name="dragAndDrop">optional object dragAndDrop</param>
		/// <param name="updateLinks">optional object updateLinks</param>
		/// <param name="copyResourceUsageHeader">optional object copyResourceUsageHeader</param>
		/// <param name="phoneticInfo">optional object phoneticInfo</param>
		/// <param name="phoneticType">optional object phoneticType</param>
		/// <param name="minuteLabelDisplay">optional object minuteLabelDisplay</param>
		/// <param name="hourLabelDisplay">optional object hourLabelDisplay</param>
		/// <param name="dayLabelDisplay">optional object dayLabelDisplay</param>
		/// <param name="weekLabelDisplay">optional object weekLabelDisplay</param>
		/// <param name="yearLabelDisplay">optional object yearLabelDisplay</param>
		/// <param name="spaceBeforeTimeLabel">optional object spaceBeforeTimeLabel</param>
		/// <param name="setDefaults">optional object setDefaults</param>
		/// <param name="monthLabelDisplay">optional object monthLabelDisplay</param>
		/// <param name="setDefaultsTimeUnits">optional object setDefaultsTimeUnits</param>
		/// <param name="hyperlinkColor">optional object hyperlinkColor</param>
		/// <param name="followedHyperlinkColor">optional object followedHyperlinkColor</param>
		/// <param name="underlineHyperlinks">optional object underlineHyperlinks</param>
		/// <param name="setDefaultsHyperlink">optional object setDefaultsHyperlink</param>
		/// <param name="inCellEditing">optional object inCellEditing</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsEditEx(object moveAfterReturn, object dragAndDrop, object updateLinks, object copyResourceUsageHeader, object phoneticInfo, object phoneticType, object minuteLabelDisplay, object hourLabelDisplay, object dayLabelDisplay, object weekLabelDisplay, object yearLabelDisplay, object spaceBeforeTimeLabel, object setDefaults, object monthLabelDisplay, object setDefaultsTimeUnits, object hyperlinkColor, object followedHyperlinkColor, object underlineHyperlinks, object setDefaultsHyperlink, object inCellEditing)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsEditEx", new object[]{ moveAfterReturn, dragAndDrop, updateLinks, copyResourceUsageHeader, phoneticInfo, phoneticType, minuteLabelDisplay, hourLabelDisplay, dayLabelDisplay, weekLabelDisplay, yearLabelDisplay, spaceBeforeTimeLabel, setDefaults, monthLabelDisplay, setDefaultsTimeUnits, hyperlinkColor, followedHyperlinkColor, underlineHyperlinks, setDefaultsHyperlink, inCellEditing });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		/// <param name="labelFontName">optional object labelFontName</param>
		/// <param name="labelFontSize">optional object labelFontSize</param>
		/// <param name="labelFontBold">optional object labelFontBold</param>
		/// <param name="labelFontItalic">optional object labelFontItalic</param>
		/// <param name="labelFontUnderline">optional object labelFontUnderline</param>
		/// <param name="labelFontColor">optional object labelFontColor</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize, object labelFontBold, object labelFontItalic, object labelFontUnderline, object labelFontColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize, labelFontBold, labelFontItalic, labelFontUnderline, labelFontColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", name, textWidth, legendOn);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", name, textWidth, legendOn, alignment);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment, object text)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", new object[]{ name, textWidth, legendOn, alignment, text });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		/// <param name="labelFontName">optional object labelFontName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		/// <param name="labelFontName">optional object labelFontName</param>
		/// <param name="labelFontSize">optional object labelFontSize</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		/// <param name="labelFontName">optional object labelFontName</param>
		/// <param name="labelFontSize">optional object labelFontSize</param>
		/// <param name="labelFontBold">optional object labelFontBold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize, object labelFontBold)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize, labelFontBold });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		/// <param name="labelFontName">optional object labelFontName</param>
		/// <param name="labelFontSize">optional object labelFontSize</param>
		/// <param name="labelFontBold">optional object labelFontBold</param>
		/// <param name="labelFontItalic">optional object labelFontItalic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize, object labelFontBold, object labelFontItalic)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize, labelFontBold, labelFontItalic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">object name</param>
		/// <param name="textWidth">object textWidth</param>
		/// <param name="legendOn">object legendOn</param>
		/// <param name="alignment">optional NetOffice.MSProjectApi.Enums.PjAlignment Alignment = 1</param>
		/// <param name="text">optional object text</param>
		/// <param name="labelFontName">optional object labelFontName</param>
		/// <param name="labelFontSize">optional object labelFontSize</param>
		/// <param name="labelFontBold">optional object labelFontBold</param>
		/// <param name="labelFontItalic">optional object labelFontItalic</param>
		/// <param name="labelFontUnderline">optional object labelFontUnderline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupLegendEx(object name, object textWidth, object legendOn, object alignment, object text, object labelFontName, object labelFontSize, object labelFontBold, object labelFontItalic, object labelFontUnderline)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupLegendEx", new object[]{ name, textWidth, legendOn, alignment, text, labelFontName, labelFontSize, labelFontBold, labelFontItalic, labelFontUnderline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name, object item, object font, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", new object[]{ name, item, font, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name, object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", name, item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name, object item, object font)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", name, item, font);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name, object item, object font, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", name, item, font, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name, object item, object font, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", new object[]{ name, item, font, size, bold });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name, object item, object font, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", new object[]{ name, item, font, size, bold, italic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilePageSetupCalendarTextEx(object name, object item, object font, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilePageSetupCalendarTextEx", new object[]{ name, item, font, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		/// <param name="order">optional object order</param>
		/// <param name="fontWord">optional object fontWord</param>
		/// <param name="cellBackground">optional object cellBackground</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="shortcut">optional object shortcut</param>
		/// <param name="displayField">optional object displayField</param>
		/// <param name="fontColor">optional object fontColor</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex, object order, object fontWord, object cellBackground, object pattern, object shortcut, object displayField, object fontColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", new object[]{ curIndex, order, fontWord, cellBackground, pattern, shortcut, displayField, fontColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", curIndex);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		/// <param name="order">optional object order</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex, object order)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", curIndex, order);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		/// <param name="order">optional object order</param>
		/// <param name="fontWord">optional object fontWord</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex, object order, object fontWord)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", curIndex, order, fontWord);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		/// <param name="order">optional object order</param>
		/// <param name="fontWord">optional object fontWord</param>
		/// <param name="cellBackground">optional object cellBackground</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex, object order, object fontWord, object cellBackground)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", curIndex, order, fontWord, cellBackground);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		/// <param name="order">optional object order</param>
		/// <param name="fontWord">optional object fontWord</param>
		/// <param name="cellBackground">optional object cellBackground</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex, object order, object fontWord, object cellBackground, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", new object[]{ curIndex, order, fontWord, cellBackground, pattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		/// <param name="order">optional object order</param>
		/// <param name="fontWord">optional object fontWord</param>
		/// <param name="cellBackground">optional object cellBackground</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="shortcut">optional object shortcut</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex, object order, object fontWord, object cellBackground, object pattern, object shortcut)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", new object[]{ curIndex, order, fontWord, cellBackground, pattern, shortcut });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="curIndex">optional object curIndex</param>
		/// <param name="order">optional object order</param>
		/// <param name="fontWord">optional object fontWord</param>
		/// <param name="cellBackground">optional object cellBackground</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="shortcut">optional object shortcut</param>
		/// <param name="displayField">optional object displayField</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool UsageViewEntryEx(object curIndex, object order, object fontWord, object cellBackground, object pattern, object shortcut, object displayField)
		{
			return Factory.ExecuteBoolMethodGet(this, "UsageViewEntryEx", new object[]{ curIndex, order, fontWord, cellBackground, pattern, shortcut, displayField });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		/// <param name="strikethrough">optional object strikethrough</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor, object pattern, object showInMenu, object strikethrough)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", new object[]{ item, font, size, bold, italic, underline, color, cellColor, pattern, showInMenu, strikethrough });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", item, font);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", item, font, size);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", item, font, size, bold);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold, object italic)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", new object[]{ item, font, size, bold, italic });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold, object italic, object underline)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", new object[]{ item, font, size, bold, italic, underline });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold, object italic, object underline, object color)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", new object[]{ item, font, size, bold, italic, underline, color });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", new object[]{ item, font, size, bold, italic, underline, color, cellColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor, object pattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", new object[]{ item, font, size, bold, italic, underline, color, cellColor, pattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">optional object item</param>
		/// <param name="font">optional object font</param>
		/// <param name="size">optional object size</param>
		/// <param name="bold">optional object bold</param>
		/// <param name="italic">optional object italic</param>
		/// <param name="underline">optional object underline</param>
		/// <param name="color">optional object color</param>
		/// <param name="cellColor">optional object cellColor</param>
		/// <param name="pattern">optional object pattern</param>
		/// <param name="showInMenu">optional object showInMenu</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailStylesFormatEx(object item, object font, object size, object bold, object italic, object underline, object color, object cellColor, object pattern, object showInMenu)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailStylesFormatEx", new object[]{ item, font, size, bold, italic, underline, color, cellColor, pattern, showInMenu });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="insideText">optional object insideText</param>
		/// <param name="reset">optional object reset</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText, object insideText, object reset, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText, insideText, reset, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", taskID, ganttStyle);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", taskID, ganttStyle, startShape);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", taskID, ganttStyle, startShape, startType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="insideText">optional object insideText</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText, object insideText)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText, insideText });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="ganttStyle">optional object ganttStyle</param>
		/// <param name="startShape">optional object startShape</param>
		/// <param name="startType">optional object startType</param>
		/// <param name="startColor">optional object startColor</param>
		/// <param name="middleShape">optional object middleShape</param>
		/// <param name="middlePattern">optional object middlePattern</param>
		/// <param name="middleColor">optional object middleColor</param>
		/// <param name="endShape">optional object endShape</param>
		/// <param name="endType">optional object endType</param>
		/// <param name="endColor">optional object endColor</param>
		/// <param name="leftText">optional object leftText</param>
		/// <param name="rightText">optional object rightText</param>
		/// <param name="topText">optional object topText</param>
		/// <param name="bottomText">optional object bottomText</param>
		/// <param name="insideText">optional object insideText</param>
		/// <param name="reset">optional object reset</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarFormatEx(object taskID, object ganttStyle, object startShape, object startType, object startColor, object middleShape, object middlePattern, object middleColor, object endShape, object endType, object endColor, object leftText, object rightText, object topText, object bottomText, object insideText, object reset)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarFormatEx", new object[]{ taskID, ganttStyle, startShape, startType, startColor, middleShape, middlePattern, middleColor, endShape, endType, endColor, leftText, rightText, topText, bottomText, insideText, reset });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="remove">optional object remove</param>
		/// <param name="timelineViewName">optional object timelineViewName</param>
		/// <param name="showDialog">optional object showDialog</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskOnTimeline(object taskID, object remove, object timelineViewName, object showDialog)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskOnTimeline", taskID, remove, timelineViewName, showDialog);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskOnTimeline()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskOnTimeline");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskOnTimeline(object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskOnTimeline", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="remove">optional object remove</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskOnTimeline(object taskID, object remove)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskOnTimeline", taskID, remove);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="remove">optional object remove</param>
		/// <param name="timelineViewName">optional object timelineViewName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskOnTimeline(object taskID, object remove, object timelineViewName)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskOnTimeline", taskID, remove, timelineViewName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveForward">optional object moveForward</param>
		/// <param name="isWorkingDuration">optional object isWorkingDuration</param>
		/// <param name="moveDays">optional object moveDays</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskMove(object moveForward, object isWorkingDuration, object moveDays)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskMove", moveForward, isWorkingDuration, moveDays);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskMove()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskMove");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveForward">optional object moveForward</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskMove(object moveForward)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskMove", moveForward);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveForward">optional object moveForward</param>
		/// <param name="isWorkingDuration">optional object isWorkingDuration</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskMove(object moveForward, object isWorkingDuration)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskMove", moveForward, isWorkingDuration);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		/// <param name="moveIncomplete">optional object moveIncomplete</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskMoveToStatusDate(object moveCompleted, object moveIncomplete)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskMoveToStatusDate", moveCompleted, moveIncomplete);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskMoveToStatusDate()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskMoveToStatusDate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="moveCompleted">optional object moveCompleted</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskMoveToStatusDate(object moveCompleted)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskMoveToStatusDate", moveCompleted);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="date">optional object date</param>
		/// <param name="moveDeadline">optional object moveDeadline</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ProjectMove(object date, object moveDeadline)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectMove", date, moveDeadline);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ProjectMove()
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectMove");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="date">optional object date</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ProjectMove(object date)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectMove", date);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="resolveMethod">optional NetOffice.MSProjectApi.Enums.PjLevelSelectedOption ResolveMethod = 0</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelSelected(object resolveMethod)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelSelected", resolveMethod);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelSelected()
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelSelected");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style</param>
		/// <param name="fillColor">optional object fillColor</param>
		/// <param name="borderColor">optional object borderColor</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool EditTPStyle(NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style, object fillColor, object borderColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditTPStyle", style, fillColor, borderColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool EditTPStyle(NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditTPStyle", style);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style</param>
		/// <param name="fillColor">optional object fillColor</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool EditTPStyle(NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style, object fillColor)
		{
			return Factory.ExecuteBoolMethodGet(this, "EditTPStyle", style, fillColor);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="style">NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ResetTPStyle(NetOffice.MSProjectApi.Enums.PjTeamPlannerStyle style)
		{
			return Factory.ExecuteBoolMethodGet(this, "ResetTPStyle", style);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="lineMultiple">Int16 lineMultiple</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SelectTPLineHeight(Int16 lineMultiple)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTPLineHeight", lineMultiple);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjTimelineShowHide item</param>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineShowHide(NetOffice.MSProjectApi.Enums.PjTimelineShowHide item, object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineShowHide", item, show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="item">NetOffice.MSProjectApi.Enums.PjTimelineShowHide item</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineShowHide(NetOffice.MSProjectApi.Enums.PjTimelineShowHide item)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineShowHide", item);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="textOnBar">optional object textOnBar</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineTextOnBar(object textOnBar)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineTextOnBar", textOnBar);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineTextOnBar()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineTextOnBar");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="type">NetOffice.MSProjectApi.Enums.PjTimelineInsertTaskType type</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineInsertTask(NetOffice.MSProjectApi.Enums.PjTimelineInsertTaskType type)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineInsertTask", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="selectionOnly">optional object selectionOnly</param>
		/// <param name="exportWidth">optional object exportWidth</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineExport(object selectionOnly, object exportWidth)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineExport", selectionOnly, exportWidth);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineExport()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineExport");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="selectionOnly">optional object selectionOnly</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineExport(object selectionOnly)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineExport", selectionOnly);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool FontStrikethrough(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "FontStrikethrough", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FontStrikethrough()
		{
			return Factory.ExecuteBoolMethodGet(this, "FontStrikethrough");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldName">object fieldName</param>
		/// <param name="filterType">optional NetOffice.MSProjectApi.Enums.PjAutoFilterType FilterType = 0</param>
		/// <param name="test1">optional object test1</param>
		/// <param name="criteria1">optional object criteria1</param>
		/// <param name="operation">optional object operation</param>
		/// <param name="test2">optional object test2</param>
		/// <param name="criteria2">optional object criteria2</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SetAutoFilter(object fieldName, object filterType, object test1, object criteria1, object operation, object test2, object criteria2)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetAutoFilter", new object[]{ fieldName, filterType, test1, criteria1, operation, test2, criteria2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldName">object fieldName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetAutoFilter(object fieldName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetAutoFilter", fieldName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldName">object fieldName</param>
		/// <param name="filterType">optional NetOffice.MSProjectApi.Enums.PjAutoFilterType FilterType = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetAutoFilter(object fieldName, object filterType)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetAutoFilter", fieldName, filterType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldName">object fieldName</param>
		/// <param name="filterType">optional NetOffice.MSProjectApi.Enums.PjAutoFilterType FilterType = 0</param>
		/// <param name="test1">optional object test1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetAutoFilter(object fieldName, object filterType, object test1)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetAutoFilter", fieldName, filterType, test1);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldName">object fieldName</param>
		/// <param name="filterType">optional NetOffice.MSProjectApi.Enums.PjAutoFilterType FilterType = 0</param>
		/// <param name="test1">optional object test1</param>
		/// <param name="criteria1">optional object criteria1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetAutoFilter(object fieldName, object filterType, object test1, object criteria1)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetAutoFilter", fieldName, filterType, test1, criteria1);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldName">object fieldName</param>
		/// <param name="filterType">optional NetOffice.MSProjectApi.Enums.PjAutoFilterType FilterType = 0</param>
		/// <param name="test1">optional object test1</param>
		/// <param name="criteria1">optional object criteria1</param>
		/// <param name="operation">optional object operation</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetAutoFilter(object fieldName, object filterType, object test1, object criteria1, object operation)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetAutoFilter", new object[]{ fieldName, filterType, test1, criteria1, operation });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldName">object fieldName</param>
		/// <param name="filterType">optional NetOffice.MSProjectApi.Enums.PjAutoFilterType FilterType = 0</param>
		/// <param name="test1">optional object test1</param>
		/// <param name="criteria1">optional object criteria1</param>
		/// <param name="operation">optional object operation</param>
		/// <param name="test2">optional object test2</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetAutoFilter(object fieldName, object filterType, object test1, object criteria1, object operation, object test2)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetAutoFilter", new object[]{ fieldName, filterType, test1, criteria1, operation, test2 });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filterType">optional NetOffice.MSProjectApi.Enums.PjFilterViewType FilterType = 65535</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool FilterNew(object filterType)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterNew", filterType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FilterNew()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterNew");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool FilterClear()
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterClear");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool GroupNew()
		{
			return Factory.ExecuteBoolMethodGet(this, "GroupNew");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool GroupClear()
		{
			return Factory.ExecuteBoolMethodGet(this, "GroupClear");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertScheduledTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertScheduledTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertManualTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertManualTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertMilestoneTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertMilestoneTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertBlankRow()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertBlankRow");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="startOnDate">optional NetOffice.MSProjectApi.Enums.PjNewTasksStartOnDate StartOnDate = 0</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool NewTasksStartOn(object startOnDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "NewTasksStartOn", startOnDate);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool NewTasksStartOn()
		{
			return Factory.ExecuteBoolMethodGet(this, "NewTasksStartOn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="on">bool on</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GroupMaintainHierarchy(bool on)
		{
			return Factory.ExecuteBoolMethodGet(this, "GroupMaintainHierarchy", on);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="on">bool on</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool FilterShowSummaryRows(bool on)
		{
			return Factory.ExecuteBoolMethodGet(this, "FilterShowSummaryRows", on);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ToggleTaskDetails()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleTaskDetails");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ToggleResourceDetails()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleResourceDetails");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleCritical(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleCritical", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleCritical()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleCritical");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleSlack(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleSlack", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleSlack()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleSlack");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleLate(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleLate", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleLate()
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleLate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="baseline">Int16 baseline</param>
		/// <param name="show">bool show</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleBaseline(Int16 baseline, bool show)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleBaseline", baseline, show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="baseline">Int16 baseline</param>
		/// <param name="show">bool show</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool GanttBarStyleSlippage(Int16 baseline, bool show)
		{
			return Factory.ExecuteBoolMethodGet(this, "GanttBarStyleSlippage", baseline, show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TogglePreventResOveralloc()
		{
			return Factory.ExecuteBoolMethodGet(this, "TogglePreventResOveralloc");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ToggleTPAutoExpand()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleTPAutoExpand");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ToggleTPUnassigned()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleTPUnassigned");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ToggleTPUnscheduled()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleTPUnscheduled");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="manual">optional object manual</param>
		/// <param name="isStickyDates">optional object isStickyDates</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskMode(object manual, object isStickyDates)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskMode", manual, isStickyDates);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskMode()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskMode");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="manual">optional object manual</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskMode(object manual)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskMode", manual);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="makeActive">optional object makeActive</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool InactivateTaskToggle(object makeActive)
		{
			return Factory.ExecuteBoolMethodGet(this, "InactivateTaskToggle", makeActive);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool InactivateTaskToggle()
		{
			return Factory.ExecuteBoolMethodGet(this, "InactivateTaskToggle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedTasks, object create, object taskID, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskFieldByID", new object[]{ fieldID, value, allSelectedTasks, create, taskID, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskFieldByID", fieldID, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskFieldByID", fieldID, value, allSelectedTasks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedTasks, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskFieldByID", fieldID, value, allSelectedTasks, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		/// <param name="taskID">optional object taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTaskFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedTasks, object create, object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTaskFieldByID", new object[]{ fieldID, value, allSelectedTasks, create, taskID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		/// <param name="create">optional object create</param>
		/// <param name="resourceID">optional object resourceID</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SetResourceFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedResources, object create, object resourceID, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceFieldByID", new object[]{ fieldID, value, allSelectedResources, create, resourceID, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetResourceFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceFieldByID", fieldID, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetResourceFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedResources)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceFieldByID", fieldID, value, allSelectedResources);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetResourceFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedResources, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceFieldByID", fieldID, value, allSelectedResources, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="fieldID">NetOffice.MSProjectApi.Enums.PjField fieldID</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedResources">optional object allSelectedResources</param>
		/// <param name="create">optional object create</param>
		/// <param name="resourceID">optional object resourceID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetResourceFieldByID(NetOffice.MSProjectApi.Enums.PjField fieldID, string value, object allSelectedResources, object create, object resourceID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetResourceFieldByID", new object[]{ fieldID, value, allSelectedResources, create, resourceID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="timeline">optional object timeline</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailsPaneToggle(object timeline)
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailsPaneToggle", timeline);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DetailsPaneToggle()
		{
			return Factory.ExecuteBoolMethodGet(this, "DetailsPaneToggle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="testID">optional object testID</param>
		/// <param name="searchAllFields">optional object searchAllFields</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field, object test, object value, object next, object matchCase, object fieldID, object testID, object searchAllFields)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", new object[]{ field, test, value, next, matchCase, fieldID, testID, searchAllFields });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", field);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field, object test)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", field, test);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field, object test, object value)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", field, test, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field, object test, object value, object next)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", field, test, value, next);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field, object test, object value, object next, object matchCase)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", new object[]{ field, test, value, next, matchCase });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field, object test, object value, object next, object matchCase, object fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", new object[]{ field, test, value, next, matchCase, fieldID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="testID">optional object testID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool FindEx(object field, object test, object value, object next, object matchCase, object fieldID, object testID)
		{
			return Factory.ExecuteBoolMethodGet(this, "FindEx", new object[]{ field, test, value, next, matchCase, fieldID, testID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="testID">optional object testID</param>
		/// <param name="searchAllFields">optional object searchAllFields</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value, object replacement, object replaceAll, object next, object matchCase, object fieldID, object testID, object searchAllFields)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", new object[]{ field, test, value, replacement, replaceAll, next, matchCase, fieldID, testID, searchAllFields });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", field);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", field, test);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", field, test, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value, object replacement)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", field, test, value, replacement);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value, object replacement, object replaceAll)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", new object[]{ field, test, value, replacement, replaceAll });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value, object replacement, object replaceAll, object next)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", new object[]{ field, test, value, replacement, replaceAll, next });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value, object replacement, object replaceAll, object next, object matchCase)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", new object[]{ field, test, value, replacement, replaceAll, next, matchCase });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value, object replacement, object replaceAll, object next, object matchCase, object fieldID)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", new object[]{ field, test, value, replacement, replaceAll, next, matchCase, fieldID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">optional object field</param>
		/// <param name="test">optional object test</param>
		/// <param name="value">optional object value</param>
		/// <param name="replacement">optional object replacement</param>
		/// <param name="replaceAll">optional object replaceAll</param>
		/// <param name="next">optional object next</param>
		/// <param name="matchCase">optional object matchCase</param>
		/// <param name="fieldID">optional object fieldID</param>
		/// <param name="testID">optional object testID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplaceEx(object field, object test, object value, object replacement, object replaceAll, object next, object matchCase, object fieldID, object testID)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplaceEx", new object[]{ field, test, value, replacement, replaceAll, next, matchCase, fieldID, testID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool SelectToEnd()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectToEnd");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool SelectTaskAssns()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTaskAssns");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="resourceUniqueID">optional object resourceUniqueID</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ReassignSelectedAssns(object resourceUniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReassignSelectedAssns", resourceUniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReassignSelectedAssns()
		{
			return Factory.ExecuteBoolMethodGet(this, "ReassignSelectedAssns");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		/// <param name="taskID">optional object taskID</param>
		/// <param name="projectName">optional object projectName</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTPField(string field, string value, object allSelectedTasks, object create, object taskID, object projectName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTPField", new object[]{ field, value, allSelectedTasks, create, taskID, projectName });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTPField(string field, string value)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTPField", field, value);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTPField(string field, string value, object allSelectedTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTPField", field, value, allSelectedTasks);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTPField(string field, string value, object allSelectedTasks, object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTPField", field, value, allSelectedTasks, create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="field">string field</param>
		/// <param name="value">string value</param>
		/// <param name="allSelectedTasks">optional object allSelectedTasks</param>
		/// <param name="create">optional object create</param>
		/// <param name="taskID">optional object taskID</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetTPField(string field, string value, object allSelectedTasks, object create, object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetTPField", new object[]{ field, value, allSelectedTasks, create, taskID });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="fileType">optional NetOffice.MSProjectApi.Enums.PjDocExportType FileType = 0</param>
		/// <param name="includeDocumentProperties">optional object includeDocumentProperties</param>
		/// <param name="includeDocumentMarkup">optional object includeDocumentMarkup</param>
		/// <param name="archiveFormat">optional object archiveFormat</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool DocumentExport(object filename, object fileType, object includeDocumentProperties, object includeDocumentMarkup, object archiveFormat, object fromDate, object toDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentExport", new object[]{ filename, fileType, includeDocumentProperties, includeDocumentMarkup, archiveFormat, fromDate, toDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DocumentExport(object filename)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentExport", filename);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="fileType">optional NetOffice.MSProjectApi.Enums.PjDocExportType FileType = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DocumentExport(object filename, object fileType)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentExport", filename, fileType);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="fileType">optional NetOffice.MSProjectApi.Enums.PjDocExportType FileType = 0</param>
		/// <param name="includeDocumentProperties">optional object includeDocumentProperties</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DocumentExport(object filename, object fileType, object includeDocumentProperties)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentExport", filename, fileType, includeDocumentProperties);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="fileType">optional NetOffice.MSProjectApi.Enums.PjDocExportType FileType = 0</param>
		/// <param name="includeDocumentProperties">optional object includeDocumentProperties</param>
		/// <param name="includeDocumentMarkup">optional object includeDocumentMarkup</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DocumentExport(object filename, object fileType, object includeDocumentProperties, object includeDocumentMarkup)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentExport", filename, fileType, includeDocumentProperties, includeDocumentMarkup);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="fileType">optional NetOffice.MSProjectApi.Enums.PjDocExportType FileType = 0</param>
		/// <param name="includeDocumentProperties">optional object includeDocumentProperties</param>
		/// <param name="includeDocumentMarkup">optional object includeDocumentMarkup</param>
		/// <param name="archiveFormat">optional object archiveFormat</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DocumentExport(object filename, object fileType, object includeDocumentProperties, object includeDocumentMarkup, object archiveFormat)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentExport", new object[]{ filename, fileType, includeDocumentProperties, includeDocumentMarkup, archiveFormat });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="fileType">optional NetOffice.MSProjectApi.Enums.PjDocExportType FileType = 0</param>
		/// <param name="includeDocumentProperties">optional object includeDocumentProperties</param>
		/// <param name="includeDocumentMarkup">optional object includeDocumentMarkup</param>
		/// <param name="archiveFormat">optional object archiveFormat</param>
		/// <param name="fromDate">optional object fromDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool DocumentExport(object filename, object fileType, object includeDocumentProperties, object includeDocumentMarkup, object archiveFormat, object fromDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "DocumentExport", new object[]{ filename, fileType, includeDocumentProperties, includeDocumentMarkup, archiveFormat, fromDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="create">optional object create</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskDeliverableCreate(object create)
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskDeliverableCreate", create);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskDeliverableCreate()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskDeliverableCreate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskDeliverableSync()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskDeliverableSync");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskDependencySync()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskDependencySync");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskRespectLinks()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskRespectLinks");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SetShowTaskWarnings(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetShowTaskWarnings", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetShowTaskWarnings()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetShowTaskWarnings");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SetShowTaskSuggestions(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetShowTaskSuggestions", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetShowTaskSuggestions()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetShowTaskSuggestions");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ShowIgnoredTaskWarnings()
		{
			return Factory.ExecuteBoolMethodGet(this, "ShowIgnoredTaskWarnings");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="type">optional NetOffice.MSProjectApi.Enums.PjResourceTypes Type = 0</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertResource(object type)
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertResource", type);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertResource()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertResource");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool InsertSummaryTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "InsertSummaryTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="date">optional object date</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ChangeStatusDate(object date)
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeStatusDate", date);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ChangeStatusDate()
		{
			return Factory.ExecuteBoolMethodGet(this, "ChangeStatusDate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="taskTable">object taskTable</param>
		/// <param name="resourceTable">object resourceTable</param>
		/// <param name="items">optional NetOffice.MSProjectApi.Enums.PjCompareVersionItems Items = 6</param>
		/// <param name="columns">optional NetOffice.MSProjectApi.Enums.PjCompareVersionColumns Columns = 0</param>
		/// <param name="showLegend">optional object showLegend</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool CreateComparisonReport(object filename, object taskTable, object resourceTable, object items, object columns, object showLegend)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateComparisonReport", new object[]{ filename, taskTable, resourceTable, items, columns, showLegend });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="taskTable">object taskTable</param>
		/// <param name="resourceTable">object resourceTable</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CreateComparisonReport(object filename, object taskTable, object resourceTable)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateComparisonReport", filename, taskTable, resourceTable);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="taskTable">object taskTable</param>
		/// <param name="resourceTable">object resourceTable</param>
		/// <param name="items">optional NetOffice.MSProjectApi.Enums.PjCompareVersionItems Items = 6</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CreateComparisonReport(object filename, object taskTable, object resourceTable, object items)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateComparisonReport", filename, taskTable, resourceTable, items);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">object filename</param>
		/// <param name="taskTable">object taskTable</param>
		/// <param name="resourceTable">object resourceTable</param>
		/// <param name="items">optional NetOffice.MSProjectApi.Enums.PjCompareVersionItems Items = 6</param>
		/// <param name="columns">optional NetOffice.MSProjectApi.Enums.PjCompareVersionColumns Columns = 0</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CreateComparisonReport(object filename, object taskTable, object resourceTable, object items, object columns)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateComparisonReport", new object[]{ filename, taskTable, resourceTable, items, columns });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool CompareProjectVersions()
		{
			return Factory.ExecuteBoolMethodGet(this, "CompareProjectVersions");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskComparison()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskComparison");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ResourceComparison()
		{
			return Factory.ExecuteBoolMethodGet(this, "ResourceComparison");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool GoToItemInVersions()
		{
			return Factory.ExecuteBoolMethodGet(this, "GoToItemInVersions");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool CloseComparison()
		{
			return Factory.ExecuteBoolMethodGet(this, "CloseComparison");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool CompareProjectsLegendToggle()
		{
			return Factory.ExecuteBoolMethodGet(this, "CompareProjectsLegendToggle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">Int32 taskID</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ClearConstraint(Int32 taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "ClearConstraint", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TaskInspector()
		{
			return Factory.ExecuteBoolMethodGet(this, "TaskInspector");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="defaultTab">optional NetOffice.MSProjectApi.Enums.PjOptionsSecurityTab DefaultTab = 0</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsSecurityTab(object defaultTab)
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurityTab", defaultTab);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OptionsSecurityTab()
		{
			return Factory.ExecuteBoolMethodGet(this, "OptionsSecurityTab");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="action">optional object action</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplanAssignments(object action)
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplanAssignments", action);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ReplanAssignments()
		{
			return Factory.ExecuteBoolMethodGet(this, "ReplanAssignments");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="set">optional object set</param>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetIgnoreWarningsForTask(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "SetIgnoreWarningsForTask", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SetIgnoreWarningsForTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetIgnoreWarningsForTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="page">optional NetOffice.MSProjectApi.Enums.PjServerPage Page = 0</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool OpenServerPage(object page)
		{
			return Factory.ExecuteBoolMethodGet(this, "OpenServerPage", page);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool OpenServerPage()
		{
			return Factory.ExecuteBoolMethodGet(this, "OpenServerPage");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="numLines">optional object numLines</param>
		/// <param name="minimized">optional object minimized</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineFormat(object numLines, object minimized)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineFormat", numLines, minimized);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineFormat()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineFormat");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="numLines">optional object numLines</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineFormat(object numLines)
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineFormat", numLines);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		/// <param name="levelIndividualAssignments">optional object levelIndividualAssignments</param>
		/// <param name="levelingCanSplit">optional object levelingCanSplit</param>
		/// <param name="levelProposedBookings">optional object levelProposedBookings</param>
		/// <param name="levelPinnedTasks">optional object levelPinnedTasks</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis, object levelIndividualAssignments, object levelingCanSplit, object levelProposedBookings, object levelPinnedTasks)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis, levelIndividualAssignments, levelingCanSplit, levelProposedBookings, levelPinnedTasks });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", automatic);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", automatic, delayInSlack);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", automatic, delayInSlack, autoClearLeveling);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", automatic, delayInSlack, autoClearLeveling, order);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		/// <param name="levelIndividualAssignments">optional object levelIndividualAssignments</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis, object levelIndividualAssignments)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis, levelIndividualAssignments });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		/// <param name="levelIndividualAssignments">optional object levelIndividualAssignments</param>
		/// <param name="levelingCanSplit">optional object levelingCanSplit</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis, object levelIndividualAssignments, object levelingCanSplit)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis, levelIndividualAssignments, levelingCanSplit });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="automatic">optional object automatic</param>
		/// <param name="delayInSlack">optional object delayInSlack</param>
		/// <param name="autoClearLeveling">optional object autoClearLeveling</param>
		/// <param name="order">optional object order</param>
		/// <param name="levelEntireProject">optional object levelEntireProject</param>
		/// <param name="fromDate">optional object fromDate</param>
		/// <param name="toDate">optional object toDate</param>
		/// <param name="periodBasis">optional object periodBasis</param>
		/// <param name="levelIndividualAssignments">optional object levelIndividualAssignments</param>
		/// <param name="levelingCanSplit">optional object levelingCanSplit</param>
		/// <param name="levelProposedBookings">optional object levelProposedBookings</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool LevelingOptionsEx(object automatic, object delayInSlack, object autoClearLeveling, object order, object levelEntireProject, object fromDate, object toDate, object periodBasis, object levelIndividualAssignments, object levelingCanSplit, object levelProposedBookings)
		{
			return Factory.ExecuteBoolMethodGet(this, "LevelingOptionsEx", new object[]{ automatic, delayInSlack, autoClearLeveling, order, levelEntireProject, fromDate, toDate, periodBasis, levelIndividualAssignments, levelingCanSplit, levelProposedBookings });
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="color">Int32 color</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SegmentFillColor(Int32 color)
		{
			return Factory.ExecuteBoolMethodGet(this, "SegmentFillColor", color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="color">Int32 color</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SegmentBorderColor(Int32 color)
		{
			return Factory.ExecuteBoolMethodGet(this, "SegmentBorderColor", color);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineGotoSelectedTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineGotoSelectedTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="resourceUniqueID">optional object resourceUniqueID</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool ToggleTPResourceExpand(object resourceUniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleTPResourceExpand", resourceUniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool ToggleTPResourceExpand()
		{
			return Factory.ExecuteBoolMethodGet(this, "ToggleTPResourceExpand");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="filename">optional object filename</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool CleanupProjectFromCache(object filename)
		{
			return Factory.ExecuteBoolMethodGet(this, "CleanupProjectFromCache", filename);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool CleanupProjectFromCache()
		{
			return Factory.ExecuteBoolMethodGet(this, "CleanupProjectFromCache");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool ShareProjectOnline()
		{
			return Factory.ExecuteBoolMethodGet(this, "ShareProjectOnline");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskUniqueID">optional object taskUniqueID</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool SelectTPTask(object taskUniqueID)
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTPTask", taskUniqueID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool SelectTPTask()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTPTask");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		/// <param name="taskID">optional object taskID</param>
		[SupportByVersion("MSProject", 11,14)]
		public bool RescheduleToNextAvailable(object taskID)
		{
			return Factory.ExecuteBoolMethodGet(this, "RescheduleToNextAvailable", taskID);
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11,14)]
		public bool RescheduleToNextAvailable()
		{
			return Factory.ExecuteBoolMethodGet(this, "RescheduleToNextAvailable");
		}

		/// <summary>
		/// SupportByVersion MSProject 11, 14
		/// </summary>
		[SupportByVersion("MSProject", 11,14)]
		public bool TimelineViewToggle()
		{
			return Factory.ExecuteBoolMethodGet(this, "TimelineViewToggle");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool Table()
		{
			return Factory.ExecuteBoolMethodGet(this, "Table");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool ReportsDialog()
		{
			return Factory.ExecuteBoolMethodGet(this, "ReportsDialog");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="percent">optional object percent</param>
		/// <param name="entire">optional object entire</param>
		[SupportByVersion("MSProject", 11)]
		public bool ZoomReport(object percent, object entire)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomReport", percent, entire);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ZoomReport()
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomReport");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="percent">optional object percent</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ZoomReport(object percent)
		{
			return Factory.ExecuteBoolMethodGet(this, "ZoomReport", percent);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="name">optional object name</param>
		/// <param name="applyTo">optional object applyTo</param>
		[SupportByVersion("MSProject", 11)]
		public bool ApplyReport(object name, object applyTo)
		{
			return Factory.ExecuteBoolMethodGet(this, "ApplyReport", name, applyTo);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ApplyReport()
		{
			return Factory.ExecuteBoolMethodGet(this, "ApplyReport");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="name">optional object name</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ApplyReport(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ApplyReport", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11)]
		public bool FileOpenOrCreate(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenOrCreate", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool FileOpenOrCreate()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenOrCreate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11)]
		public bool ShowOSFTaskPane(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ShowOSFTaskPane", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ShowOSFTaskPane()
		{
			return Factory.ExecuteBoolMethodGet(this, "ShowOSFTaskPane");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="parentSiteUrl">optional object parentSiteUrl</param>
		/// <param name="newSiteName">optional object newSiteName</param>
		/// <param name="launchBrowser">optional object launchBrowser</param>
		[SupportByVersion("MSProject", 11)]
		public bool CreateProjectSite(object parentSiteUrl, object newSiteName, object launchBrowser)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateProjectSite", parentSiteUrl, newSiteName, launchBrowser);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool CreateProjectSite()
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateProjectSite");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="parentSiteUrl">optional object parentSiteUrl</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool CreateProjectSite(object parentSiteUrl)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateProjectSite", parentSiteUrl);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="parentSiteUrl">optional object parentSiteUrl</param>
		/// <param name="newSiteName">optional object newSiteName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool CreateProjectSite(object parentSiteUrl, object newSiteName)
		{
			return Factory.ExecuteBoolMethodGet(this, "CreateProjectSite", parentSiteUrl, newSiteName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		/// <param name="taskListName">optional object taskListName</param>
		[SupportByVersion("MSProject", 11)]
		public bool LinkToTaskList(object siteURL, object taskListName)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkToTaskList", siteURL, taskListName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool LinkToTaskList()
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkToTaskList");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool LinkToTaskList(object siteURL)
		{
			return Factory.ExecuteBoolMethodGet(this, "LinkToTaskList", siteURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="uRL">optional object uRL</param>
		[SupportByVersion("MSProject", 11)]
		public bool OpenBrowser(object uRL)
		{
			return Factory.ExecuteBoolMethodGet(this, "OpenBrowser", uRL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool OpenBrowser()
		{
			return Factory.ExecuteBoolMethodGet(this, "OpenBrowser");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool PasteAsPicture()
		{
			return Factory.ExecuteBoolMethodGet(this, "PasteAsPicture");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool PasteSourceFormatting()
		{
			return Factory.ExecuteBoolMethodGet(this, "PasteSourceFormatting");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool PasteDestFormatting()
		{
			return Factory.ExecuteBoolMethodGet(this, "PasteDestFormatting");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool CopyReport()
		{
			return Factory.ExecuteBoolMethodGet(this, "CopyReport");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="name">optional object name</param>
		[SupportByVersion("MSProject", 11)]
		public bool ProjectCheckOut(object name)
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectCheckOut", name);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ProjectCheckOut()
		{
			return Factory.ExecuteBoolMethodGet(this, "ProjectCheckOut");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool SelectTable()
		{
			return Factory.ExecuteBoolMethodGet(this, "SelectTable");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool DistributeTableRows()
		{
			return Factory.ExecuteBoolMethodGet(this, "DistributeTableRows");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool DistributeTableColumns()
		{
			return Factory.ExecuteBoolMethodGet(this, "DistributeTableColumns");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool SetRTLTable()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetRTLTable");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool SetLTRTable()
		{
			return Factory.ExecuteBoolMethodGet(this, "SetLTRTable");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool AlignTableCellTop()
		{
			return Factory.ExecuteBoolMethodGet(this, "AlignTableCellTop");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool AlignTableCellVerticalCenter()
		{
			return Factory.ExecuteBoolMethodGet(this, "AlignTableCellVerticalCenter");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool AlignTableCellBottom()
		{
			return Factory.ExecuteBoolMethodGet(this, "AlignTableCellBottom");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="templateId">optional NetOffice.MSProjectApi.Enums.PjReportLayoutTemplateId TemplateId = 0</param>
		[SupportByVersion("MSProject", 11)]
		public bool ApplyReportLayoutTemplate(object templateId)
		{
			return Factory.ExecuteBoolMethodGet(this, "ApplyReportLayoutTemplate", templateId);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ApplyReportLayoutTemplate()
		{
			return Factory.ExecuteBoolMethodGet(this, "ApplyReportLayoutTemplate");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		/// <param name="listName">optional object listName</param>
		/// <param name="doSync">optional object doSync</param>
		/// <param name="fromSave">optional object fromSave</param>
		[SupportByVersion("MSProject", 11)]
		public bool SynchronizeWithSiteEx(object siteURL, object listName, object doSync, object fromSave)
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSiteEx", siteURL, listName, doSync, fromSave);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool SynchronizeWithSiteEx()
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSiteEx");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool SynchronizeWithSiteEx(object siteURL)
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSiteEx", siteURL);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		/// <param name="listName">optional object listName</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool SynchronizeWithSiteEx(object siteURL, object listName)
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSiteEx", siteURL, listName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="siteURL">optional object siteURL</param>
		/// <param name="listName">optional object listName</param>
		/// <param name="doSync">optional object doSync</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool SynchronizeWithSiteEx(object siteURL, object listName, object doSync)
		{
			return Factory.ExecuteBoolMethodGet(this, "SynchronizeWithSiteEx", siteURL, listName, doSync);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11)]
		public bool HighlightPredecessors(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightPredecessors", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool HighlightPredecessors()
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightPredecessors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11)]
		public bool HighlightDrivingPredecessors(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightDrivingPredecessors", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool HighlightDrivingPredecessors()
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightDrivingPredecessors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11)]
		public bool HighlightSuccessors(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightSuccessors", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool HighlightSuccessors()
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightSuccessors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="set">optional object set</param>
		[SupportByVersion("MSProject", 11)]
		public bool HighlightDrivenSuccessors(object set)
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightDrivenSuccessors", set);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool HighlightDrivenSuccessors()
		{
			return Factory.ExecuteBoolMethodGet(this, "HighlightDrivenSuccessors");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool RemoveHighlight()
		{
			return Factory.ExecuteBoolMethodGet(this, "RemoveHighlight");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="show">optional object show</param>
		[SupportByVersion("MSProject", 11)]
		public bool ShowReportDataPane(object show)
		{
			return Factory.ExecuteBoolMethodGet(this, "ShowReportDataPane", show);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool ShowReportDataPane()
		{
			return Factory.ExecuteBoolMethodGet(this, "ShowReportDataPane");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool RenameReport()
		{
			return Factory.ExecuteBoolMethodGet(this, "RenameReport");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[SupportByVersion("MSProject", 11)]
		public bool FileOpenUsingBackstage()
		{
			return Factory.ExecuteBoolMethodGet(this, "FileOpenUsingBackstage");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="projectField">optional NetOffice.MSProjectApi.Enums.PjField ProjectField = -1</param>
		/// <param name="sharePointName">optional object sharePointName</param>
		[SupportByVersion("MSProject", 11)]
		public bool AddSiteColumn(object projectField, object sharePointName)
		{
			return Factory.ExecuteBoolMethodGet(this, "AddSiteColumn", projectField, sharePointName);
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool AddSiteColumn()
		{
			return Factory.ExecuteBoolMethodGet(this, "AddSiteColumn");
		}

		/// <summary>
		/// SupportByVersion MSProject 11
		/// </summary>
		/// <param name="projectField">optional NetOffice.MSProjectApi.Enums.PjField ProjectField = -1</param>
		[CustomMethod]
		[SupportByVersion("MSProject", 11)]
		public bool AddSiteColumn(object projectField)
		{
			return Factory.ExecuteBoolMethodGet(this, "AddSiteColumn", projectField);
		}

		#endregion

		#pragma warning restore
	}
}
